<?php

require_once '../../model/Constants.php';
require_once '../../model/User.php';
require_once '../../model/Cod_promocional.php';
require_once '../../model/Usuario_cod_pro.php';
require_once '../../model/Auth.php';
require_once '../../model/Contact.php';
require_once '../../model/PHP_AES_Cipher.php';
require_once '../../model/Document_legis.php';
require_once '../../model/Articulos.php';
require_once '../../model/Correspondencia.php';
require_once '../../model/Diccionario.php';
require_once '../../model/ContenidoReforma.php';
require_once '../../model/Notas.php';
require_once '../../model/Seminary.php';
require_once '../../model/Book.php';
require_once '../../model/Notifications.php';
require_once '../../model/Search_suggest.php';
require_once '../../model/SubscriptionPremium.php';
require_once '../../model/Book_User.php';
require_once '../../model/OfficialRegister.php';
require_once '../../model/Setting_app.php';

require 'view_api/ViewFormatJson.php';
require 'utils/ExceptionApi.php';
require '../../model/ValidComponent.php';
require '../../model/Valid.php';

header('Content-Type: application/json');
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST,GET, OPTIONS");

$view = new ViewFormatJson();

// Constantes de estado
const INCORRECT_URL_STATUS = 2;
const RESOURCE_EXISTS = 3;
const METHOD_NO_PERMITTED = 4;

set_exception_handler(function ($exception) use ($view) {

    $body = array(
        "status" => $exception->status,
        "message" => $exception->getMessage()
    );

    if ($exception->getCode()) {
        $view->status = $exception->getCode();
    } else {
        $view->status = 500;
    }

    $view->show($body);

});

if (isset($_GET['PATH_INFO'])) {
    $peticion = explode("/", $_GET['PATH_INFO']);
} else {
    throw new ExceptionApi(INCORRECT_URL_STATUS, utf8_encode("No se reconoce la petición"));
}

// Obtener recurso
$recurso = array_shift($peticion);
$recursos_existentes = array('user', 'cod_promocional', 'auth', 'contact', 'document_legis', "articulos", "correspondencia",
    "diccionario", "contenido_reforma", "notas", "notifications", "seminary", "book", "search_suggest", "subscription_premium",
    "book_user", "ro", "setting_app");

// Comprobar si existe el recurso
if (!in_array($recurso, $recursos_existentes)) {
    // Respuesta error
    throw new ExceptionApi(RESOURCE_EXISTS,
        "No se reconoce el recurso al que intentas acceder");
}
$metodo = $_SERVER['REQUEST_METHOD'];
switch ($metodo) {
    case 'GET':
        // Procesar método get
        if ($recurso == "user") {
            $view->show(User::setGetRequest($peticion));
        }
        break;
    case 'POST':
        // Procesar método post
        if ($recurso == "user") {
            $view->show(User::setPostRequest($peticion));
        } else if ($recurso == "auth") {
            $view->show(Auth::setPostRequest($peticion));
        } else if ($recurso == "cod_promocional") {
            $view->show(Cod_promocional::setPostRequest($peticion));
        } else if ($recurso == "contact") {
            $view->show(Contact::setPostRequest($peticion));
        } else if ($recurso == "document_legis") {
            $view->show(Document_legis::setPostRequest($peticion));
        } else if ($recurso == "articulos") {
            $view->show(Articulos::setPostRequest($peticion));
        } else if ($recurso == "correspondencia") {
            $view->show(Correspondencia::setPostRequest($peticion));
        } else if ($recurso == "diccionario") {
            $view->show(Diccionario::setPostRequest($peticion));
        } else if ($recurso == "contenido_reforma") {
            $view->show(ContenidoReforma::setPostRequest($peticion));
        } else if ($recurso == "notas") {
            $view->show(Notas::setPostRequest($peticion));
        } else if ($recurso == "notifications") {
            $view->show(Notifications::setPostRequest($peticion));
        } else if ($recurso == "seminary") {
            $view->show(Seminary::setPostRequest($peticion));
        } else if ($recurso == "book") {
            $view->show(Book::setPostRequest($peticion));
        } else if ($recurso == "search_suggest") {
            $view->show(Search_suggest::setPostRequest($peticion));
        } else if ($recurso == "subscription_premium") {
            $view->show(SubscriptionPremium::setPostRequest($peticion));
        } else if ($recurso == "book_user") {
            $view->show(Book_User::setPostRequest($peticion));
        } else if ($recurso == "ro") {
            $view->show(OfficialRegister::setPostRequest($peticion));
        } else if ($recurso == "setting_app") {
            $view->show(Setting_app::setPostRequest($peticion));
        }
        break;
    case 'PUT':
        // Procesar método put
        break;

    case 'DELETE':
        // Procesar método delete
        break;
    default:
        // Método no aceptado
        throw new ExceptionApi(METHOD_NO_PERMITTED, utf8_encode("Metodo no permitido"), 405);

}
?>