<?php

namespace App\Controllers;
defined("APPPATH") OR die("Access denied");
date_default_timezone_set('America/Guayaquil');

use App\Values\Resources;
use \Core\View;
use \App\Models\Entities\API;
use \App\Models\Entities\Constants;
use \App\Models\Entities\GoCredentials;
use \Core\App;


GoCredentials::verify(false, "/speedycep/admin/access/");

class Application
{

    protected $title = "";
    public $TOKEN = "A80D313B049E3A50E2B4DA77C62B779E0631FC4F8A1B118E99063A7524AB154B";

    public function index()
    {
        try {
            View::render("application");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }

    public function setting_app()
    {
        try {
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/setting_app/get/",
                array(), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);
            View::set("data", $data["data"]);
            View::render("setting_app");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }

    public function change_setting_app()
    {

        if (isset($_POST["seguridad_password"])) {


            $init_admin = parse_ini_file(APPPATH . '/Config/admin.ini');
            $secondPasswordStorage = $init_admin['second_password'];


            if ($secondPasswordStorage == $_POST["seguridad_password"]) {
                $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/setting_app/change/",
                    array(
                        "law_price" => $_POST['law_price'],
                        "law_row_quantity" => $_POST['law_row_quantity'],
                        "domestic_shipping_price" => $_POST['domestic_shipping_price'],
                        "america_shipping_price" => $_POST['america_shipping_price'],
                        "international_shipping_price" => $_POST['international_shipping_price'],
                        "monthly_subscription_price" => $_POST['monthly_subscription_price'],
                        "anual_subscription_price" => $_POST['anual_subscription_price']
                    ), $this->TOKEN);

                //$data = API::JSON_TO_ARRAY($multi_info_api);

                echo $multi_info_api;
            } else {
                echo json_encode([
                    "status" => 2,
                    "message" => "Clave especial incorrecta."
                ]);
            }



        } else {
            echo json_encode([
                "status" => 2,
                "message" => "La clave especial no existe."
            ]);
        }

    }

    public function setting_emails($type)
    {
        try {
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/setting_app/get/",
                array(), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);

            if ($type == "books") {
                View::set("data", $data["data"][0]['emails_for_books']);
                View::set("title", "Correos donde se van a recibir las notificaciones de las compras de libros o leyes.");
            } else if ($type == "seminaries") {
                View::set("data", $data["data"][0]['emails_for_seminaries']);
                View::set("title", "Correos donde se van a recibir las notificaciones de las compras de cursos, talleres o seminarios.");
            } else if ($type == "subscriptions") {
                View::set("data", $data["data"][0]['emails_for_suscriptions']);
                View::set("title", "Correos donde se van a recibir las notificaciones de las compras de suscripciones.");
            }

            View::set("type", $type);
            View::render("setting_emails");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }


    public function change_setting_emails($type)
    {


        if (isset($_POST["seguridad_password"])) {
            $init_admin = parse_ini_file(APPPATH . '/Config/admin.ini');
            $secondPasswordStorage = $init_admin['second_password'];

            if ($secondPasswordStorage == $_POST["seguridad_password"]) {
                $name = "";
                $post_emails = "";
                if ($type == "books") {
                    $name = "change_emails_for_books";
                    $post_emails = "emails_for_books";
                } else if ($type == "seminaries") {
                    $name = "change_emails_for_seminaries";
                    $post_emails = "emails_for_seminaries";
                } else if ($type == "subscriptions") {
                    $name = "change_emails_for_subscriptions";
                    $post_emails = "emails_for_suscriptions";
                }

                if ($name != "") {

                    $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/setting_app/" . $name,
                        array(
                            $post_emails => $_POST["emails"]
                        ), $this->TOKEN);

                    echo $multi_info_api;

                } else {
                    return [
                        "status" => self::FAILED_CREATION,
                        "message" => "Ocurrio un error al intentar antes de almacenar los correos"
                    ];
                }
            } else {
                echo json_encode([
                    "status" => 2,
                    "message" => "Clave especial incorrecta."
                ]);
            }



        } else {
            echo json_encode([
                "status" => 2,
                "message" => "La clave especial no existe."
            ]);
        }


    }

    /*public function change_paypal_account()
    {

        $encryption_key = '5166546A576E5A72';
        require_once(dirname(dirname(dirname(dirname(__FILE__)))) . "/model/PHP_AES_Cipher.php");

        $email = $_POST['email'];
        $fecha_completa = new \DateTime('now');


        $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/paypal_account/get/",
            array(), $this->TOKEN);
        $data = API::JSON_TO_ARRAY($multi_info_api);
        //var_dump($data['data'][0]["id_dex_paypal_account"]);
        $tokens_encrypt = \PHP_AES_Cipher::decrypt($encryption_key, $data['data'][0]["tokens"]);
        $tokens_dencrypt = \PHP_AES_Cipher::decrypt($encryption_key, $tokens_encrypt);
        $compare_email = json_decode($tokens_dencrypt, true)['email'];

        if ($email != $compare_email) {
            $arr = [
                "email" => $email,
                "date_modified" => $fecha_completa->format("Y-m-d H:i:s")
            ];

            $enc1 = \PHP_AES_Cipher::encrypt($encryption_key, json_encode($arr, true));

            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/paypal_account/change/",
                array("tokens" => $enc1), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);

            if ($data['status'] == 1) {

                echo $multi_info_api;

            } else {

                echo json_encode(
                    [
                        "status" => 2,
                        "message" => "Cuenta no modificada."
                    ]
                );

            }
        } else {

            echo json_encode(
                [
                    "status" => 2,
                    "message" => "Debe cambiar el nombre de la cuenta."
                ]
            );

        }


    }

    public function paypal_account()
    {
        $encryption_key = '5166546A576E5A72';
        require_once(dirname(dirname(dirname(dirname(__FILE__)))) . "/model/PHP_AES_Cipher.php");


        $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/paypal_account/get/",
            array(), $this->TOKEN);
        $data = API::JSON_TO_ARRAY($multi_info_api);
        //var_dump($data['data'][0]["id_dex_paypal_account"]);
        $tokens_encrypt = \PHP_AES_Cipher::decrypt($encryption_key, $data['data'][0]["tokens"]);
        $tokens_dencrypt = \PHP_AES_Cipher::decrypt($encryption_key, $tokens_encrypt);
        try {
            View::set("email", json_decode($tokens_dencrypt, true)['email']);
            View::render("paypal_account");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }*/

    public function user()
    {
        try {
            View::render("user");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }

    public function doc_data()
    {
        $config = App::getConfig();
        $_dbHost = $config["host"];
        $_dbUser = $config["user"];
        $_dbPassword = $config["password"];
        $_dbName = $config["database"];

        $sql_details = array(
            'user' => $_dbUser,
            'pass' => $_dbPassword,
            'db' => $_dbName,
            'host' => $_dbHost
        );

        // DB table to use
        $table = 'dex_documentos_legis';

        // Table's primary key
        $primaryKey = 'doc_id';

        $columns = array(
            array('db' => 'doc_id', 'dt' => 0),
            array('db' => 'doc_titulo', 'dt' => 1)
        );

        $users = SSP::simpleDoc($_GET, $sql_details, $table, $primaryKey, $columns);


        //var_dump($users) ;
        header('Content-Type: application/json; charset=utf8');
        echo json_encode($users, JSON_PRETTY_PRINT);
    }

    public function user_data()
    {
        $config = App::getConfig();
        $_dbHost = $config["host"];
        $_dbUser = $config["user"];
        $_dbPassword = $config["password"];
        $_dbName = $config["database"];

        $sql_details = array(
            'user' => $_dbUser,
            'pass' => $_dbPassword,
            'db' => $_dbName,
            'host' => $_dbHost
        );


        // DB table to use
        $table = 'dex_usuario_new';

        // Table's primary key
        $primaryKey = 'id_usuario';

        $columns = array(
            array('db' => 'id_usuario', 'dt' => 0),
            array('db' => 'email_usuario', 'dt' => 1),
            array('db' => 'cedula_usuario', 'dt' => 2),
            array('db' => 'nombre_usuario', 'dt' => 3),
            array('db' => 'apellido_usuario', 'dt' => 4),
            array('db' => 'sexo', 'dt' => 5),
            array('db' => 'direccion_usuario', 'dt' => 6),
            array('db' => 'ciudad_usuario', 'dt' => 7),
            array('db' => 'pais_usuario', 'dt' => 8),
            array('db' => 'celular_usuario', 'dt' => 9),
            array('db' => 'servicio_speedy', 'dt' => 10),
            array('db' => 'fecha_caduca_premium', 'dt' => 11)
        );

        $users = SSP::simple($_GET, $sql_details, $table, $primaryKey, $columns);


        //var_dump($users) ;
        header('Content-Type: application/json; charset=utf8');
        echo json_encode($users, JSON_PRETTY_PRINT);
        //echo count($users["data"]);


    }

    public function basic_norm()
    {
        try {
            View::render("basic_norm");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }

    public function change_norms()
    {
        $dir = "/var/www/html/speedycep/doc/";
        $tmp = "[basic]\ndata = \"{\\\"doc_ids\\\": " . str_replace("\"", "\\\"", $_POST['json']) . "}\"";
        $newFile = fopen($dir . "basic_norm.ini", 'w+');
        fwrite($newFile, $tmp);
        fclose($newFile);

        echo json_encode([
            "status" => 1,
            "message" => "Cambios realizados ..."
        ]);
    }

    public function code_promotional()
    {
        try {
            View::render("codigo_promocional");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }

    public function generate_code_promotional($api_key)
    {
        $api_key = mb_substr($api_key, 4, strlen($api_key));
        $res = crypt($this->TOKEN, "lCp4K90") == $api_key;
        if ($res) {
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/cod_promocional/generate/", array(), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);
            echo $data['data'];
        }
    }

    public function manipulate_multiple_code_promotional()
    {
        if (isset($_POST['count_code_promotional'])) {
            $count_codes = $_POST['count_code_promotional'];
            $duracion_codes = $_POST['duracion_codes'];
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/cod_promocional/register_multiple_todo_code/",
                array("count_codes" => $count_codes, "duracion_codes" => $duracion_codes), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);
            if ($data['status'] == 1) {
                echo json_encode($data);
            } else {
                echo $data['message'];
            }
        }
    }

    public function manipulate_code_promotional()
    {
        if (isset($_POST['duration']) && isset($_POST['code'])) {
            $duration = $_POST['duration'];
            $code = $_POST['code'];
            if ($code != "") {
                if ($duration == 30 || $duration == 90 || $duration == 365) {
                    $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/cod_promocional/verify/",
                        array("auto_code" => $code), $this->TOKEN);
                    $data = API::JSON_TO_ARRAY($multi_info_api);
                    if ($data['status'] == 1) {
                        $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/cod_promocional/register_todo_code/",
                            array("code" => $code, "duration" => $duration, "date" => date("Y-m-d")), $this->TOKEN);
                        $data = API::JSON_TO_ARRAY($multi_info_api);
                        if ($data['status'] == 1) {
                            echo json_encode($data);
                        } else {
                            echo $data['message'];
                        }

                    } else {
                        echo $data['message'];
                    }
                } else {
                    echo "La duración no está correctamente especificada.";
                }
            } else {
                echo "No pueden quedar campos en blanco.";
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }


    public function edit_code_promotional()
    {
        if (isset($_POST['duration']) && isset($_POST['code'])) {
            $duration = $_POST['duration'];
            $code = $_POST['code'];
            if ($code != "") {
                if ($duration == 30 || $duration == 90 || $duration == 365) {
                    $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/cod_promocional/edit_todo_code/",
                        array("code" => $code, "duration" => $duration), $this->TOKEN);
                    $data = API::JSON_TO_ARRAY($multi_info_api);
                    if ($data['status'] == 1) {
                        echo json_encode($data);
                    } else {
                        echo $data['message'];
                    }
                } else {
                    echo "La duración no está correctamente especificada.";
                }

            } else {
                echo "No pueden quedar campos en blanco.";
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }

    public function delete_code_promotional()
    {
        if (isset($_POST['code'])) {
            $code = $_POST['code'];
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/cod_promocional/delete_todo_code/",
                array("code" => $code), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);
            if ($data['status'] == 1) {
                echo json_encode($data);
            } else {
                echo $data['message'];
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }

    public function cod_promotional_data()
    {
        $config = App::getConfig();
        $_dbHost = $config["host"];
        $_dbUser = $config["user"];
        $_dbPassword = $config["password"];
        $_dbName = $config["database"];

        $sql_details = array(
            'user' => $_dbUser,
            'pass' => $_dbPassword,
            'db' => $_dbName,
            'host' => $_dbHost
        );


        // DB table to use
        $table = 'dex_cod_promocional';

        // Table's primary key
        $primaryKey = 'id_dex_cod_promocional';

        $columns = array(
            array('db' => 'id_dex_cod_promocional', 'dt' => 0),
            array('db' => 'codigo', 'dt' => 1),
            array('db' => 'duracion', 'dt' => 2),
            array('db' => 'fecha_inicial', 'dt' => 3),
            array('db' => 'fecha_expiracion', 'dt' => 4),
            array('db' => 'tipo_promocional', 'dt' => 5),
            array('db' => 'estado', 'dt' => 6),
            array('db' => 'email_assoc', 'dt' => 7),
            array('db' => 'email_creador', 'dt' => 8)
        );

        $codigos_promocionales = SSP::simpleCodPromotional($_GET, $sql_details, $table, $primaryKey, $columns);


        //var_dump($codigos_promocionales) ;
        header('Content-Type: application/json; charset=utf8');
        echo json_encode($codigos_promocionales, JSON_PRETTY_PRINT);
        //echo count($codigos_promocionales["data"]);


    }


    public function seminary()
    {
        try {
            View::render("taller_seminario");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }


    public function manipulate_seminary()
    {
        if (isset($_POST['tipo_taller_sem']) && isset($_POST['titulo_taller_sem']) && isset($_POST['lugar']) && isset($_POST['fecha_desde'])
            && isset($_POST['fecha_hasta']) && isset($_POST['horario']) && isset($_POST['inversion']) && isset($_POST['telefono'])
            && isset($_POST['extra'])) {

            $tipo_taller_sem = $_POST['tipo_taller_sem'];
            $titulo_taller_sem = $_POST['titulo_taller_sem'];
            $lugar = $_POST['lugar'];
            $fecha_desde = $_POST['fecha_desde'];
            $fecha_hasta = $_POST['fecha_hasta'];
            $horario = $_POST['horario'];
            $inversion = $_POST['inversion'];
            $telefono = $_POST['telefono'];
            $extra = $_POST['extra'];

            if ($tipo_taller_sem != "" && $titulo_taller_sem != "") {

                $autoID = md5(uniqid());
                $uploadPortada = $this->uploadFile("file_portada",
                    "/var/www/html/speedycep/admin/public/img/seminary/",
                    "/speedycep/admin/img/seminary/",
                    array("image/png", "image/jpg", "image/jpeg"),
                    md5($autoID));

                if ($uploadPortada['status'] == 1) {
                    $portada_path = $uploadPortada['message'];

                    $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/seminary/register_todo_code/",
                        array("tipo_taller_sem" => $tipo_taller_sem, "titulo_taller_sem" => $titulo_taller_sem,
                            "lugar" => $lugar,
                            "fecha_desde" => $fecha_desde, "fecha_hasta" => $fecha_hasta, "horario" => $horario,
                            "inversion" => $inversion, "telefono" => $telefono, "extra" => $extra,
                            "portada_path" => $portada_path), $this->TOKEN);
                    $data = API::JSON_TO_ARRAY($multi_info_api);
                    if ($data['status'] == 1) {
                        echo json_encode($data);
                    } else {
                        echo $data['message'];
                    }

                } else {
                    http_response_code(400);
                    echo json_encode([
                        "status" => 2,
                        "message" => "No se pudo subir la portada."
                    ]);
                }

            } else {
                http_response_code(400);
                echo json_encode([
                    "status" => 2,
                    "message" => "No pueden quedar campos en blanco."
                ]);
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }


    public function edit_seminary()
    {
        if (isset($_POST['id']) && isset($_POST['tipo_taller_sem']) && isset($_POST['lugar']) && isset($_POST['titulo_taller_sem']) && isset($_POST['fecha_desde'])
            && isset($_POST['fecha_hasta']) && isset($_POST['horario']) && isset($_POST['inversion']) && isset($_POST['telefono'])
            && isset($_POST['extra'])) {


            $id = $_POST['id'];
            $tipo_taller_sem = $_POST['tipo_taller_sem'];
            $titulo_taller_sem = $_POST['titulo_taller_sem'];
            $lugar = $_POST['lugar'];
            $fecha_desde = $_POST['fecha_desde'];
            $fecha_hasta = $_POST['fecha_hasta'];
            $horario = $_POST['horario'];
            $inversion = $_POST['inversion'];
            $telefono = $_POST['telefono'];
            $extra = $_POST['extra'];

            if ($tipo_taller_sem != "" && $titulo_taller_sem != "") {

                $get_info_api_seminary = API::POST_SERVER(Constants::PATH_API() . "/seminary/get_seminary_post_by_code/",
                    array("id_taller_sem" => $id), $this->TOKEN);

                if (is_array($_FILES["file_portada"])) {
                    $dataBook = API::JSON_TO_ARRAY($get_info_api_seminary);
                    $fileName = explode(".", basename($dataBook['data']['ruta_portada']))[0];
                    $uploadPortada = $this->uploadFile("file_portada",
                        "/var/www/html/speedycep/admin/public/img/seminary/",
                        "/speedycep/admin/img/seminary/",
                        array("image/png", "image/jpg", "image/jpeg"),
                        $fileName);

                    if ($uploadPortada["status"] == 1) {
                        $ruta_portada = $uploadPortada['message'];
                        API::POST_SERVER(Constants::PATH_API() . "/seminary/update_portada/",
                            array("id" => $id, "portada_path" => $ruta_portada), $this->TOKEN);
                    }

                }

                $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/seminary/edit_todo_code/",
                    array("id" => $id, "tipo_taller_sem" => $tipo_taller_sem, "titulo_taller_sem" => $titulo_taller_sem,
                        "lugar" => $lugar,
                        "fecha_desde" => $fecha_desde, "fecha_hasta" => $fecha_hasta, "horario" => $horario,
                        "inversion" => $inversion, "telefono" => $telefono, "extra" => $extra), $this->TOKEN);
                $data = API::JSON_TO_ARRAY($multi_info_api);

                if ($data['status'] == 1) {
                    echo json_encode($data);
                } else {
                    echo $data['message'];
                }

            } else {
                http_response_code(400);
                echo json_encode([
                    "status" => 2,
                    "message" => "No pueden quedar campos en blanco."
                ]);
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }

    public function delete_seminary()
    {
        if (isset($_POST['id'])) {
            $code = $_POST['id'];
            $info_hasRegisters = API::POST_SERVER(Constants::PATH_API() . "/seminary/get_by_users/",
                array("id" => $code), $this->TOKEN);
            $dataHas = API::JSON_TO_ARRAY($info_hasRegisters);
            if ($dataHas['status'] == 2) {
                $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/seminary/delete_todo_code/",
                    array("id" => $code), $this->TOKEN);
                $data = API::JSON_TO_ARRAY($multi_info_api);
                if ($data['status'] == 1) {
                    echo json_encode($data);
                } else {
                    echo $data['message'];
                }
            } else {
                echo "No puedes eliminar porque hay usuarios asociados.";
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }

    public function change_port_seminary()
    {
        if ($_FILES) {
            $id = $_POST['id'];
            $ext = pathinfo($_FILES["file"]["name"], PATHINFO_EXTENSION);
            $target_dir = "/speedycep/admin/public/img/seminary/" . $id . "." . $ext;
            $to_target_dir_sql = "/speedycep/admin/img/seminary/" . $id . "." . $ext;
            $target_file = $_SERVER[DOCUMENT_ROOT] . $target_dir;

            $finfo = new \finfo(FILEINFO_MIME_TYPE);
            $fileContents = file_get_contents($_FILES["file"]["tmp_name"]);
            $mimeType = $finfo->buffer($fileContents);

            if ($mimeType == "image/png" || $mimeType == "image/jpg" || $mimeType == "image/jpeg") {
                if (move_uploaded_file($_FILES["file"]["tmp_name"], $target_file)) {
                    //enlazar al nuevo archivo.
                    //guardar ruta completa.
                    $picture_url = $to_target_dir_sql;
                    $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/seminary/update_portada/",
                        array("id" => $id, "portada_path" => $picture_url), $this->TOKEN);
                    $data = API::JSON_TO_ARRAY($multi_info_api);
                    if ($data['status'] == 1) {
                        echo json_encode($data);
                    } else {
                        echo $data['message'];
                    }

                } else {
                    http_response_code(500);
                    echo json_encode([
                        'status' => 7,
                        'message' => "Error al cargar el archivo: " . basename(__DIR__)
                    ]);
                }

            } else {
                http_response_code(422);
                echo json_encode([
                    'status' => 7,
                    'message' => "Error al intentar cargar el archivo"
                ]);
            }

        }
    }

    public function load_users_seminary()
    {
        if (isset($_POST['id'])) {
            $code = $_POST['id'];
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/seminary/get_by_users/",
                array("id" => $code), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);
            if ($data['status'] == 1) {
                echo json_encode($data);
            } else {
                echo $data['message'];
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }

    public function not_publish_seminary()
    {

        if (isset($_POST['id'])) {
            $code = $_POST['id'];
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/seminary/publish_todo_code/",
                array("id" => $code), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);
            if ($data['status'] == 1) {
                echo json_encode($data);
            } else {
                echo $data['message'];
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }

    public function remove_publish_seminary()
    {

        if (isset($_POST['id'])) {
            $code = $_POST['id'];
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/seminary/unpublish_todo_code/",
                array("id" => $code), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);
            if ($data['status'] == 1) {
                echo json_encode($data);
            } else {
                echo $data['message'];
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }

    public function book()
    {
        try {
            View::render("libro");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }

    /*public function verify_write()
    {
        $dir = "/var/www/html/speedycep/doc/";
        if (is_writable($dir)) {
            echo "the folder: " . $dir . " is writable";
        } else {
            echo ('sorry the web server does not have permission to write to ' . $dir." <br/><br/>");
            echo substr(sprintf('%o', fileperms($dir)), -4);
        }
    }

    public function upload_test()
    {
        try {
            echo '
                <form name="form" method="post" action="/speedycep/admin/application/finish_upload/" enctype="multipart/form-data" >
                <input type="file" name="my_file" /><br /><br />
                <input type="submit" name="submit" value="Upload"/>
                </form>
            ';
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }
*/
    /* public function finish_upload()
     {
         try {

             $target_dir = "/var/www/html/speedycep/doc/";
             if (($_FILES['my_file']['name'] != "")) {
                 // Where the file is going to be stored
                 $file = $_FILES['my_file']['name'];
                 $path = pathinfo($file);
                 $filename = $path['filename'];
                 $ext = $path['extension'];
                 $temp_name = $_FILES['my_file']['tmp_name'];
                 $path_filename_ext = $target_dir . $filename . "." . $ext;

                 if (move_uploaded_file($temp_name, $path_filename_ext)) {
                     echo "Congratulations! File Uploaded Successfully.";
                 } else {
                     echo "File not upload. has error: " . $path_filename_ext;
                 }
             } else {
                 echo "File not found." . $target_dir;
             }
         } catch (\Exception $e) {
             echo "Ocurrio una excepción al intentar acceder a (access)";
         }
     }*/

    public function uploadFile($fileNamePost, $dir, $dir_sql, $arrMimeType, $id)
    {
        $ext = pathinfo($_FILES[$fileNamePost]["name"], PATHINFO_EXTENSION);
        $target_dir = $dir . $id . "." . $ext;
        $to_target_dir_sql = $dir_sql . $id . "." . $ext;
        $target_file = $target_dir;

        $finfo = new \finfo(FILEINFO_MIME_TYPE);
        $fileContents = file_get_contents($_FILES[$fileNamePost]["tmp_name"]);
        $mimeType = $finfo->buffer($fileContents);

        $flag = false;
        foreach ($arrMimeType as $type) {
            if ($mimeType == $type) {
                $flag = true;
                break;
            }
        }

        if ($flag) {
            if (move_uploaded_file($_FILES[$fileNamePost]["tmp_name"], $target_file)) {
                return [
                    'status' => 1,
                    "message" => $to_target_dir_sql
                ];
            } else {
                return json_encode([
                    'status' => 7,
                    'message' => "Error al cargar el archivo"
                ]);
            }
        } else {
            return json_encode([
                'status' => 7,
                'message' => "Error al intentar cargar el archivo formato desconocido"
            ]);
        }


    }

    public function manipulate_book()
    {
        if (isset($_POST['titulo_libro']) && isset($_POST['resumen']) && isset($_POST['autor']) && isset($_POST['edicion'])
            && isset($_POST['editorial']) && isset($_POST['annio_edicion']) && isset($_POST['precio_fisico']) && isset($_POST['precio_ebook'])
            && isset($_POST['existencia_fisica']) && isset($_POST['existencia_ebook'])) {

            $titulo_libro = $_POST['titulo_libro'];
            $resumen = $_POST['resumen'];
            $autor = $_POST['autor'];
            $edicion = $_POST['edicion'];
            $editorial = $_POST['editorial'];
            $annio_edicion = $_POST['annio_edicion'];
            $precio_fisico = $_POST['precio_fisico'];
            $precio_ebook = $_POST['precio_ebook'];
            $existencia_fisica = $_POST['existencia_fisica'];
            $existencia_ebook = $_POST['existencia_ebook'];

            if ($titulo_libro != "" && $resumen != "" && $autor != "" && $edicion != "" && $editorial != ""
                && $annio_edicion != "" && $precio_fisico != "" && $precio_ebook != "" && $existencia_fisica != ""
                && $existencia_ebook != "") {
                //$regData = $data['data'];
                $autoID = md5(uniqid());
                $uploadPortada = $this->uploadFile("file_portada",
                    "/var/www/html/speedycep/admin/public/img/book/",
                    "/speedycep/admin/img/book/",
                    array("image/png", "image/jpg", "image/jpeg"),
                    md5($autoID));
                $uploadEpub = $this->uploadFile("file_epub",
                    "/var/www/html/speedycep/doc/",
                    "/speedycep/doc/",
                    array("application/epub+zip"),
                    md5($autoID));

                if ($uploadPortada['status'] == 1 && $uploadEpub['status'] == 1) {
                    $ruta_portada = $uploadPortada['message'];
                    $ruta_enlace = $uploadEpub['message'];

                    $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/book/register_todo_code/",
                        array("titulo_libro" => $titulo_libro, "resumen" => $resumen, "autor" => $autor,
                            "edicion" => $edicion, "editorial" => $editorial, "annio_edicion" => $annio_edicion,
                            "precio_fisico" => $precio_fisico, "precio_ebook" => $precio_ebook,
                            "existencia_fisica" => $existencia_fisica, "existencia_ebook" => $existencia_ebook,
                            "ruta_portada" => $ruta_portada, "ruta_enlace" => $ruta_enlace), $this->TOKEN);

                    $data = API::JSON_TO_ARRAY($multi_info_api);
                    if ($data['status'] == 1) {
                        echo json_encode($data);
                    } else {
                        echo $data['message'];
                    }
                    /*echo json_encode([
                        "status" => 1,
                        "message" => "Datos registrados ..."
                    ]);*/
                } else {
                    http_response_code(400);
                    echo json_encode([
                        "status" => 2,
                        "message" => "No se subieron los archivos."
                    ]);
                }

            } else {
                http_response_code(400);
                echo json_encode([
                    "status" => 2,
                    "message" => "No pueden quedar campos en blanco."
                ]);
            }

        } else {
            echo "No se pudo realizar la operación.";
        }

    }

    public function edit_book()
    {
        if (isset($_POST['titulo_libro']) && isset($_POST['resumen']) && isset($_POST['autor']) && isset($_POST['edicion'])
            && isset($_POST['editorial']) && isset($_POST['annio_edicion']) && isset($_POST['precio_fisico']) && isset($_POST['precio_ebook'])
            && isset($_POST['existencia_fisica']) && isset($_POST['existencia_ebook'])) {

            $id = $_POST['id'];
            $titulo_libro = $_POST['titulo_libro'];
            $resumen = $_POST['resumen'];
            $autor = $_POST['autor'];
            $edicion = $_POST['edicion'];
            $editorial = $_POST['editorial'];
            $annio_edicion = $_POST['annio_edicion'];
            $precio_fisico = $_POST['precio_fisico'];
            $precio_ebook = $_POST['precio_ebook'];
            $existencia_fisica = $_POST['existencia_fisica'];
            $existencia_ebook = $_POST['existencia_ebook'];

            if ($titulo_libro != "" && $resumen != "" && $autor != "" && $edicion != "" && $editorial != ""
                && $annio_edicion != "" && $precio_fisico != "" && $precio_ebook != "" && $existencia_fisica != ""
                && $existencia_ebook != "") {

                $get_info_api_book = API::POST_SERVER(Constants::PATH_API() . "/book/get_book_post_by_code/",
                    array("id_libro_premium" => $id), $this->TOKEN);

                if (is_array($_FILES["file_portada"])) {
                    $dataBook = API::JSON_TO_ARRAY($get_info_api_book);
                    $fileName = explode(".", basename($dataBook['data']['ruta_portada']))[0];
                    $uploadPortada = $this->uploadFile("file_portada",
                        "/var/www/html/speedycep/admin/public/img/book/",
                        "/speedycep/admin/img/book/",
                        array("image/png", "image/jpg", "image/jpeg"),
                        $fileName);

                    if ($uploadPortada["status"] == 1) {
                        $ruta_portada = $uploadPortada['message'];
                        API::POST_SERVER(Constants::PATH_API() . "/book/update_portada/",
                            array("id_libro_premium" => $id, "ruta_portada" => $ruta_portada), $this->TOKEN);
                    }

                }


                if (is_array($_FILES["file_epub"])) {
                    $dataBook = API::JSON_TO_ARRAY($get_info_api_book);
                    $fileName = explode(".", basename($dataBook['data']['ruta_enlace']))[0];
                    $uploadEpub = $this->uploadFile("file_epub",
                        "/var/www/html/speedycep/doc/",
                        "/speedycep/doc/",
                        array("application/epub+zip"),
                        $fileName);
                }

                $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/book/edit_todo_code/",
                    array("id" => $id, "titulo_libro" => $titulo_libro, "resumen" => $resumen, "autor" => $autor,
                        "edicion" => $edicion, "editorial" => $editorial, "annio_edicion" => $annio_edicion,
                        "precio_fisico" => $precio_fisico, "precio_ebook" => $precio_ebook,
                        "existencia_fisica" => $existencia_fisica, "existencia_ebook" => $existencia_ebook), $this->TOKEN);

                $data = API::JSON_TO_ARRAY($multi_info_api);
                if ($data['status'] == 1) {
                    echo json_encode($data);
                } else {
                    echo $data['message'];
                }


            } else {
                echo "No pueden quedar campos en blanco.";
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }

    public function delete_book()
    {
        if (isset($_POST['id'])) {
            $code = $_POST['id'];
            $info_hasRegisters = API::POST_SERVER(Constants::PATH_API() . "/book/get_buyer/",
                array("id" => $code), $this->TOKEN);
            $dataHas = API::JSON_TO_ARRAY($info_hasRegisters);
            if ($dataHas['status'] == 2) {
                $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/book/delete_todo_code/",
                    array("id" => $code), $this->TOKEN);
                $data = API::JSON_TO_ARRAY($multi_info_api);
                if ($data['status'] == 1) {
                    echo json_encode($data);
                } else {
                    echo $data['message'];
                }
            } else {
                echo "No puedes eliminar porque hay usuarios asociados.";
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }


    public function not_publish_book()
    {

        if (isset($_POST['id'])) {
            $code = $_POST['id'];
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/book/publish_todo_code/",
                array("id" => $code), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);
            if ($data['status'] == 1) {
                echo json_encode($data);
            } else {
                echo $data['message'];
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }

    public function remove_publish_book()
    {

        if (isset($_POST['id'])) {
            $code = $_POST['id'];
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/book/unpublish_todo_code/",
                array("id" => $code), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);
            if ($data['status'] == 1) {
                echo json_encode($data);
            } else {
                echo $data['message'];
            }
        } else {
            echo "No se pudo realizar la operación.";
        }
    }

    public function buyer_users_book($id)
    {
        try {
            View::set("id", $id);
            View::render("libro_user_buyer");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }

    }

    public function buyer_details_book($id, $id_ant)
    {
        try {
            View::set("id", $id);
            View::set("id_ant", $id_ant);
            View::render("libro_user_details");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }

    public function update_details_user_book()
    {

        if (isset($_POST['id'])) {
            $code = $_POST['id'];
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/book/update_detail_user_book/",
                array("id" => $code, "estado_envio" => $_POST['estado_envio'], "observacion" => $_POST['observacion']), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);
            if ($data['status'] == 1) {
                echo json_encode($data);
            } else {
                echo $data['message'];
            }
        } else {
            echo "No se pudo realizar la operación.";
        }

    }


    public function doc_users_book()
    {
        try {
            View::render("doclegis_user_buyer");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }

    }

    public function doc_details_book($id)
    {
        try {
            View::set("id", $id);
            View::render("doc_user_details");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }


    public function update_details_user_doc()
    {

        if (isset($_POST['id'])) {
            $code = $_POST['id'];
            $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/document_legis/update_detail_user_doc/",
                array("id" => $code, "estado_envio" => $_POST['estado_envio'], "observacion" => $_POST['observacion']), $this->TOKEN);
            $data = API::JSON_TO_ARRAY($multi_info_api);
            if ($data['status'] == 1) {
                echo json_encode($data);
            } else {
                echo $data['message'];
            }
        } else {
            echo "No se pudo realizar la operación.";
        }

    }

    function encrypt($data)
    {

        return crypt($data, 'lCp4K90');

    }

    function validateDate($date, $format = 'Y-m-d')
    {
        $d = \DateTime::createFromFormat($format, $date);
        // The Y ( 4 digits year ) returns TRUE for any integer with any number of digits so changing the comparison from == to === fixes the issue.
        return $d && $d->format($format) === $date;
    }


    public function doc_user_buyer_data()
    {
        $config = App::getConfig();
        $_dbHost = $config["host"];
        $_dbUser = $config["user"];
        $_dbPassword = $config["password"];
        $_dbName = $config["database"];

        $sql_details = array(
            'user' => $_dbUser,
            'pass' => $_dbPassword,
            'db' => $_dbName,
            'host' => $_dbHost
        );


        // DB table to use
        $tables = '`dex_usuario_doclegis_comprado`, `dex_documentos_legis`';

        // Table's primary key
        $primaryKey = 'id_dex_usuario_doclegis_comprado';

        $columns = array(
            array('db' => 'id_dex_usuario_doclegis_comprado', 'dt' => 0),
            array('db' => 'id_usuario', 'dt' => 1),
            array('db' => 'email_envio', 'dt' => 2),
            array('db' => 'nombres_envio', 'dt' => 3),
            array('db' => 'apellidos_envio', 'dt' => 4),
            array('db' => 'doc_titulo', 'dt' => 5),
            array('db' => 'tipo_pago', 'dt' => 6),
            array('db' => 'fecha_compra', 'dt' => 7),
            array('db' => 'numero_referencia', 'dt' => 8),
            array('db' => 'precio_compra', 'dt' => 9)
        );

        $users = SSP::simpleBuyerLaw($_GET, $sql_details, $tables, $primaryKey, $columns);


        //var_dump($users) ;
        header('Content-Type: application/json; charset=utf8');
        echo json_encode($users, JSON_PRETTY_PRINT);
        //echo count($users["data"]);
    }


    public function view_buyer_premium_book()
    {
        try {
            View::render("view_buyer_premium_book");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }

    }


    public function view_buyer_premium_book_data()
    {
        $config = App::getConfig();
        $_dbHost = $config["host"];
        $_dbUser = $config["user"];
        $_dbPassword = $config["password"];
        $_dbName = $config["database"];

        $sql_details = array(
            'user' => $_dbUser,
            'pass' => $_dbPassword,
            'db' => $_dbName,
            'host' => $_dbHost
        );


        // DB table to use
        $tables = '`dex_usuario_libro_comprador`, `dex_libro_premium_speedy`';

        // Table's primary key
        $primaryKey = 'id_usuario_comprador';

        $columns = array(
            array('db' => 'id_usuario_comprador', 'dt' => 0),
            array('db' => 'id_usuario', 'dt' => 1),
            array('db' => 'email_envio', 'dt' => 2),
            array('db' => 'nombres_envio', 'dt' => 3),
            array('db' => 'apellidos_envio', 'dt' => 4),
            array('db' => 'titulo_libro', 'dt' => 5),
            array('db' => 'edicion', 'dt' => 6),
            array('db' => 'annio_edicion', 'dt' => 7),
            array('db' => 'tipo_pago', 'dt' => 8),
            array('db' => 'fecha_compra', 'dt' => 9),
            array('db' => 'numero_referencia', 'dt' => 10),
            array('db' => 'precio_compra', 'dt' => 11)
        );

        $users = SSP::simpleBuyerBook($_GET, $sql_details, $tables, $primaryKey, $columns);


        //var_dump($users) ;
        header('Content-Type: application/json; charset=utf8');
        echo json_encode($users, JSON_PRETTY_PRINT);
        //echo count($users["data"]);
    }

    public function view_buyer_premium_book_details($id)
    {
        try {
            View::set("id", $id);
            View::render("view_buyer_premium_book_details");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }


    public function view_buyer_premium_ebook()
    {
        try {
            View::render("view_buyer_premium_ebook");
        } catch (\Exception $e) {
            echo "Ocurrio una excepción al intentar acceder a (access)";
        }
    }


    public function view_buyer_premium_ebook_data()
    {
        $config = App::getConfig();
        $_dbHost = $config["host"];
        $_dbUser = $config["user"];
        $_dbPassword = $config["password"];
        $_dbName = $config["database"];

        $sql_details = array(
            'user' => $_dbUser,
            'pass' => $_dbPassword,
            'db' => $_dbName,
            'host' => $_dbHost
        );


        // DB table to use
        $tables = '`dex_usuario_libro_comprador`, `dex_libro_premium_speedy`';

        // Table's primary key
        $primaryKey = 'id_usuario_comprador';

        $columns = array(
            array('db' => 'id_usuario_comprador', 'dt' => 0),
            array('db' => 'id_usuario', 'dt' => 1),
            array('db' => 'email_envio', 'dt' => 2),
            array('db' => 'nombres_envio', 'dt' => 3),
            array('db' => 'apellidos_envio', 'dt' => 4),
            array('db' => 'titulo_libro', 'dt' => 5),
            array('db' => 'edicion', 'dt' => 6),
            array('db' => 'annio_edicion', 'dt' => 7),
            array('db' => 'tipo_pago', 'dt' => 8),
            array('db' => 'fecha_compra', 'dt' => 9),
            array('db' => 'numero_referencia', 'dt' => 10),
            array('db' => 'precio_compra', 'dt' => 11)
        );

        $users = SSP::simpleBuyerEBook($_GET, $sql_details, $tables, $primaryKey, $columns);


        //var_dump($users) ;
        header('Content-Type: application/json; charset=utf8');
        echo json_encode($users, JSON_PRETTY_PRINT);
        //echo count($users["data"]);
    }


}


class SSP
{
    /**
     * Create the data output array for the DataTables rows
     *
     * @param array $columns Column information array
     * @param array $data Data from the SQL get
     * @return array          Formatted data in a row based format
     */
    static function data_output($columns, $data)
    {
        $out = array();
        for ($i = 0, $ien = count($data); $i < $ien; $i++) {
            $row = array();
            for ($j = 0, $jen = count($columns); $j < $jen; $j++) {
                $column = $columns[$j];
                // Is there a formatter?
                if (isset($column['formatter'])) {
                    $row[$column['dt']] = $column['formatter']($data[$i][$column['db']], $data[$i]);
                } else {
                    $row[$column['dt']] = $data[$i][$columns[$j]['db']];
                }
            }
            $out[] = $row;
        }
        return $out;
    }

    /**
     * Database connection
     *
     * Obtain an PHP PDO connection from a connection details array
     *
     * @param array $conn SQL connection details. The array should have
     *    the following properties
     *     * host - host name
     *     * db   - database name
     *     * user - user name
     *     * pass - user password
     * @return array|\PDO
     */
    static function db($conn)
    {
        if (is_array($conn)) {
            return self::sql_connect($conn);
        }
        return $conn;
    }

    /**
     * Paging
     *
     * Construct the LIMIT clause for server-side processing SQL query
     *
     * @param array $request Data sent to server by DataTables
     * @param array $columns Column information array
     * @return string SQL limit clause
     */
    static function limit($request, $columns)
    {
        $limit = "";
        if (isset($request['start']) && $request['length'] != -1) {
            $limit = "LIMIT " . intval($request['start']) . ", " . intval($request['length']);
        }
        return $limit;
    }

    /**
     * Ordering
     *
     * Construct the ORDER BY clause for server-side processing SQL query
     *
     * @param array $request Data sent to server by DataTables
     * @param array $columns Column information array
     * @return string SQL order by clause
     */
    static function order($request, $columns)
    {
        $order = '';
        if (isset($request['order']) && count($request['order'])) {
            $orderBy = array();
            $dtColumns = self::pluck($columns, 'dt');
            for ($i = 0, $ien = count($request['order']); $i < $ien; $i++) {
                // Convert the column index into the column data property
                $columnIdx = intval($request['order'][$i]['column']);
                $requestColumn = $request['columns'][$columnIdx];
                $columnIdx = array_search($requestColumn['data'], $dtColumns);
                $column = $columns[$columnIdx];
                if ($requestColumn['orderable'] == 'true') {
                    $dir = $request['order'][$i]['dir'] === 'asc' ?
                        'ASC' :
                        'DESC';
                    $orderBy[] = '`' . $column['db'] . '` ' . $dir;
                }
            }
            if (count($orderBy)) {
                $order = 'ORDER BY ' . implode(', ', $orderBy);
            }
        }
        return $order;
    }

    /**
     * Searching / Filtering
     *
     * Construct the WHERE clause for server-side processing SQL query.
     *
     * NOTE this does not match the built-in DataTables filtering which does it
     * word by word on any field. It's possible to do here performance on large
     * databases would be very poor
     *
     * @param array $request Data sent to server by DataTables
     * @param array $columns Column information array
     * @param array $bindings Array of values for PDO bindings, used in the
     *    sql_exec() function
     * @return string SQL where clause
     */
    static function filter($request, $columns, &$bindings)
    {
        $globalSearch = array();
        $columnSearch = array();
        $dtColumns = self::pluck($columns, 'dt');

        if (isset($request['search']) && $request['search']['value'] != '') {
            $str = $request['search']['value'];

            for ($i = 0, $ien = count($request['columns']); $i < $ien; $i++) {
                $requestColumn = $request['columns'][$i];
                $columnIdx = array_search($requestColumn['data'], $dtColumns);
                $column = $columns[$columnIdx];

                if ($requestColumn['searchable'] == 'true') {
                    $binding = self::bind($bindings, '%' . $str . '%', PDO::PARAM_STR);
                    $globalSearch[] = "`" . $column['db'] . "` LIKE " . $binding;
                }
            }
        }

        // Individual column filtering
        if (isset($request['columns'])) {
            for ($i = 0, $ien = count($request['columns']); $i < $ien; $i++) {
                $requestColumn = $request['columns'][$i];
                $columnIdx = array_search($requestColumn['data'], $dtColumns);
                $column = $columns[$columnIdx];

                $str = $requestColumn['search']['value'];

                if ($requestColumn['searchable'] == 'true' &&
                    $str != '') {
                    $binding = self::bind($bindings, '%' . $str . '%', PDO::PARAM_STR);
                    $columnSearch[] = "`" . $column['db'] . "` LIKE " . $binding;
                }
            }
        }

        // Combine the filters into a single string
        $where = '';

        if (count($globalSearch)) {
            $where = '(' . implode(' OR ', $globalSearch) . ')';
        }

        if (count($columnSearch)) {
            $where = $where === '' ?
                implode(' AND ', $columnSearch) :
                $where . ' AND ' . implode(' AND ', $columnSearch);
        }

        if ($where !== '') {
            $where = 'WHERE ' . $where;
        }

        return $where;
    }

    static function filterDoc($value)
    {


        $columns_search = array('`doc_id`', '`doc_titulo`');


        $createSearchQuery = "";
        $k = 0;
        foreach ($columns_search as $row) {
            $temp = $row . " LIKE '%" . $value . "%' ";
            if ($k != 0) {
                $temp = "OR " . $row . " LIKE '%" . $value . "%' ";
            }

            $createSearchQuery = $createSearchQuery . $temp;
            $k++;
        }

        return " WHERE " . $createSearchQuery;

    }

    static function filterUser($value)
    {


        $columns_search = array('`email_usuario`', '`cedula_usuario`', '`nombre_usuario`', '`apellido_usuario`', '`sexo`', '`direccion_usuario`',
            '`ciudad_usuario`', '`pais_usuario`', '`celular_usuario`', '`servicio_speedy`', '`fecha_caduca_premium`');


        $createSearchQuery = "";
        $k = 0;
        foreach ($columns_search as $row) {
            $temp = $row . " LIKE '%" . $value . "%' ";
            if ($k != 0) {
                $temp = "OR " . $row . " LIKE '%" . $value . "%' ";
            }

            $createSearchQuery = $createSearchQuery . $temp;
            $k++;
        }

        return " WHERE " . $createSearchQuery;

    }

    static function filterCodPromotional($value)
    {


        $columns_search = array('`codigo`', '`duracion`', '`fecha_inicial`', '`estado`');


        $createSearchQuery = "";
        $k = 0;
        foreach ($columns_search as $row) {
            $temp = $row . " LIKE '%" . $value . "%' ";
            if ($k != 0) {
                $temp = "OR " . $row . " LIKE '%" . $value . "%' ";
            }

            $createSearchQuery = $createSearchQuery . $temp;
            $k++;
        }

        return " WHERE " . $createSearchQuery;

    }

    static function filterBuyerEBook($value)
    {


        $columns_search = array('`id_usuario_comprador`', '`id_usuario`',
            '`email_envio`', '`nombres_envio`', '`apellidos_envio`', '`titulo_libro`', '`edicion`', '`annio_edicion`',
            '`tipo_pago`', '`fecha_compra`', '`numero_referencia`', '`precio_compra`');


        $createSearchQuery = "";
        $k = 0;
        foreach ($columns_search as $row) {
            $temp = $row . " LIKE '%" . $value . "%' ";
            if ($k != 0) {
                $temp = "OR " . $row . " LIKE '%" . $value . "%' ";
            }

            $createSearchQuery = $createSearchQuery . $temp;
            $k++;
        }

        return " WHERE dex_libro_premium_speedy.id_libro_premium = dex_usuario_libro_comprador.id_libro_premium AND tipo_compra = 'EBOOK' AND (" . $createSearchQuery . ")";

    }

    static function filterBuyerBook($value)
    {


        $columns_search = array('`id_usuario_comprador`', '`id_usuario`',
            '`email_envio`', '`nombres_envio`', '`apellidos_envio`', '`titulo_libro`', '`edicion`', '`annio_edicion`',
            '`tipo_pago`', '`fecha_compra`', '`numero_referencia`', '`precio_compra`');


        $createSearchQuery = "";
        $k = 0;
        foreach ($columns_search as $row) {
            $temp = $row . " LIKE '%" . $value . "%' ";
            if ($k != 0) {
                $temp = "OR " . $row . " LIKE '%" . $value . "%' ";
            }

            $createSearchQuery = $createSearchQuery . $temp;
            $k++;
        }

        return " WHERE dex_libro_premium_speedy.id_libro_premium = dex_usuario_libro_comprador.id_libro_premium AND tipo_compra = 'FISICO' AND (" . $createSearchQuery . ")";

    }

    static function filterBuyerLaw($value)
    {


        $columns_search = array('`id_dex_usuario_doclegis_comprado`', '`id_usuario`',
            '`email_envio`', '`nombres_envio`', '`apellidos_envio`', '`doc_titulo`',
            '`tipo_pago`', '`fecha_compra`', '`numero_referencia`', '`precio_compra`');


        $createSearchQuery = "";
        $k = 0;
        foreach ($columns_search as $row) {
            $temp = $row . " LIKE '%" . $value . "%' ";
            if ($k != 0) {
                $temp = "OR " . $row . " LIKE '%" . $value . "%' ";
            }

            $createSearchQuery = $createSearchQuery . $temp;
            $k++;
        }

        return " WHERE dex_documentos_legis.doc_id = dex_usuario_doclegis_comprado.doc_id AND (" . $createSearchQuery . ")";

    }


    /**
     * Perform the SQL queries needed for an server-side processing requested,
     * utilising the helper functions of this class, limit(), order() and
     * filter() among others. The returned array is ready to be encoded as JSON
     * in response to an SSP request, or can be modified if needed before
     * sending back to the client.
     *
     * @param array $request Data sent to server by DataTables
     * @param array|PDO $conn PDO connection resource or connection parameters array
     * @param string $table SQL table to query
     * @param string $primaryKey Primary key of the table
     * @param array $columns Column information array
     * @return array          Server-side processing response array
     */
    static function simple($request, $conn, $table, $primaryKey, $columns)
    {
        $bindings = array();
        $db = self::db($conn);
        // Build the SQL query string from the request
        $limit = self::limit($request, $columns);
        $order = self::order($request, $columns);
        $where = self::filterUser($_GET['search']['value']);
        // Main query to actually get the data
        $sql = "SELECT `" . implode("`, `", self::pluck($columns, 'db')) . "`
			 FROM `$table`
			 $where
			 $order
			 $limit";
        $data = self::sql_exec($db, $bindings, $sql);
        // Data set length after filtering
        $resFilterLength = self::sql_exec($db, $bindings,
            "SELECT COUNT(`{$primaryKey}`)
			 FROM   `$table`
			 $where"
        );
        $recordsFiltered = $resFilterLength[0][0];
        // Total data set length
        $resTotalLength = self::sql_exec($db,
            "SELECT COUNT(`{$primaryKey}`)
			 FROM   `$table`"
        );
        $recordsTotal = $resTotalLength[0][0];
        /*
         * Output
         */

        for ($i = 0; $i < count($data); $i++) {
            if ($data[$i]['sexo'] == "") {
                $data[$i]['sexo'] = "N/A";
            }
            if ($data[$i]['cedula_usuario'] == "") {
                $data[$i]['cedula_usuario'] = "N/A";
            }
            if ($data[$i]['celular_usuario'] == "") {
                $data[$i]['celular_usuario'] = "N/A";
            }
            if ($data[$i]['nombre_usuario'] == "") {
                $data[$i]['nombre_usuario'] = "N/A";
            }
            if ($data[$i]['apellido_usuario'] == "") {
                $data[$i]['apellido_usuario'] = "N/A";
            }
        }

        return array(
            "draw" => isset ($request['draw']) ?
                intval($request['draw']) :
                0,
            "recordsTotal" => intval($recordsTotal),
            "recordsFiltered" => intval($recordsFiltered),
            "data" => $data
        );

    }


    static function simpleCodPromotional($request, $conn, $table, $primaryKey, $columns)
    {
        $bindings = array();
        $db = self::db($conn);
        // Build the SQL query string from the request
        $limit = self::limit($request, $columns);
        $order = self::order($request, $columns);
        $where = self::filterCodPromotional($_GET['search']['value']);
        // Main query to actually get the data
        $sql = "SELECT `" . implode("`, `", self::pluck($columns, 'db')) . "`
			 FROM `$table`
			 $where
			 $order
			 $limit";
        $data = self::sql_exec($db, $bindings, $sql);
        // Data set length after filtering
        $resFilterLength = self::sql_exec($db, $bindings,
            "SELECT COUNT(`{$primaryKey}`)
			 FROM   `$table`
			 $where"
        );
        $recordsFiltered = $resFilterLength[0][0];
        // Total data set length
        $resTotalLength = self::sql_exec($db,
            "SELECT COUNT(`{$primaryKey}`)
			 FROM   `$table`"
        );

        $recordsTotal = $resTotalLength[0][0];
        for ($i = 0; $i < count($data); $i++) {
            $data[$i]['edit'] = "<img style=\"cursor:pointer;\" onclick=\"editCode(this);\" src=\"/speedycep/admin/img/edit_icon.png\" width=\"24\" height=\"24\">";
            $data[$i]['delete'] = "<img style=\"cursor:pointer;\" onclick=\"deleteCode(this);\" src=\"/speedycep/admin/img/remove_icon.png\" width=\"24\" height=\"24\">";
        }

        return array(
            "draw" => isset ($request['draw']) ?
                intval($request['draw']) :
                0,
            "recordsTotal" => intval($recordsTotal),
            "recordsFiltered" => intval($recordsFiltered),
            "data" => $data
        );

    }

    static function simpleDoc($request, $conn, $table, $primaryKey, $columns)
    {
        $bindings = array();
        $db = self::db($conn);
        // Build the SQL query string from the request
        $limit = self::limit($request, $columns);
        $order = self::order($request, $columns);
        $where = self::filterDoc($_GET['search']['value']);
        // Main query to actually get the data
        $sql = "SELECT `" . implode("`, `", self::pluck($columns, 'db')) . "`
			 FROM `$table`
			 $where
			 $order
			 $limit";
        $data = self::sql_exec($db, $bindings, $sql);
        // Data set length after filtering
        $resFilterLength = self::sql_exec($db, $bindings,
            "SELECT COUNT(`{$primaryKey}`)
			 FROM   `$table`
			 $where"
        );
        $recordsFiltered = $resFilterLength[0][0];
        // Total data set length
        $resTotalLength = self::sql_exec($db,
            "SELECT COUNT(`{$primaryKey}`)
			 FROM   `$table`"
        );
        $recordsTotal = $resTotalLength[0][0];

        return array(
            "draw" => isset ($request['draw']) ?
                intval($request['draw']) :
                0,
            "recordsTotal" => intval($recordsTotal),
            "recordsFiltered" => intval($recordsFiltered),
            "data" => $data
        );

    }

    static function simpleBuyerEBook($request, $conn, $tables, $primaryKey, $columns)
    {
        $bindings = array();
        $db = self::db($conn);
        // Build the SQL query string from the request
        $limit = self::limit($request, $columns);
        $order = self::order($request, $columns);
        $where = self::filterBuyerEBook($_GET['search']['value']);
        // Main query to actually get the data
        $sql = "SELECT `" . implode("`, `", self::pluck($columns, 'db')) . "`
			 FROM $tables
			 $where
			 $order
			 $limit";

        $data = self::sql_exec($db, $bindings, $sql);
        // Data set length after filtering
        $resFilterLength = self::sql_exec($db, $bindings,
            "SELECT COUNT(`{$primaryKey}`)
			 FROM   $tables
			 $where"
        );
        $recordsFiltered = $resFilterLength[0][0];
        // Total data set length
        $resTotalLength = self::sql_exec($db,
            "SELECT COUNT(`{$primaryKey}`) 
            FROM $tables WHERE dex_libro_premium_speedy.id_libro_premium = dex_usuario_libro_comprador.id_libro_premium AND tipo_compra = 'EBOOK'"
        );

        $recordsTotal = $resTotalLength[0][0];
        for ($i = 0; $i < count($data); $i++) {

            $dateCompra = new \DateTime($data[$i]['fecha_compra']);
            $data[$i]['fecha_compra'] = $dateCompra->format("m/d/Y H:i:s a");
            $data[$i]['precio_compra'] = "$" . $data[$i]['precio_compra'];
            $data[$i]['edicion'] = $data[$i]['edicion'] . " - " . $data[$i]['annio_edicion'];

            //$data[$i]['reenviar'] = "<button class=\"btn btn-warning\" onclick='detalles_ebook(this);'>Reenviar al email</button>";

        }

        return array(
            "draw" => isset ($request['draw']) ?
                intval($request['draw']) :
                0,
            "recordsTotal" => intval($recordsTotal),
            "recordsFiltered" => intval($recordsFiltered),
            "data" => $data
        );

    }

    static function simpleBuyerBook($request, $conn, $tables, $primaryKey, $columns)
    {
        $bindings = array();
        $db = self::db($conn);
        // Build the SQL query string from the request
        $limit = self::limit($request, $columns);
        $order = self::order($request, $columns);
        $where = self::filterBuyerBook($_GET['search']['value']);
        // Main query to actually get the data
        $sql = "SELECT `" . implode("`, `", self::pluck($columns, 'db')) . "`
			 FROM $tables
			 $where
			 $order
			 $limit";

        $data = self::sql_exec($db, $bindings, $sql);
        // Data set length after filtering
        $resFilterLength = self::sql_exec($db, $bindings,
            "SELECT COUNT(`{$primaryKey}`)
			 FROM   $tables
			 $where"
        );
        $recordsFiltered = $resFilterLength[0][0];
        // Total data set length
        $resTotalLength = self::sql_exec($db,
            "SELECT COUNT(`{$primaryKey}`) 
            FROM $tables WHERE dex_libro_premium_speedy.id_libro_premium = dex_usuario_libro_comprador.id_libro_premium AND tipo_compra = 'FISICO'"
        );

        $recordsTotal = $resTotalLength[0][0];
        for ($i = 0; $i < count($data); $i++) {

            $dateCompra = new \DateTime($data[$i]['fecha_compra']);
            $data[$i]['details_buyer'] = "<button class=\"btn btn-danger\" onclick='detalles_fisico(\"" . $data[$i]['id_usuario_comprador'] . "\");'>Detalles de envío</button>";
            $data[$i]['fecha_compra'] = $dateCompra->format("m/d/Y H:i:s a");
            $data[$i]['precio_compra'] = "$" . $data[$i]['precio_compra'];

            $sqlEstadoEnv = "SELECT `estado_envio`
			 FROM `dex_detalle_envio_speedy` WHERE id_usuario_libro_comprador = '" . $data[$i]['id_usuario_comprador'] . "' ORDER BY id_detalle_envio_speedy DESC LIMIT 1";
            $dataEstadoEnv = self::sql_exec($db, $bindings, $sqlEstadoEnv);
            $data[$i]['estado_envio'] = self::getColorStatus($dataEstadoEnv[0]['estado_envio']);
            $data[$i]['edicion'] = $data[$i]['edicion'] . " - " . $data[$i]['annio_edicion'];

        }

        return array(
            "draw" => isset ($request['draw']) ?
                intval($request['draw']) :
                0,
            "recordsTotal" => intval($recordsTotal),
            "recordsFiltered" => intval($recordsFiltered),
            "data" => $data
        );

    }

    static function simpleBuyerLaw($request, $conn, $tables, $primaryKey, $columns)
    {
        $bindings = array();
        $db = self::db($conn);
        // Build the SQL query string from the request
        $limit = self::limit($request, $columns);
        $order = self::order($request, $columns);
        $where = self::filterBuyerLaw($_GET['search']['value']);
        // Main query to actually get the data
        $sql = "SELECT `" . implode("`, `", self::pluck($columns, 'db')) . "`
			 FROM $tables
			 $where
			 $order
			 $limit";

        $data = self::sql_exec($db, $bindings, $sql);
        // Data set length after filtering
        $resFilterLength = self::sql_exec($db, $bindings,
            "SELECT COUNT(`{$primaryKey}`)
			 FROM   $tables
			 $where"
        );
        $recordsFiltered = $resFilterLength[0][0];
        // Total data set length
        $resTotalLength = self::sql_exec($db,
            "SELECT COUNT(`{$primaryKey}`) 
            FROM $tables WHERE dex_documentos_legis.doc_id = dex_usuario_doclegis_comprado.doc_id"
        );

        $recordsTotal = $resTotalLength[0][0];
        for ($i = 0; $i < count($data); $i++) {
            $dateCompra = new \DateTime($data[$i]['fecha_compra']);
            $data[$i]['details_buyer'] = "<button class=\"btn btn-danger\" onclick='detalles_fisico(\"" . $data[$i]['id_dex_usuario_doclegis_comprado'] . "\");'>Detalles de envío</button>";
            $data[$i]['fecha_compra'] = $dateCompra->format("m/d/Y H:i:s a");
            $data[$i]['precio_compra'] = "$" . $data[$i]['precio_compra'];

            $sqlEstadoEnv = "SELECT `estado_envio`
			 FROM `dex_detalle_envio_speedy_ro` WHERE id_dex_usuario_doclegis_comprado = '" . $data[$i]['id_dex_usuario_doclegis_comprado'] . "' ORDER BY id_detalle_envio_speedy_ro DESC LIMIT 1";
            $dataEstadoEnv = self::sql_exec($db, $bindings, $sqlEstadoEnv);
            $data[$i]['estado_envio'] = self::getColorStatus($dataEstadoEnv[0]['estado_envio']);

        }

        return array(
            "draw" => isset ($request['draw']) ?
                intval($request['draw']) :
                0,
            "recordsTotal" => intval($recordsTotal),
            "recordsFiltered" => intval($recordsFiltered),
            "data" => $data
        );

    }

    static function getColorStatus($estado)
    {

        if ($estado == "INFORMACION RECIBIDA") {
            return "<div style='background: #AFD0FF;padding: 10px;'>RECIBIDA</div>";
        } else if ($estado == "PREPARANDO ENVIO") {
            return "<div style='background: #0e84b5;padding: 10px;'>PREPARANDO</div>";
        } else if ($estado == "ENVIADO") {
            return "<div style='background: #5cb85c;padding: 10px;'>" . $estado . "</div>";
        } else {
            return "<div style='background: #ddddbb;padding: 10px;'>" . $estado . "</div>";
        }

    }


    /**
     * Connect to the database
     *
     * @param array $sql_details SQL server connection details array, with the
     *   properties:
     *     * host - host name
     *     * db   - database name
     *     * user - user name
     *     * pass - user password
     * @return \PDO
     */
    static function sql_connect($sql_details)
    {
        try {
            $db = new \PDO(
                "mysql:host={$sql_details['host']};dbname={$sql_details['db']}",
                $sql_details['user'],
                $sql_details['pass'],
                array(\PDO::ATTR_ERRMODE => \PDO::ERRMODE_EXCEPTION)
            );
            $db->exec("SET CHARACTER SET utf8");
        } catch (\PDOException $e) {
            self::fatal(
                "An error occurred while connecting to the database. " .
                "The error reported by the server was: " . $e->getMessage()
            );
        }
        return $db;
    }

    /**
     * Execute an SQL query on the database
     *
     * @param array|PDO
     * @param array $bindings Array of PDO binding values from bind() to be
     *   used for safely escaping strings. Note that this can be given as the
     *   SQL query string if no bindings are required.
     * @param string $sql SQL query to execute.
     * @return array         Result from the query (all rows)
     */
    static function sql_exec($db, $bindings, $sql = null)
    {
        // Argument shifting
        if ($sql === null) {
            $sql = $bindings;
        }
        $stmt = $db->prepare($sql);
        //echo $sql;
        // Bind parameters

        if (is_array($bindings)) {
            for ($i = 0, $ien = count($bindings); $i < $ien; $i++) {
                $binding = $bindings[$i];
                $stmt->bindValue($binding['key'], $binding['val'], $binding['type']);
            }
        }
        // Execute

        // Execute
        try {
            $stmt->execute();
        } catch (\PDOException $e) {
            self::fatal("An SQL error occurred: " . $e->getMessage());
        }
        // Return all
        return $stmt->fetchAll(\PDO::FETCH_BOTH);
    }
    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
     * Internal methods
     */
    /**
     * Throw a fatal error.
     *
     * This writes out an error message in a JSON string which DataTables will
     * see and show to the user in the browser.
     *
     * @param string $msg Message to send to the client
     */
    static function fatal($msg)
    {
        echo json_encode(array(
            "error" => $msg
        ));
        exit(0);
    }

    /**
     * Create a PDO binding key which can be used for escaping variables safely
     * when executing a query with sql_exec()
     *
     * @param array &$a Array of bindings
     * @param  *      $val  Value to bind
     * @param int $type PDO field type
     * @return string       Bound key to be used in the SQL where this parameter
     *   would be used.
     */
    static function bind(&$a, $val, $type)
    {
        $key = ':binding_' . count($a);
        $a[] = array(
            'key' => $key,
            'val' => $val,
            'type' => $type
        );
        return $key;
    }

    /**
     * Pull a particular property from each assoc. array in a numeric array,
     * returning and array of the property values from each item.
     *
     * @param array $a Array to get data from
     * @param string $prop Property to read
     * @return array        Array of property values
     */
    static function pluck($a, $prop)
    {
        $out = array();
        for ($i = 0, $len = count($a); $i < $len; $i++) {
            $out[] = $a[$i][$prop];
        }
        return $out;
    }

    /**
     * Return a string from an array or a string
     *
     * @param array|string $a Array to join
     * @param string $join Glue for the concatenation
     * @return string Joined string
     */
    static function _flatten($a, $join = ' AND ')
    {
        if (!$a) {
            return '';
        } else if ($a && is_array($a)) {
            return implode($join, $a);
        }
        return $a;
    }
}