<?php

use App\Values\Resources;

?>
<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="shortcut icon" href="/speedycep/admin/img/favicon.ico" type="image/x-icon">
    <link rel="icon" href="/speedycep/admin/img/favicon.ico" type="image/x-icon">
    <meta name="description" content="">
    <meta name="author" content="Ing. Daniel Molina">

    <title><?php echo Resources::getStringResource("app_name"); ?></title>

    <!-- Bootstrap Core CSS -->
    <link href="/speedycep/admin/css/bootstrap_dashboard.min.css" rel="stylesheet">

    <!-- MetisMenu CSS -->
    <link href="/speedycep/admin/css/metisMenu.min.css" rel="stylesheet">

    <!-- DataTables CSS -->
    <link href="/speedycep/admin/css/dataTables.bootstrap.css" rel="stylesheet">

    <!-- DataTables Responsive CSS -->
    <link href="/speedycep/admin/css/dataTables.responsive.css" rel="stylesheet">

    <!-- Custom CSS -->
    <link href="/speedycep/admin/css/sb-admin-2.css" rel="stylesheet">


    <!-- Custom Fonts -->
    <link href="/speedycep/admin/fonts/font-awesome-4.7.0/css/font-awesome.min.css" rel="stylesheet" type="text/css">

    <!-- HTML5 Shim and Respond.js IE8 support of HTML5 elements and media queries -->
    <!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
    <!--[if lt IE 9]>
    <script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
    <script src="https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js"></script>
    <![endif]-->
</head>

<body>

<div id="wrapper">

    <!-- Navigation -->
    <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">

        <div class="navbar-header">
            <!-- /.navbar-header -->
            <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <img src="/speedycep/admin/img/circle_speedycep_logo.png" width="48" height="48" style="float: left;">
            <a class="navbar-brand"
               href="/speedycep/admin/application/"><?php echo Resources::getStringResource("app_name"); ?></a>
        </div>
        <!-- /.navbar-header -->
        <ul class="nav navbar-top-links navbar-right">
            <!-- /.dropdown -->
            <li class="dropdown">
                <a class="dropdown-toggle" data-toggle="dropdown" href="#">
                    <i class="fa fa-user fa-fw"></i> <i class="fa fa-caret-down"></i>
                </a>
                <ul class="dropdown-menu dropdown-user">
                    <li class="divider"></li>
                    <li><a href="/speedycep/admin/access/logout/"><i class="fa fa-sign-out fa-fw"></i> Logout</a>
                    </li>
                </ul>
                <!-- /.dropdown-user -->
            </li>
            <!-- /.dropdown -->
        </ul>
        <!-- /.navbar-top-links -->

        <div class="navbar-default sidebar" role="navigation">
            <div class="sidebar-nav navbar-collapse">
                <ul class="nav" id="side-menu">
                    <li>
                        <a style="cursor: pointer;" onclick="javascript:load('/speedycep/admin/application/user/');"><i class="fa fa-user fa-fw"></i> Usuarios</a>
                    </li>
                    <li>
                        <a style="cursor: pointer;" onclick="javascript:load('/speedycep/admin/application/code_promotional/');"><i class="fa fa-sort-numeric-asc fa-fw"></i> Códigos promocionales</a>
                    </li>
                    <li>
                        <a style="cursor: pointer;" onclick="javascript:load('/speedycep/admin/application/book/');"><i class="fa fa-book fa-fw"></i> Libros premium</a>
                        <!-- /.nav-second-level -->
                    </li>
                    <li>
                        <a style="cursor: pointer;" onclick="javascript:load('/speedycep/admin/application/seminary/');"><i class="fa fa-file-text-o fa-fw"></i> Seminarios - talleres</a>
                    </li>
                    <li>
                        <a style="cursor: pointer;" onclick="javascript:load('/speedycep/admin/application/basic_norm/');"><i class="fa fa-bookmark-o fa-fw"></i> Normas básicas gratis</a>
                    </li>
                    <li>
                        <a style="cursor: pointer;" onclick="javascript:load('/speedycep/admin/application/doc_users_book/');"><i class="fa fa-dollar fa-fw"></i> Ver compras de leyes (RO)</a>
                    </li>
                    <li>
                        <a style="cursor: pointer;" onclick="javascript:load('/speedycep/admin/application/view_buyer_premium_book/');"><i class="fa fa-archive fa-fw"></i> Ver compras de libros premium</a>
                    </li>
                    <li>
                        <a style="cursor: pointer;" onclick="javascript:load('/speedycep/admin/application/view_buyer_premium_ebook/');"><i class="fa fa-cloud fa-fw"></i> Ver compras de ebooks</a>
                    </li>
                    <li>
                        <a style="cursor: pointer;" onclick="javascript:load('/speedycep/admin/application/setting_app/');"><i class="fa fa-cog fa-fw"></i> Ajustes de precios</a>
                    </li>
                    <li>
                        <a href="#"><i class="fa fa-address-card fa-fw"></i> Ajustes para recepción de correos<span class="fa arrow"></span></a>
                        <ul class="nav nav-second-level">
                            <li>
                                <a style="cursor:pointer;" onclick="javascript:load('/speedycep/admin/application/setting_emails/books');">Para libros o leyes</a>
                            </li>
                            <li>
                                <a style="cursor:pointer;" onclick="javascript:load('/speedycep/admin/application/setting_emails/seminaries');">Para cursos, talleres o seminarios</a>
                            </li>
                            <li>
                                <a style="cursor:pointer;" onclick="javascript:load('/speedycep/admin/application/setting_emails/subscriptions');">Para subscripciones</a>
                            </li>
                        </ul>
                        <!-- /.nav-second-level -->
                    </li>
                </ul>
            </div>
            <!-- /.sidebar-collapse -->
        </div>
        <!-- /.navbar-static-side -->
    </nav>

    <!-- Page Content -->
    <div id="page-wrapper">
        <div class="container-fluid">
            <div id="load-event-change-view" class="text-center" style="height: 90vh; display: flex; justify-content: center; flex-direction: column; text-align: center;">
                <p>
                    <img src="/speedycep/admin/img/loading.gif" width="128" height="96"/>
                    <br/><h4><i>Cargando contenido ...</i></h4>
                </p>
            </div>
            <div id="content_load" style="display: none;">
                <div class="text-center">
                    <img src="/speedycep/admin/img/speedyceplogo.png" width="300" height="200">
                    <br/><br/><br/>
                    <p>Sencillo panel administrativo, con el cual se puede ajustar la información de los libros premium, códigos promocionales y talleres.</p>
                </div>
            </div>
            <!-- /.row -->
        </div>
        <!-- /.container-fluid -->
    </div>
    <!-- /#page-wrapper -->

</div>
<!-- /#wrapper -->

<!-- jQuery -->
<script src="/speedycep/admin/js/jquery-3.2.1.min.js"></script>

<!-- Bootstrap Core JavaScript -->
<script src="/speedycep/admin/js/bootstrap_dashboard.min.js"></script>

<!-- Metis Menu Plugin JavaScript -->
<script src="/speedycep/admin/js/metisMenu.min.js"></script>

<!-- DataTables JavaScript -->
<script src="/speedycep/admin/js/jquery.dataTables.js"></script>
<script src="/speedycep/admin/js/dataTables.bootstrap.min.js"></script>
<script src="/speedycep/admin/js/dataTables.responsive.js"></script>

<!-- Custom Theme JavaScript -->
<script src="/speedycep/admin/js/sb-admin-2.js"></script>
<script src="/speedycep/admin/js/application.js"></script>

</body>

</html>