<?php

use \App\Controllers\Application;
use \App\Models\Entities\Constants;
use \App\Models\Entities\API;

$apl_con = new Application();
date_default_timezone_set('America/Guayaquil');


$init_admin = parse_ini_file('/var/www/html/speedycep/doc/basic_norm.ini');
$storageData = $init_admin['data'];
?>
<!-- DataTables Responsive CSS -->
<link href="/speedycep/admin/css/jquery.dataTables.min.css" rel="stylesheet">
<style>
    /* Customize the label (the container) */
    .container {
        display: block;
        position: relative;
        padding-left: 35px;
        margin-bottom: 12px;
        cursor: pointer;
        font-size: 12px;
        -webkit-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        border-bottom: 1px solid #eee;
        padding-bottom: 10px;
    }

    /* Hide the browser's default checkbox */
    .container input {
        position: absolute;
        opacity: 0;
        cursor: pointer;
        height: 0;
        width: 0;
    }

    /* Create a custom checkbox */
    .checkmark {
        position: absolute;
        top: 0;
        left: 0;
        height: 25px;
        width: 25px;
        background-color: #eee;
    }

    /* On mouse-over, add a grey background color */
    .container:hover input ~ .checkmark {
        background-color: #ccc;
    }

    /* When the checkbox is checked, add a blue background */
    .container input:checked ~ .checkmark {
        background-color: #2196F3;
    }

    /* Create the checkmark/indicator (hidden when not checked) */
    .checkmark:after {
        content: "";
        position: absolute;
        display: none;
    }

    /* Show the checkmark when checked */
    .container input:checked ~ .checkmark:after {
        display: block;
    }

    /* Style the checkmark/indicator */
    .container .checkmark:after {
        left: 9px;
        top: 6px;
        width: 5px;
        height: 10px;
        border: solid white;
        border-width: 0 3px 3px 0;
        -webkit-transform: rotate(45deg);
        -ms-transform: rotate(45deg);
        transform: rotate(45deg);
    }
</style>
<div class="row">
    <div class="col-lg-12">
        <h1 class="page-header">Normas básicas gratis</h1>
    </div>
    <!-- /.col-lg-12 -->
</div>

<div class="row">
    <div class="col-lg-12">
        <div class="panel panel-default">
            <!-- /.panel-heading -->
            <div class="panel-heading" align="right">
                <button class="btn btn-primary" id="save_btn">Guardar cambios</button>
                <button class="btn btn-primary" id="search_btn">Buscar norma</button>
            </div>
            <div class="panel-body">
                <?php
                $ids = json_decode($storageData, true);
                echo "<div class='row norm-container' id='documents-container'>";
                foreach ($ids["doc_ids"] as $item) {
                    $checked = "";
                    if ($item['active']) {
                        $checked = " checked=\"checked\" ";
                    }
                    echo "
                            <div id='id_" . $item['id'] . "' class='iterable'>
                                <div class='col-lg-11'>
                                    <label class=\"container\" >" . $item['name'] . "
                                        <input type=\"checkbox\" " . $checked . ">
                                        <span class=\"checkmark\"></span>
                                    </label>
                                </div>
                                <div class='col-lg-1'>
                                    <img onclick='removeItem(this);' src='/speedycep/admin/public/img/remove_icon.png' style='cursor:pointer;' width='24' height='24' />
                                </div>
                            </div>
                        ";
                }
                echo "</div>";
                ?>
            </div>
            <!-- /.panel-body -->
        </div>
        <!-- /.panel -->
    </div>
    <!-- /.col-lg-12 -->

    <!-- Modal -->
    <div class="modal fade" id="myModalSearch" tabindex="-1" role="dialog" aria-labelledby="myModalLabelSearch"
         aria-hidden="true">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                    <h4 class="modal-title" id="myModalLabelSearch">Buscar norma.</h4>
                </div>
                <div class="modal-body">
                    <table width="100%" class="table table-striped table-bordered table-hover"
                           id="dataTables-basic-norm">
                        <thead>
                        <tr>
                            <th class="text-center">ID</th>
                            <th class="text-center">Norma o ley</th>
                        </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                    <button type="button" id="add-code-btn" class="btn btn-primary">Agregar</button>
                </div>
            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>

</div>
<script>
    var up = "/speedycep/admin/application/change_norms/";
</script>
<script src="/speedycep/admin/js/dataTables.buttons.min.js"></script>
<script src="/speedycep/admin/js/jszip.min.js"></script>
<script src="/speedycep/admin/js/pdfmake.min.js"></script>
<script src="/speedycep/admin/js/vfs_fonts.js"></script>
<script src="/speedycep/admin/js/buttons.html5.min.js"></script>
<script src="/speedycep/admin/public/js/basic_norm.js"></script>


