<?php

use \App\Controllers\Application;
use \App\Models\Entities\Constants;
use \App\Models\Entities\API;

$apl_con = new Application();
date_default_timezone_set('America/Guayaquil');

$multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/cod_promocional/get_todo_code/",
    array(), $apl_con->TOKEN);
$data = API::JSON_TO_ARRAY($multi_info_api);
?>
<div class="row">
    <div class="col-lg-12">
        <h1 class="page-header">Códigos promocionales</h1>
    </div>
    <!-- /.col-lg-12 -->
</div>

<div class="row">
    <div class="col-lg-12">
        <div class="panel panel-default">
            <div class="panel-heading" align="right">
                <button class="btn btn-primary" id="multiple_btn">Multiples códigos</button>
                <button class="btn btn-primary" id="create_btn">Crear código</button>
            </div>
            <!-- /.panel-heading -->
            <div class="panel-body">
                <table width="100%" class="table table-striped table-bordered table-hover"
                       id="dataTables-code-promotional">
                    <thead>
                    <tr>
                        <th class="text-center">Código</th>
                        <th class="text-center">Duración</th>
                        <th class="text-center">Fecha de creación</th>
                        <th class="text-center">Estado</th>
                        <th class="text-center"></th>
                        <th class="text-center"></th>
                    </tr>
                    </thead>
                    <tbody>
                    <?php
                    if ($data != null) {
                        if ($data['status'] == 1) {
                            foreach ($data['data'] as $row) {
                                $date_inicial = new \DateTime($row['fecha_inicial']);
                                echo '<tr>
                                    <td class="text-center">' . $row['codigo'] . '</td>
                                    <td class="text-center">' . $row['duracion'] . '</td>
                                    <td class="text-center">' . $date_inicial->format('m/d/Y') . '</td>
                                    <td class="text-center">' . $row['estado'] . '</td>
                                    <td class="text-center"><img style="cursor:pointer;" onclick="editCode(this);" src="/speedycep/admin/img/edit_icon.png" width="24" height="24"></td>
                                    <td class="text-center"><img style="cursor:pointer;" onclick="deleteCode(this);" src="/speedycep/admin/img/remove_icon.png" width="24" height="24"></td>
                                    </tr>';
                            }
                        }
                    }
                    ´ ?>
                    </tbody>
                </table>
            </div>
            <!-- /.panel-body -->
        </div>
        <!-- /.panel -->
    </div>
    <!-- /.col-lg-12 -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModalMultiple" tabindex="-1" role="dialog" aria-labelledby="myModalMultipleLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalMultipleLabel">Creación de multiples códigos promocionales</h4>
            </div>
            <div>
                <div class="modal-body">
                    <div class="form-group">
                        <label>¿Cuántos códigos vas a crear?</label>
                        <!--                    <input class="form-control" placeholder="Enter text">-->
                        <select class="form-control" id="select_count_code_promotional">
                            <option value="5">5</option>
                            <option value="10">10</option>
                            <option value="30">30</option>
                            <option value="50">50</option>
                            <option value="100">100</option>
                        </select>
                    </div>
                    <div class="form-group">
                        <label>¿Duración de los códigos?</label>
                        <select class="form-control" id="duracion_codes">
                            <option value="30">1 Mes</option>
                            <option value="90">3 Meses</option>
                            <option value="365">1 Año</option>
                        </select>
                    </div>
                    <div class="form-group">
                        <h5>Nota: Los códigos van hacer creados de forma aleatoria por el sistema, use está opción para crear varios códigos al mismo tiempo.</h5>
                    </div>
                </div>
                <div align="center" style="display: none;" id="panel-multiple-msg-error">
                    <span class="alert alert-danger"><i class="fa fa-warning"></i> <span id="msg_multiple_error"></span> </span>
                    <br/><br/>
                </div>
                <div class="modal-footer">
                    <img src="/speedycep/admin/img/loading.gif" width="48" height="36" id="load-multiple-extra-gif"
                         style="display: none;"/>
                    <button type="button" id="create-multiple-code-btn" class="btn btn-primary">Crear códigos</button>
                </div>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabel">Creación del código promocional</h4>
            </div>
            <div id="panel-create" style="display: none;">
                <div class="modal-body">
                    <div class="form-group">
                        <label>Duración</label>
                        <!--                    <input class="form-control" placeholder="Enter text">-->
                        <select class="form-control" id="duracion">
                            <option value="30">1 Mes</option>
                            <option value="90">3 Meses</option>
                            <option value="365">1 Año</option>
                        </select>
                    </div>
                    <label>Código autogenerado</label>
                    <div class="form-group input-group">
                        <input type="text" class="form-control" id="codigo" readonly>
                        <span class="input-group-addon" id="auto-generate-btn" style="cursor: pointer;">Generar</span>
                    </div>
                </div>
                <div align="center" style="display: none;" id="panel-msg-error">
                    <span class="alert alert-danger"><i class="fa fa-warning"></i> <span id="msg_error"></span> </span>
                    <br/><br/>
                </div>
                <div class="modal-footer">
                    <img src="/speedycep/admin/img/loading.gif" width="48" height="36" id="load-extra-gif"
                         style="display: none;"/>
                    <button type="button" id="create-code-btn" class="btn btn-primary">Crear código</button>
                </div>
            </div>
            <div id="load-create" align="center">
                <img src="/speedycep/admin/img/loading.gif" width="64" height="48"/>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModalEdit" tabindex="-1" role="dialog" aria-labelledby="myModalLabelEdit"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelEdit">Editar código promocional</h4>
            </div>
            <div id="panel-create">
                <div class="modal-body">
                    <div class="form-group">
                        <label>Duración</label>
                        <!--                    <input class="form-control" placeholder="Enter text">-->
                        <select class="form-control" id="duracion_edit">
                            <option value="30">1 Mes</option>
                            <option value="90">3 Meses</option>
                            <option value="365">1 Año</option>
                        </select>
                    </div>
                    <label>Código autogenerado</label>
                    <div class="form-group">
                        <input type="text" class="form-control" id="codigo_edit" readonly>
                    </div>
                </div>
                <div align="center" style="display: none;" id="panel-msg-error-edit">
                    <span class="alert alert-danger"><i class="fa fa-warning"></i> <span
                                id="msg_error_edit"></span> </span>
                    <br/><br/>
                </div>
                <div class="modal-footer">
                    <img src="/speedycep/admin/img/loading.gif" width="48" height="36" id="load-extra-gif-edit"
                         style="display: none;"/>
                    <button type="button" id="edit-code-btn" class="btn btn-primary">Editar código</button>
                </div>
            </div>
            <div id="load-create-edit" align="center" style="display: none;">
                <img src="/speedycep/admin/img/loading.gif" width="64" height="48"/>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>


<!-- Modal -->
<div class="modal fade" id="myModalDelete" tabindex="-1" role="dialog" aria-labelledby="myModalLabelDelete"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelDelete">Eliminación del código promocional</h4>
            </div>
            <div class="modal-body">
                ¿Desea eliminar esté código promocional?
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                <button type="button" id="delete-code-btn" class="btn btn-primary">Sí</button>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>


<script>
    var token = '<?php echo '5pU8' . $apl_con->encrypt($apl_con->TOKEN);?>';
    var gcp = "/speedycep/admin/application/generate_code_promotional/" + token;
    var mmc = "/speedycep/admin/application/manipulate_multiple_code_promotional/";
    var mc = "/speedycep/admin/application/manipulate_code_promotional/";
    var ec = "/speedycep/admin/application/edit_code_promotional/";
    var dc = "/speedycep/admin/application/delete_code_promotional/";
</script>
<script src="/speedycep/admin/js/dataTables.buttons.min.js"></script>
<script src="/speedycep/admin/js/jszip.min.js"></script>
<script src="/speedycep/admin/js/pdfmake.min.js"></script>
<script src="/speedycep/admin/js/vfs_fonts.js"></script>
<script src="/speedycep/admin/js/buttons.html5.min.js"></script>
<script src="/speedycep/admin/js/codigo_promocional.js" charset="utf-8"></script>

