<?php

use \App\Controllers\Application;
use \App\Models\Entities\Constants;
use \App\Models\Entities\API;

$apl_con = new Application();
date_default_timezone_set('America/Guayaquil');

$multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/document_legis/get_todo_code/",
    array(), $apl_con->TOKEN);
$data = API::JSON_TO_ARRAY($multi_info_api);
?>
<div class="row">
    <div class="col-lg-12">
        <h1 class="page-header">Documentos legislación - RO</h1>
    </div>
    <!-- /.col-lg-12 -->
</div>

<div class="row">
    <div class="col-lg-12">
        <div class="panel panel-default">
            <div class="panel-heading" align="right">
                <button class="btn btn-primary" id="create_btn">Crear libro</button>
            </div>
            <!-- /.panel-heading -->
            <div class="panel-body">

                <div style="width: 100%;">
                    <div class="table-responsive">
                        <table width="100%" class="table table-striped table-bordered table-hover"
                               id="dataTables-book">
                            <thead>
                            <tr>
                                <th class="text-center" style="display: none;">ID</th>
                                <th class="text-center">Titulo</th>
                                <th class="text-center">Tema</th>
                                <th class="text-center">Grupo</th>
                                <th class="text-center">Número de ley</th>
                                <th class="text-center">Autoridad</th>
                                <th class="text-center">Fecha ley</th>
                                <th class="text-center">Fecha RO</th>
                                <th class="text-center"></th>
                            </tr>
                            </thead>
                            <tbody>
                            <?php
                            if ($data != null) {
                                if ($data['status'] == 1) {
                                    foreach ($data['data'] as $row) {

                                        echo '<tr>
                                    <td class="text-center" style="display: none;">' . $row['doc_id'] . '</td>
                                    <td class="text-center">' . $row['doc_titulo'] . '</td>
                                    <td class="text-center">' . $row['tema'] . '</td>
                                    <td class="text-center">' . $row['grup_nombre'] . '</td>
                                    <td class="text-center">' . $row['num_ley'] . '</td>
                                    <td class="text-center">' . $row['doc_autoridad'] . '</td>
                                    <td class="text-center">' . $row['doc_fecha'] . '</td>
                                    <td class="text-center">' . $row['doc_fecha_ro'] . '</td>
                                    <td class="text-center"><button class="btn btn-danger" onclick=\'compradores(this);\'>Compradores</button></td>
                                  </tr>';
                                    }
                                }
                            } ?>
                            </tbody>
                        </table>
                    </div>

                </div>
            </div>
            <!-- /.panel-body -->
        </div>
        <!-- /.panel -->
    </div>
    <!-- /.col-lg-12 -->
</div>
<script src="/speedycep/admin/js/doclegis.js"></script>