<?php

use \App\Controllers\Application;
use \App\Models\Entities\Constants;
use \App\Models\Entities\API;

$apl_con = new Application();
date_default_timezone_set('America/Guayaquil');

$multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/book/get_todo_code/",
    array(), $apl_con->TOKEN);
$data = API::JSON_TO_ARRAY($multi_info_api);
?>

<style>
    .flex-container {
        height: 100%;
        padding: 0;
        margin: 0;
        display: -webkit-box;
        display: -moz-box;
        display: -ms-flexbox;
        display: -webkit-flex;
        display: flex;
        align-items: center;
        justify-content: center;
    }

    .hide_column {
        display: none;
    }
</style>

<div class="row">
    <div class="col-lg-12">
        <h1 class="page-header">Libros premium</h1>
    </div>
    <!-- /.col-lg-12 -->
</div>

<div class="row">
    <div class="col-lg-12">
        <div class="panel panel-default">
            <div class="panel-heading" align="right">
                <button class="btn btn-primary" id="create_btn">Crear libro</button>
            </div>
            <!-- /.panel-heading -->
            <div class="panel-body">

                <div style="width: 100%;">
                    <div class="table-responsive">
                        <table width="100%" class="table table-striped table-bordered table-hover"
                               id="dataTables-book">
                            <thead>
                            <tr>
                                <th class="text-center" style="display: none;">ID</th>
                                <th class="text-center">Titulo</th>
                                <th class="text-center">Resumen</th>
                                <th class="text-center">Autor</th>
                                <th class="text-center">Edición</th>
                                <th class="text-center">Editorial</th>
                                <th class="text-center">Año de edición</th>
                                <th class="text-center">Precio en físico</th>
                                <th class="text-center">Precio en digital</th>
                                <th class="text-center">Enlace digital</th>
                                <th class="text-center">Existencia en físico</th>
                                <th class="text-center">Existencia en digital</th>
                                <th class="text-center">Portada</th>
                                <th class="text-center"></th>
                                <th class="text-center"></th>
                                <th class="text-center"></th>
                                <th class="text-center"></th>
                            </tr>
                            </thead>
                            <tbody>
                            <?php
                            if ($data != null) {
                                if ($data['status'] == 1) {
                                    foreach ($data['data'] as $row) {


                                        $customButton = "<button class=\"btn btn-default\" onclick='noPublicada(this);'>No publicada</button>";
                                        if ($row['publicar'] == "PUBLICADA") {
                                            $customButton = "<button class=\"btn btn-success\" onclick='publicada(this);'>Publicada</button>";
                                        }

                                        echo '<tr>
                                    <td class="text-center">' . $row['id_libro_premium'] . '</td>
                                    <td class="text-center">' . $row['titulo_libro'] . '</td>
                                    <td class="text-center">' . $row['resumen'] . '</td>
                                    <td class="text-center">' . $row['autor'] . '</td>
                                    <td class="text-center">' . $row['edicion'] . '</td>
                                    <td class="text-center">' . $row['editorial'] . '</td>
                                    <td class="text-center">' . $row['annio_edicion'] . '</td>
                                    <td class="text-center">' . $row['precio_fisico'] . '</td>
                                    <td class="text-center">' . $row['precio_ebook'] . '</td>
                                    <td class="text-center"><a href="' . $row['ruta_enlace'] . '">Enlace al libro</a></td>
                                    <td class="text-center">' . $row['existencia_fisica'] . '</td>
                                    <td class="text-center">' . $row['existencia_ebook'] . '</td>
                                    <td class="text-center"><img style="cursor:pointer;" onclick="showPortada(this);" src="' . $row['ruta_portada'] . '?' . rand(1, 1000000) . '" width="48" height="48"></td>
                                    <td class="text-center"><img style="cursor:pointer;" onclick="editBook(this);" src="/speedycep/admin/img/edit_icon.png" width="24" height="24"></td>
                                    <td class="text-center"><img style="cursor:pointer;" onclick="deleteBook(this);" src="/speedycep/admin/img/remove_icon.png" width="24" height="24"></td>
                                    <td class="text-center">' . $customButton . '</td>
                                    <td class="text-center"><button class="btn btn-danger" onclick=\'compradores(this);\'>Compradores</button></td>
                                  </tr>';
                                    }
                                }
                            } ?>
                            </tbody>
                        </table>
                    </div>

                </div>
            </div>
            <!-- /.panel-body -->
        </div>
        <!-- /.panel -->
    </div>
    <!-- /.col-lg-12 -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabel">Creación del libro</h4>
            </div>
            <div id="panel-create" style="display: none;">
                <div class="modal-body">
                    <div class="row">
                        <div class="col-sm-6 flex-container">

                            <div style="width: 300px;height: 300px;border: #eee solid 2px;border-radius: 20px;">

                                <div class="row text-center" style="margin-top: 20px;">
                                    <img src="/speedycep/admin/public/img/upload.png" width="92" height="92"/>
                                </div>
                                <div class="row text-center" style="margin-top: 10px;">
                                    <h4>Libro en digital <br/>Solo archivos .epub</h4>
                                </div>
                                <div class="row text-center" style="margin-top: 5px;">
                                    <h5 style="color: #cc2704;" id="msg_upload_epub">Sin archivo</h5>
                                </div>
                                <div class="row text-center" style="margin-top: 5px;">
                                    <button class="btn btn-info" id="btn_epub">Buscar archivo</button>
                                </div>
                                <div class="row text-center" style="margin-top: 5px;">
                                    <span style="color: #555555;font-family: 'Calibri', 'sans-serif'">Se puede subir un solo archivo max de 2MB.</span>
                                    <input type="file" id="file_upload_epub" name="file_upload_epub" style="display: none"/>
                                </div>

                            </div>

                        </div>
                        <div class="col-sm-6 flex-container">

                            <div style="width: 300px;height: 300px;border: #eee solid 2px;border-radius: 20px;">

                                <div class="row text-center" style="margin-top: 20px;">
                                    <img src="/speedycep/admin/public/img/upload.png" width="92" height="92"/>
                                </div>
                                <div class="row text-center" style="margin-top: 10px;">
                                    <h4>Portada del libro<br/>Imagen 640*640px (.png, jpg)</h4>
                                </div>
                                <div class="row text-center" style="margin-top: 5px;">
                                    <h5 style="color: #cc2704;" id="msg_upload_portada">Sin imagen</h5>
                                </div>
                                <div class="row text-center" style="margin-top: 5px;">
                                    <button class="btn btn-info" id="btn_portada">Buscar portada</button>
                                </div>
                                <div class="row text-center" style="margin-top: 5px;">
                                    <span style="color: #555555;font-family: 'Calibri', 'sans-serif'">Se puede subir un solo archivo max de 2MB.</span>
                                    <input type="file" id="file_upload_portada" name="file_upload_portada" style="display: none;"/>
                                </div>

                            </div>

                        </div>
                    </div>
                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <label>Título</label>
                            <input type="text" class="form-control" id="titulo_libro">
                        </div>
                        <div class="col-sm-6 form-group">
                            <label>Autor</label>
                            <input type="text" class="form-control" id="autor">
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-sm-12 form-group">
                            <label>Resumen</label>
                            <textarea class="form-control" id="resumen"></textarea>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <label>Editorial</label>
                            <input type="text" class="form-control" id="editorial">
                        </div>
                        <div class="col-sm-6 form-group">
                            <label>Edición</label>
                            <input type="text" class="form-control" id="edicion">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <label>Año de edición</label>
                            <input type="number" class="form-control" id="annio_edicion" min="1900"
                                   max="<?php echo date('Y'); ?>">
                        </div>
                        <div class="col-sm-6 form-group">
                            <label>Precio en físico</label>
                            <input type="number" class="form-control" id="precio_fisico" min="0" max="1000" step="0.1">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-12 form-group">
                            <label>Precio en digital (Cuando el precio sea 0, el libro será gratuito y aparecerá en Cep-Reader)</label>
                            <input type="number" class="form-control" id="precio_ebook" min="0" max="1000" step="0.1">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <label>Existencia física</label>
                            <select class="form-control" id="existencia_fisica">
                                <option value="SI">SI</option>
                                <option value="NO">NO</option>
                            </select>
                        </div>
                        <div class="col-sm-6 form-group">
                            <label>Existencia digital</label>
                            <select class="form-control" id="existencia_ebook">
                                <option value="SI">SI</option>
                                <option value="NO">NO</option>
                            </select>
                        </div>
                    </div>


                </div>
                <div align="center" style="display: none;" id="panel-msg-error">
                    <span class="alert alert-danger"><i class="fa fa-warning"></i> <span id="msg_error"></span> </span>
                    <br/><br/>
                </div>
                <div class="modal-footer">
                    <div id="progressContainerUpload" class="progress" style="display: none;">
                        <div id="progressUpload" class="progress-bar progress-bar-striped active" role="progressbar"
                             aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width:0%;">
                            0%
                        </div>
                    </div>
                    <img src="/speedycep/admin/img/loading.gif" width="48" height="36" id="load-extra-gif"
                         style="display: none;"/>
                    <button type="button" id="create-code-btn" class="btn btn-primary">Crear nuevo</button>
                </div>
            </div>
            <div id="load-create" align="center">
                <img src="/speedycep/admin/img/loading.gif" width="64" height="48"/>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>


<!-- Modal -->
<div class="modal fade" id="myModalShowPortada" tabindex="-1" role="dialog" aria-labelledby="myModalLabelPortada"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelPortada">Portada del libro</h4>
            </div>
            <div class="modal-body">
                <img id="img-portada-zoom" width="550" height="640" />
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModalDelete" tabindex="-1" role="dialog" aria-labelledby="myModalLabelDelete"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelDelete">Eliminación del libro</h4>
            </div>
            <div class="modal-body">
                ¿Desea eliminar esté libro?
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                <button type="button" id="delete-code-btn" class="btn btn-primary">Sí</button>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>


<!-- Modal -->
<div class="modal fade" id="myModalNoPublicada" tabindex="-1" role="dialog" aria-labelledby="myModalLabelNoPublicada"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelNoPublicada">Publicar en las notificaciones de la app.</h4>
            </div>
            <div class="modal-body">
                <strong>Información:</strong>
                <p>
                    Al publicar el libro este pasa a ser una notificación de app, hasta que se quite está opción.
                    <br/><br/>
                    ¿Deseas publicar esté ítem?
                </p>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                <button type="button" id="publicar-code-btn" class="btn btn-primary">Publicar</button>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModalPublicada" tabindex="-1" role="dialog" aria-labelledby="myModalLabelPublicada"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelPublicada">Quitar publicación de las notificaciones.</h4>
            </div>
            <div class="modal-body">
                <p>
                    ¿Quitar la publicación?
                </p>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                <button type="button" id="unpublicar-code-btn" class="btn btn-primary">Si</button>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<script>
    var mc = "/speedycep/admin/application/manipulate_book/";
    var ec = "/speedycep/admin/application/edit_book/";
    var dc = "/speedycep/admin/application/delete_book/";
    var ch = "/speedycep/admin/application/change_port_book/";
    var npub = "/speedycep/admin/application/not_publish_book/";
    var rpub = "/speedycep/admin/application/remove_publish_book/";
</script>
<script src="/speedycep/admin/js/libro.js"></script>