<?php

use \App\Controllers\Application;
use \App\Models\Entities\Constants;
use \App\Models\Entities\API;

$apl_con = new Application();
date_default_timezone_set('America/Guayaquil');

$api_data_book = API::POST_SERVER(Constants::PATH_API() . "/book/get_info_book_by_code/",
    array("id" => $id), $apl_con->TOKEN);

$multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/book/get_buyer/",
    array("id" => $id), $apl_con->TOKEN);
$data = API::JSON_TO_ARRAY($multi_info_api);
$data_book = API::JSON_TO_ARRAY($api_data_book);
?>
<div class="row">
    <div class="col-lg-12 page-header">
        <table >
            <tr>
                <td>Datos del libro: &nbsp;</td>
                <td align="left"><?php echo $data_book['data']['titulo_libro'];?></td>
                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Año de edición: &nbsp;</td>
                <td align="left"><?php echo $data_book['data']['annio_edicion'];?></td>
            </tr>
            <tr>
                <td>Autor: &nbsp;</td>
                <td align="left"><?php echo $data_book['data']['autor'];?></td>
                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Edición: &nbsp;</td>
                <td align="left"><?php echo $data_book['data']['edicion'];?></td>
            </tr>
            <tr>
                <td>Editorial: &nbsp;</td>
                <td align="left"><?php echo $data_book['data']['editorial'];?></td>
                <td colspan="2"></td>
            </tr>
        </table>
        <h1 class="">Usuarios compradores</h1>
    </div>
    <!-- /.col-lg-12 -->
</div>

<div class="row">
    <div class="col-lg-12">
        <div class="panel panel-default">
            <div class="panel-heading" align="left">
                <button class="btn btn-primary" id="back_btn">Volver atrás</button>
            </div>
            <!-- /.panel-heading -->
            <div class="panel-body">

                <div style="width: 100%;">
                    <div class="table-responsive">
                        <table width="100%" class="table table-striped table-bordered table-hover"
                               id="dataTables-content-compradores">
                            <thead>
                            <tr>
                                <th class="text-center" style="display: none;">ID</th>
                                <th class="text-center">Número de Ref</th>
                                <th class="text-center">Cédula</th>
                                <th class="text-center">Nombres</th>
                                <th class="text-center">Apellidos</th>
                                <th class="text-center">Tipo de compra</th>
                                <th class="text-center">Pais</th>
                                <th class="text-center">Ciudad</th>
                                <th class="text-center">Dirección</th>
                                <th class="text-center">Teléfono</th>
                                <th class="text-center">Fecha de compra</th>
                                <th class="text-center">Email</th>
                                <th class="text-center">Pago</th>
                                <th class="text-center"></th>
                            </tr>
                            </thead>
                            <tbody>
                            <?php
                            if ($data != null) {
                                if ($data['status'] == 1) {
                                    foreach ($data['data'] as $row) {

                                        $custom_btn = "<button class=\"btn btn-danger\" onclick='detalles_fisico(this,\"" . $id . "\");'>Detalles de envío</button>";

                                        if ($row['tipo_compra'] == "EBOOK") {
                                            //$custom_btn = "<button class=\"btn btn-warning\" onclick='detalles_ebook(this);'>Reenviar al email</button>";
                                            $custom_btn = "<button class=\"btn btn-warning\">Libro digital</button>";
                                        }

                                        echo '<tr>
                                    <td class="text-center" style="display: none;">' . $row['id_usuario_comprador'] . '</td>
                                    <td class="text-center">' . $row['numero_referencia'] . '</td>
                                    <td class="text-center">' . $row['cedula_envio'] . '</td>
                                    <td class="text-center">' . $row['nombres_envio'] . '</td>
                                    <td class="text-center">' . $row['apellidos_envio'] . '</td>
                                    <td class="text-center">' . $row['tipo_compra'] . '</td>
                                    <td class="text-center">' . $row['pais_envio'] . '</td>
                                    <td class="text-center">' . $row['ciudad_envio'] . '</td>
                                    <td class="text-center">' . $row['direccion_envio'] . '</td>
                                    <td class="text-center">' . $row['telefono_envio'] . '</td>
                                    <td class="text-center">' . $row['fecha_compra'] . '</td>
                                    <td class="text-center">' . $row['email_envio'] . '</td>
                                    <td class="text-center">$' . $row['precio_compra'] . '</td>
                                    <td class="text-center">' . $custom_btn . '</td>
                                    </tr>';
                                    }
                                }
                            }
                            ´ ?>
                            </tbody>
                        </table>
                    </div>
                </div>

            </div>
            <!-- /.panel-body -->
        </div>
        <!-- /.panel -->
    </div>
    <!-- /.col-lg-12 -->
</div>

<script src="/speedycep/admin/js/libro_user_buyer.js"></script>

