<?php

use \App\Controllers\Application;
use \App\Models\Entities\Constants;
use \App\Models\Entities\API;

$apl_con = new Application();
date_default_timezone_set('America/Guayaquil');


$api_data_user = API::POST_SERVER(Constants::PATH_API() . "/book/get_user_data_buyer/",
    array("id" => $id), $apl_con->TOKEN);

$multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/book/get_buyer_details/",
    array("id" => $id), $apl_con->TOKEN);
$data = API::JSON_TO_ARRAY($multi_info_api);
$data_user = API::JSON_TO_ARRAY($api_data_user);
?>
<div class="row">
    <div class="col-lg-12 page-header">
        <div align="right">
            <table>
                <tr>
                    <td>Dirección de envío: &nbsp;</td>
                    <td align="right"><?php echo $data_user['data']['nombres_envio'] . " " . $data_user['data']['apellidos_envio']; ?></td>
                </tr>
                <tr>
                    <td></td>
                    <td align="right"><?php echo $data_user['data']['direccion_envio']; ?></td>
                </tr>
                <tr>
                    <td></td>
                    <td align="right"><?php echo $data_user['data']['ciudad_envio']; ?></td>
                </tr>
                <tr>
                    <td></td>
                    <td align="right"><?php echo $data_user['data']['pais_envio']; ?></td>
                </tr>
            </table>
        </div>
        <h1 class="">
            Detalles del envío N#<?php echo $data_user['data']['numero_referencia']; ?>
        </h1>
    </div>
    <!-- /.col-lg-12 -->
</div>

<div class="row">
    <div class="col-lg-12">
        <div class="panel panel-default">
            <div class="panel-heading" align="left">
                <button class="btn btn-primary" id="back_btn" data-text="<?php echo $id_ant; ?>">Volver atrás</button>
                <button class="btn btn-primary" id="update_details_btn" style="float: right;">Actualizar Detalle
                </button>
            </div>
            <!-- /.panel-heading -->
            <div class="panel-body">
                <table width="100%" class="table table-striped table-bordered table-hover"
                       id="dataTables-content-details">
                    <thead>
                    <tr>
                        <th class="text-center" style="display: none;"></th>
                        <th class="text-center">Estado del envío</th>
                        <th class="text-center">Fecha de actualización</th>
                        <th class="text-center">Observación</th>
                    </tr>
                    </thead>
                    <tbody>
                    <?php
                    if ($data != null) {
                        if ($data['status'] == 1) {
                            foreach ($data['data'] as $row) {
                                $date_actualizacion = new \DateTime($row['fecha_actualizacion']);
                                echo '<tr>
                                    <td class="text-center" style="display: none;"></td>
                                    <td class="text-center">' . $row['estado_envio'] . '</td>
                                    <td class="text-center">' . $date_actualizacion->format('m/d/Y H:i:s') . '</td>
                                    <td class="text-center">' . $row['observacion'] . '</td>
                                    </tr>';
                            }
                        }
                    }
                    ?>
                    </tbody>
                </table>
            </div>
            <!-- /.panel-body -->
        </div>
        <!-- /.panel -->
    </div>
    <!-- /.col-lg-12 -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModalActualizar" data-text="<?php echo $id;?>" tabindex="-1" role="dialog" aria-labelledby="myModalLabelActualizar"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelActualizar">Actualizar detalle del envío.</h4>
            </div>
            <div class="modal-body">
                <div class="form-group">
                    <label>Estado</label>
                    <select class="form-control" id="estado_envio">
                        <option value="INFORMACION RECIBIDA">INFORMACION RECIBIDA</option>
                        <option value="PREPARANDO ENVIO">PREPARANDO ENVIO</option>
                        <option value="ENVIADO">ENVIADO</option>
                        <option value="OTROS">OTROS</option>
                    </select>
                </div>
                <div class="form-group">
                    <label>Observaciones</label>
                    <textarea class="form-control" id="observacion"></textarea>
                </div>

            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                <button type="button" id="act-book-user-details-btn" class="btn btn-primary">Actualizar</button>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>


<script>
    var updub = "/speedycep/admin/application/update_details_user_book/";
</script>
<script src="/speedycep/admin/js/libro_user_details.js"></script>

