<?php

use \App\Controllers\Application;
use \App\Models\Entities\Constants;
use \App\Models\Entities\API;

$apl_con = new Application();
date_default_timezone_set('America/Guayaquil');

?>
<!-- DataTables Responsive CSS -->
<div class="row">
    <div class="col-lg-12">
        <h1 class="page-header">Ajustes de precios</h1>
    </div>
    <!-- /.col-lg-12 -->
</div>

<div class="row">
    <div class="col-lg-12">
        <div class="panel panel-default">
            <div class="panel-heading" align="right">
                <img id="loading_text" src="/speedycep/admin/public/img/loading2.gif" width="24" height="24" style="display: none;"/>
                <button class="btn btn-primary" id="save_btn">Guardar cambios</button>
            </div>
            <div class="panel-body">
                <div class="row">
                    <div class="col-sm-12 form-group">
                        <h4 class="page-header">Precio base para las leyes</h4>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 form-group">
                        <label>Precio de la ley</label>
                        <input type="number" data-title="Precio de la ley" class="form-control" value="<?php echo $data[0]['law_price'];?>" id="law_price" min="0" max="100">
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 form-group">
                        <label>¿Cada cuantas filas (artículos) se multiplica el precio de la ley?</label>
                        <input type="number" data-title="¿Cada cuantas filas se multiplica el precio de la ley?" value="<?php echo $data[0]['law_row_quantity'];?>" class="form-control" id="law_row_quantity" min="0" max="10000">
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 form-group">
                        <h4 class="page-header">Precio fijo para los envíos</h4>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 form-group">
                        <label>En territorio ecuatoriano</label>
                        <input type="number" data-title="En territorio ecuatoriano" class="form-control" value="<?php echo $data[0]['domestic_shipping_price'];?>" id="domestic_shipping" min="0" max="100">
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 form-group">
                        <label>En América</label>
                        <input type="number" data-title="En america" class="form-control" value="<?php echo $data[0]['america_shipping_price'];?>" id="america_shipping_price" min="0" max="100">
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 form-group">
                        <label>Internacionales</label>
                        <input type="number" data-title="Internacionales" class="form-control" value="<?php echo $data[0]['international_shipping_price'];?>" id="international_shipping_price" min="0" max="100">
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 form-group">
                        <h4 class="page-header">Precio base para los tipos de suscripciones disponibles</h4>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 form-group">
                        <label>Suscripción mensual</label>
                        <input type="number" data-title="Suscripción mensual" class="form-control" value="<?php echo $data[0]['monthly_subscription_price'];?>" id="monthly_subscription_price" min="0" max="100">
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 form-group">
                        <label>Suscripción anual</label>
                        <input type="number" data-title="Suscripción anual" class="form-control" value="<?php echo $data[0]['anual_subscription_price'];?>" id="anual_subscription_price" min="0" max="100">
                    </div>
                </div>
            </div>

            <!-- /.panel-body -->
        </div>
        <!-- /.panel -->
    </div>
    <!-- /.col-lg-12 -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModalConfirm" tabindex="-1" role="dialog" aria-labelledby="myModalLabelConfirm"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalConfirm">Verificación de seguridad</h4>
            </div>
            <div class="modal-body">
                <div class="form-group">
                    <label>Introduzca la clave especial</label>
                    <input type="password" class="form-control"  id="seguridad_password" maxlength="20"/>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                <button type="button" id="verify-code-btn" class="btn btn-primary">Verificar</button>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<script>
    var up = "/speedycep/admin/application/change_setting_app/";
</script>
<script src="/speedycep/admin/public/js/setting_app.js"></script>
