<?php

use \App\Controllers\Application;
use \App\Models\Entities\Constants;
use \App\Models\Entities\API;

$apl_con = new Application();
date_default_timezone_set('America/Guayaquil');

$multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/seminary/get_todo_code/",
    array(), $apl_con->TOKEN);
$data = API::JSON_TO_ARRAY($multi_info_api);
?>

<style>
    .flex-container {
        height: 100%;
        padding: 0;
        margin: 0;
        display: -webkit-box;
        display: -moz-box;
        display: -ms-flexbox;
        display: -webkit-flex;
        display: flex;
        align-items: center;
        justify-content: center;
    }
</style>

<div class="row">
    <div class="col-lg-12">
        <h1 class="page-header">Seminarios - Talleres</h1>
    </div>
    <!-- /.col-lg-12 -->
</div>

<div class="row">
    <div class="col-lg-12">
        <div class="panel panel-default">
            <div class="panel-heading" align="right">
                <button class="btn btn-primary" id="create_btn">Crear nuevo</button>
            </div>
            <!-- /.panel-heading -->
            <div class="panel-body">

                <div style="width: 100%;">
                    <div class="table-responsive">
                        <table width="100%" class="table table-striped table-bordered table-hover"
                               id="dataTables-seminary">
                            <thead>
                            <tr>
                                <th class="text-center" style="display: none;">ID</th>
                                <th class="text-center">Tipo</th>
                                <th class="text-center">Titulo</th>
                                <th class="text-center">Lugar</th>
                                <th class="text-center">Fecha desde</th>
                                <th class="text-center">Fecha hasta</th>
                                <th class="text-center">Horario</th>
                                <th class="text-center">Inversión</th>
                                <th class="text-center">Contacto</th>
                                <th class="text-center">Extra</th>
                                <th class="text-center">Portada</th>
                                <th class="text-center"></th>
                                <th class="text-center"></th>
                                <th class="text-center"></th>
                                <th class="text-center"></th>
                            </tr>
                            </thead>
                            <tbody>
                            <?php
                            if ($data != null) {
                                if ($data['status'] == 1) {
                                    foreach ($data['data'] as $row) {
                                        $dd = "";
                                        if ($row['fecha_desde'] != "") {
                                            $date_desde = new \DateTime($row['fecha_desde']);
                                            $dd = $date_desde->format('m/d/Y');
                                        }

                                        $dh= "";
                                        if ($row['fecha_hasta'] != "") {
                                            $date_hasta = new \DateTime($row['fecha_hasta']);
                                            $dh = $date_hasta->format('m/d/Y');
                                        }

                                        $customButton = "<button class=\"btn btn-default\" onclick='noPublicada(this);'>No publicada</button>";
                                        if ($row['publicar'] == "PUBLICADA") {
                                            $customButton = "<button class=\"btn btn-success\" onclick='publicada(this);'>Publicada</button>";
                                        }

                                        echo '<tr>
                                    <td class="text-center" style="display: none;">' . $row['id_taller_sem'] . '</td>
                                    <td class="text-center">' . $row['tipo_taller_sem'] . '</td>
                                    <td class="text-center">' . $row['titulo_taller_sem'] . '</td>
                                    <td class="text-center">' . $row['lugar'] . '</td>
                                    <td class="text-center">' . $dd . '</td>
                                    <td class="text-center">' . $dh . '</td>
                                    <td class="text-center">' . $row['horario'] . '</td>
                                    <td class="text-center">' . $row['inversion'] . '</td>
                                    <td class="text-center">' . $row['telefono'] . '</td>
                                    <td class="text-center">' . $row['extra'] . '</td>
                                    <td class="text-center"><img style="cursor:pointer;" onclick="showPortada(this);" src="' . $row['portada_path'] . '?' . rand(1, 1000000) . '" width="48" height="48"></td>
                                    <td class="text-center"><img style="cursor:pointer;" onclick="editSeminary(this);" src="/speedycep/admin/img/edit_icon.png" width="24" height="24"></td>
                                    <td class="text-center"><img style="cursor:pointer;" onclick="deleteSeminary(this);" src="/speedycep/admin/img/remove_icon.png" width="24" height="24"></td>
                                    <td class="text-center">' . $customButton . '</td>
                                    <td class="text-center"><button class="btn btn-danger" onclick=\'registrados(this);\'>Registrados</button></td>
                                   </tr>';
                                    }
                                }
                            }
                            ?>
                            </tbody>
                        </table>
                    </div>
                </div>

            </div>
            <!-- /.panel-body -->
        </div>
        <!-- /.panel -->
    </div>
    <!-- /.col-lg-12 -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabel">Creación del taller - seminario</h4>
            </div>
            <div id="panel-create" style="display: none;">
                <div class="modal-body">

                    <div class="row">
                        <div class="col-sm-12 flex-container">
                            <div style="width: 300px;height: 300px;border: #eee solid 2px;border-radius: 20px;">

                                <div class="row text-center" style="margin-top: 20px;">
                                    <img src="/speedycep/admin/public/img/upload.png" width="92" height="92"/>
                                </div>
                                <div class="row text-center" style="margin-top: 10px;">
                                    <h4>Portada<br/>Imagen 640*640px (.png, jpg)</h4>
                                </div>
                                <div class="row text-center" style="margin-top: 5px;">
                                    <h5 style="color: #cc2704;" id="msg_upload_portada">Sin imagen</h5>
                                </div>
                                <div class="row text-center" style="margin-top: 5px;">
                                    <button class="btn btn-info" id="btn_portada">Buscar portada</button>
                                </div>
                                <div class="row text-center" style="margin-top: 5px;">
                                    <span style="color: #555555;font-family: 'Calibri', 'sans-serif'">Se puede subir un solo archivo max de 2MB.</span>
                                    <input type="file" id="file_upload_portada" name="file_upload_portada" style="display: none;"/>
                                </div>

                            </div>
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <label>Tipo</label>
                            <select class="form-control" id="tipo_taller_sem">
                                <option value="SEMINARIO">Seminario</option>
                                <option value="TALLER">Taller</option>
                                <option value="CURSO">Curso</option>
                                <option value="PUBLICIDAD">Publicidad</option>
                            </select>
                        </div>
                        <div class="col-sm-6 form-group">
                            <label>Título</label>
                            <input type="text" class="form-control" id="titulo_taller_sem" placeholder="Ej: Seminario de investigación I">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <label>Lugar</label>
                            <input type="text" class="form-control" id="lugar" placeholder="Ej: Centro de Arte LFC, Gquil.">
                        </div>
                        <div class="col-sm-6 form-group">
                            <label>Fecha desde</label>
                            <input type="date" class="form-control" id="fecha_desde" min="<?php echo date('Y-m-d'); ?>">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <label>Fecha hasta</label>
                            <input type="date" class="form-control" id="fecha_hasta" min="<?php echo date('Y-m-d'); ?>"
                                   disabled>
                        </div>
                        <div class="col-sm-6 form-group">
                            <label>Horario</label>
                            <input type="text" class="form-control" id="horario" placeholder="ej: de 8 a 10 de la noche">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-6 form-group">
                            <label>Inversión $</label>
                            <input type="number" class="form-control" id="inversion" step=".01" placeholder="ej: 10.0">
                        </div>
                        <div class="col-sm-6 form-group">
                            <label>Contacto - teléfono</label>
                            <input type="tel" class="form-control" id="telefono" placeholder="0985678910">
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-sm-12 form-group">
                            <label id="link_copy">Información extra</label>
                            <textarea class="form-control" id="extra"></textarea>
                        </div>
                    </div>

                </div>

                <div align="center" style="display: none;" id="panel-msg-error">
                    <span class="alert alert-danger"><i class="fa fa-warning"></i> <span id="msg_error"></span> </span>
                    <br/><br/>
                </div>
                <div class="modal-footer">
                    <div id="progressContainerUpload" class="progress" style="display: none;">
                        <div id="progressUpload" class="progress-bar progress-bar-striped active" role="progressbar"
                             aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width:0%;">
                            0%
                        </div>
                    </div>
                    <img src="/speedycep/admin/img/loading.gif" width="48" height="36" id="load-extra-gif"
                         style="display: none;"/>
                    <button type="button" id="create-code-btn" class="btn btn-primary">Crear nuevo</button>
                </div>
            </div>
            <div id="load-create" align="center">
                <img src="/speedycep/admin/img/loading.gif" width="64" height="48"/>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>


<!-- Modal -->
<div class="modal fade" id="myModalShowPortada" tabindex="-1" role="dialog" aria-labelledby="myModalLabelPortada"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelPortada">Portada</h4>
            </div>
            <div class="modal-body">
                <img id="img-portada-zoom" width="550" height="640" />
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModalDelete" tabindex="-1" role="dialog" aria-labelledby="myModalLabelDelete"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelDelete">Eliminación del taller - seminario</h4>
            </div>
            <div class="modal-body">
                ¿Desea eliminar esté taller - seminario?
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                <button type="button" id="delete-code-btn" class="btn btn-primary">Sí</button>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModalNoPublicada" tabindex="-1" role="dialog" aria-labelledby="myModalLabelNoPublicada"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelNoPublicada">Publicar en las notificaciones de la app.</h4>
            </div>
            <div class="modal-body">
                <strong>Información:</strong>
                <p>
                    Al publicar el seminario, taller o curso este pasa a ser una notificación de app, hasta que expiré su fecha de culminación.
                    <br/><br/>
                    ¿Deseas publicar esté ítem?
                </p>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                <button type="button" id="publicar-code-btn" class="btn btn-primary">Publicar</button>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModalPublicada" tabindex="-1" role="dialog" aria-labelledby="myModalLabelPublicada"
     aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelPublicada">Quitar publicación de las notificaciones.</h4>
            </div>
            <div class="modal-body">
                <p>
                    ¿Quitar la publicación?
                </p>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
                <button type="button" id="unpublicar-code-btn" class="btn btn-primary">Si</button>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<!-- Modal -->
<div class="modal fade" id="myModalRegistrados" tabindex="-1" role="dialog" aria-labelledby="myModalLabelRegistrados"
     aria-hidden="true">
    <div class="modal-dialog" style="width:80%; max-width: 70%;">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabelRegistrados">Personas registradas</h4>
            </div>
            <div class="modal-body">
                <div align="center" id="img-load-registrados">
                    <img src="/speedycep/admin/img/loading.gif" width="64" height="48"/>
                </div>
                <div id="content-registrados" style="display: none;">

                    <div style="width: 100%;">
                        <div class="table-responsive">
                            <table width="100%" class="table table-striped table-bordered table-hover"
                                   id="dataTables-content-registrados">
                                <thead>
                                <tr>
                                    <th class="text-center" style="display: none;">ID</th>
                                    <th class="text-center">Email</th>
                                    <th class="text-center">Cédula</th>
                                    <th class="text-center">Nombres</th>
                                    <th class="text-center">Apellidos</th>
                                    <th class="text-center">Sexo</th>
                                    <th class="text-center">País</th>
                                    <th class="text-center">Ciudad</th>
                                    <th class="text-center">Dirección</th>
                                    <th class="text-center">Teléfono</th>
                                    <th class="text-center">Monto</th>
                                    <th class="text-center">Estado</th>
                                </tr>
                                </thead>
                                <tbody>

                                </tbody>
                            </table>
                        </div>
                    </div>


                </div>
                <br/>
                <div align="center" style="display: none;" id="panel-msg-error-registrados">
                    <span class="alert alert-danger"><i class="fa fa-warning"></i> <span
                                id="msg_error_registrados"></span> </span>
                    <br/><br/>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancelar</button>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>

<script>
    var mc = "/speedycep/admin/application/manipulate_seminary/";
    var ec = "/speedycep/admin/application/edit_seminary/";
    var dc = "/speedycep/admin/application/delete_seminary/";
    var ch = "/speedycep/admin/application/change_port_seminary/";
    var npub = "/speedycep/admin/application/not_publish_seminary/";
    var rpub = "/speedycep/admin/application/remove_publish_seminary/";
    var lus = "/speedycep/admin/application/load_users_seminary/";
</script>
<script src="/speedycep/admin/js/taller_seminario.js"></script>