<?php

namespace Core;
defined("APPPATH") OR die("Access denied");
session_start();

/*if (!isset($_SESSION['auth_secret'])
    || !password_verify($_SESSION['authoricatequesis'], $_SESSION['auth_secret'])
) {
    header('location: /index.php');
}*/

class App
{

    protected $controller;

    protected $method = "index";

    protected $params = [];

    const NAMESPACE_CONTROLLERS = "\App\Controllers\\";

    const CONTROLLERS_PATH = APPPATH. "/Controllers/";



    public function __construct()
    {
        //obtenemos la url parseada
        $url = $this->parseUrl();
        //comprobamos que exista el archivo en el directorio controllers
        if (file_exists(self::CONTROLLERS_PATH . ucfirst($url[0]) . ".php")) {
            //nombre del archivo a llamar
            $this->controller = ucfirst($url[0]);
            //eliminamos el controlador de url, así sólo nos quedaran los parámetros del método
            unset($url[0]);
        } else {
            include APPPATH . "/Views/Errors/404.php";
            exit;
        }

        $fullClass = self::NAMESPACE_CONTROLLERS . $this->controller;

        //asociamos la instancia a $this->controller
        $this->controller = new $fullClass;

        //si existe el segundo segmento comprobamos que el método exista en esa clase
        if (isset($url[1])) {

            //aquí tenemos el método
            $this->method = $url[1];
            if (method_exists($this->controller, $url[1])) {
                //eliminamos el método de url, así sólo nos quedaran los parámetros del método
                unset($url[1]);
            } else {
                include APPPATH . "/Views/Errors/405.php";
                exit;
            }
        }
        //asociamos el resto de segmentos a $this->params para pasarlos al método llamado, por defecto será un array vacío
        $this->params = $url ? array_values($url) : [];

    }

    /**
     * [parseUrl Parseamos la url en trozos]
     * @return [type] [description]
     */
    public function parseUrl()
    {
        if (isset($_GET["url"])) {
            return explode("/", filter_var(rtrim($_GET["url"], "/"), FILTER_SANITIZE_URL));
        }
    }

    /**
     * [render  lanzamos el controlador/método que se ha llamado con los parámetros]
     */
    public function render()
    {
        call_user_func_array([$this->controller, $this->method], $this->params);
    }

    /**
     * [getConfig Obtenemos la configuración de la app]
     * @return [Array] [Array con la config]
     */
    public static function getConfig()
    {
        return parse_ini_file(APPPATH . '/Config/config.ini');
    }

    /**
     * @return mixed
     */
    public function getController()
    {
        return $this->controller;
    }

    /**
     * @return string
     */
    public function getMethod()
    {
        return $this->method;
    }

    /**
     * @return array
     */
    public function getParams()
    {
        return $this->params;
    }


}