var SUCCESS = 1;

var datable = $('#dataTables-basic-norm').DataTable({
    responsive: true,
    columnDefs: [
        {className: 'text-center', targets: [0, 1]}
    ],
    "processing": true,
    "serverSide": true,
    "info": true,
    "ajax":
        {
            "url": "/speedycep/admin/application/doc_data/"
        },
    "columns": [
        {"data": "doc_id"},
        {"data": "doc_titulo"}
    ]
});

$(document).ready(function () {


    $('#dataTables-basic-norm tbody').on('click', 'tr', function () {
        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        } else {
            datable.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');
        }
    });

    $('#add-code-btn').click(function () {
        let form_data = datable.rows('.selected').data();
        $.each(form_data, function (key, value) {
            let doc_id = value.doc_id;
            let doc_titulo = value.doc_titulo;

            var flag = true;
            $(".iterable").each(function (k, v) {
                var id = $(v).attr("id").split("_")[1];
                if (id === doc_id) {
                    flag = false;
                }
            });

            if (flag) {
                $("#documents-container").append("<div id='id_" + doc_id + "' class='iterable'> <div class='col-lg-11'><label class='container' >" + doc_titulo + "<input type='checkbox'><span class='checkmark'></span></label></div>  <div class='col-lg-1'><img onclick='removeItem(this);' src='/speedycep/admin/public/img/remove_icon.png' style='cursor:pointer;' width='24' height='24' /></div></div>");
                $("#myModalSearch").modal('hide');
            } else {
                alert("ya existe no se puede agregar");
            }

        });
    });

    $("#save_btn").on("click", function () {
        var array = [];
        $("input:checkbox").each(function () {
            let checked = $(this).is(':checked');
            let id = $(this).parent().parent().parent().attr("id").split("_")[1];
            let name = $.trim($(this).parent().parent().text());
            //console.log("id: " + id + " name: " + name+ " checked: " + checked);
            array.push({
                id: id,
                name: name,
                active: checked
            });
        });

        let json = JSON.stringify(array);

        $.post(up, {
            json: json
        }).done(function (data) {
            if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                let dataJSON = $.parseJSON(data);
                if (dataJSON.status === SUCCESS) {
                    alert(dataJSON.message);
                }
            } else {
                alert(data);
            }
        });

    });

    $("#search_btn").on("click", function () {
        $("#myModalSearch").modal('show');
    });
});

function removeItem(img) {

    if (confirm("¿Desea eliminar está norma o ley?")) {

        $(img).parent().parent().remove();

    }
}