var SUCCESS = 1;
var idx = 0;
var tr = null;
var datable = $('#dataTables-code-promotional').DataTable({
    dom: 'lBfrtip',
    buttons: [
        'copyHtml5',
        'excelHtml5'
    ],
    lengthMenu: [5, 10, 20, 50, 100, 200, 500],
    responsive: true,
    columnDefs: [
        {className: 'text-center', targets: [0, 1, 2, 3, 4, 5]},
    ],
    "processing": true,
    "serverSide": true,
    "info": true,
    "ajax":
        {
            "url": "/speedycep/admin/application/cod_promotional_data/"
        },
    "columns": [
        {"data": "codigo"},
        {"data": "duracion"},
        {"data": "fecha_inicial"},
        {"data": "estado"},
        {"data": "edit"},
        {"data": "delete"}
    ],
    "order": [[ 2, "desc" ]]
});
$(document).ready(function () {

    $("#multiple_btn").on('click', function () {
        $("#myModalMultiple").modal('show');
    });

    $("#create_btn").on('click', function () {
        $("#load-create").show();
        $("#panel-create").hide();
        $("#myModal").modal('show');
        $.post(gcp)
            .done(function (data) {
                $("#load-create").hide();
                $("#panel-create").show();
                $("#codigo").val(data);
            });
    });

    $("#auto-generate-btn").on('click', function () {
        $("#create-code-btn").attr("disabled", true);
        $("#load-extra-gif").show();
        $.post(gcp)
            .done(function (data) {
                $("#codigo").val(data);
                $("#load-extra-gif").hide();
                $("#create-code-btn").removeAttr("disabled");
            });
    });

    $("#create-multiple-code-btn").on('click', function () {
        $("#create-multiple-code-btn").attr("disabled", true);
        $("#select_count_code_promotional").attr("disabled", true);
        $("#duracion_codes").attr("disabled", true);
        $("#load-multiple-extra-gif").show();
        $.post(mmc, {
            count_code_promotional: $("#select_count_code_promotional").val(),
            duracion_codes: $("#duracion_codes").val()
        })
            .done(function (data) {
                //console.log("data: " + data);
                if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                    let dataJSON = $.parseJSON(data);
                    if (dataJSON.status === SUCCESS) {
                        $("#create-multiple-code-btn").removeAttr("disabled");
                        $("#load-multiple-extra-gif").hide();
                        $("#myModalMultiple").modal('hide');
                        $("#select_count_code_promotional").removeAttr("disabled");
                        $("#duracion_codes").removeAttr("disabled");

                        $('#dataTables-code-promotional').DataTable().clear();
                        $('#dataTables-code-promotional').DataTable().ajax.reload();

                        //for (let i = 0; i < dataJSON.data.length; i++) {

                            /*console.log("dataJSON.data[" + 0 + "]: " + dataJSON.data[0].codigo);
                            var date_inicial = new Date(dataJSON.data[0].fecha_inicial);

                            var rowIndex = $('#dataTables-code-promotional').dataTable().fnAddData([
                                dataJSON.data[0].codigo,
                                dataJSON.data[0].duracion,
                                getM((date_inicial.getMonth() + 1) + "/" + date_inicial.getDate() + "/" + date_inicial.getFullYear()),
                                dataJSON.data[0].estado,
                                "<img style=\"cursor:pointer;\" onclick=\"editCode(this);\" src=\"/speedycep/admin/img/edit_icon.png\" width=\"24\" height=\"24\">",
                                "<img style=\"cursor:pointer;\" onclick=\"deleteCode(this);\" src=\"/speedycep/admin/img/remove_icon.png\" width=\"24\" height=\"24\">",
                            ]);

                            var row = $('#dataTables-code-promotional').dataTable().fnGetNodes(rowIndex);
                            for (var k = 0; k < 6; k++) {
                                $(row).find("td:eq(" + k + ")").addClass("text-center");
                            }*/

                        //}


                    }
                } else {
                    $("#load-multiple-extra-gif").hide();
                    $("#msg_multiple_error").text(data);
                    $("#load-multiple-extra-gif").fadeIn(1000).fadeOut(3000);
                    setTimeout(function () {
                        $("#select_count_code_promotional").removeAttr("disabled");
                        $("#duracion_codes").removeAttr("disabled");
                        $("#create-multiple-code-btn").removeAttr("disabled");
                    }, 4000);
                }
            });
    });


    $("#create-code-btn").on('click', function () {
        $("#create-code-btn").attr("disabled", true);
        $("#load-extra-gif").show();
        $.post(mc, {duration: $("#duracion").val(), code: $("#codigo").val()})
            .done(function (data) {
                if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                    let dataJSON = $.parseJSON(data);
                    if (dataJSON.status === SUCCESS) {
                        $("#create-code-btn").removeAttr("disabled");
                        $("#load-extra-gif").hide();
                        $("#myModal").modal('hide');

                        $('#dataTables-code-promotional').DataTable().clear();
                        $('#dataTables-code-promotional').DataTable().ajax.reload();

                        /*var date_inicial = new Date(dataJSON.data.fecha_inicial);
                        var rowIndex = $('#dataTables-code-promotional').dataTable().fnAddData([
                            $("#codigo").val(),
                            dataJSON.data.duracion,
                            getM((date_inicial.getMonth() + 1) + "/" + date_inicial.getDate() + "/" + date_inicial.getFullYear()),
                            dataJSON.data.estado,
                            "<img style=\"cursor:pointer;\" onclick=\"editCode(this);\" src=\"/speedycep/admin/img/edit_icon.png\" width=\"24\" height=\"24\">",
                            "<img style=\"cursor:pointer;\" onclick=\"deleteCode(this);\" src=\"/speedycep/admin/img/remove_icon.png\" width=\"24\" height=\"24\">",
                        ]);

                        var row = $('#dataTables-code-promotional').dataTable().fnGetNodes(rowIndex);
                        for (var i = 0; i < 7; i++) {
                            $(row).find("td:eq(" + i + ")").addClass("text-center");
                        }*/
                    }
                } else {
                    $("#load-extra-gif").hide();
                    $("#msg_error").text(data);
                    $("#panel-msg-error").fadeIn(1000).fadeOut(3000);
                    setTimeout(function () {
                        $("#create-code-btn").removeAttr("disabled");
                    }, 4000);
                }
            });
    });

    $("#edit-code-btn").on('click', function () {
        $("#edit-code-btn").attr("disabled", true);
        $("#load-extra-gif-edit").show();

        $.post(ec, {
            duration: $("#duracion_edit").val(),
            code: $("#codigo_edit").val()
        })
            .done(function (data) {
                if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                    let dataJSON = $.parseJSON(data);
                    if (dataJSON.status === SUCCESS) {
                        $("#edit-code-btn").removeAttr("disabled");
                        $("#load-extra-gif-edit").hide();
                        $("#myModalEdit").modal('hide');

                        var date_inicial = new Date(dataJSON.data.fecha_inicial);
                        datable.cell(idx, 1).data(dataJSON.data.duracion).draw();
                        datable.cell(idx, 2).data(getM((date_inicial.getMonth() + 1)) + "/" + date_inicial.getDate() + "/" + date_inicial.getFullYear()).draw();
                        datable.cell(idx, 3).data(dataJSON.data.estado).draw();
                        tr.fadeOut(1000).fadeIn(1000);

                    }
                } else {
                    $("#load-extra-gif-edit").hide();
                    $("#msg_error_edit").text(data);
                    $("#panel-msg-error-edit").fadeIn(1000).fadeOut(3000);
                    setTimeout(function () {
                        $("#edit-code-btn").removeAttr("disabled");
                    }, 4000);
                }

            });
    });


    $("#delete-code-btn").on('click', function () {
        $("#myModalDelete").modal('hide');
        let code = datable.cell(idx, 0).data();
        let estado = datable.cell(idx, 3).data();

        if (estado === "INVITACION") {
            $.post(dc, {
                code: code
            }).done(function (data) {
                let dataJSON = $.parseJSON(data);
                if (dataJSON.status === SUCCESS) {
                    tr.fadeOut(1000);
                    setTimeout(function () {
                        datable.row(tr).remove()
                            .draw();
                    }, 1000);
                } else {
                    alert(data);
                }
            });
        } else {
            alert("No se puede eliminar porque ya esta en uso.");
        }
    });

});

function getM(mm) {
    if (parseInt(mm) >= 1 && parseInt(mm) < 10) {
        return "0" + mm;
    }
    return mm;
}

function editCode(td) {
    tr = $(td).parent().parent();
    idx = datable.row(tr).index();
    let code = datable.cell(idx, 0).data();
    let duration = datable.cell(idx, 1).data();
    let estado = datable.cell(idx, 3).data();

    if (estado === "INVITACION") {
        $("#duracion_edit").val(duration);
        $("#codigo_edit").val(code);
        $("#myModalEdit").modal('show');
    } else {
        alert("No se puede editar porque ya esta en uso.");
    }

}

function deleteCode(td) {
    tr = $(td).parent().parent();
    idx = datable.row(tr).index();

    $("#myModalDelete").modal('show');

}
