var SUCCESS = 1;
$(document).ready(function () {

    $("#loading_text").hide();
    $("#save_btn").on("click", function () {
        $("#seguridad_password").val("");
        $("#myModalConfirm").modal("show");
    });

    $("#verify-code-btn").on("click", function () {
        let segu = $("#seguridad_password");
        if (segu.val() !== "") {
            send(segu.val());
        } else {
            alert("Introduzca la clave especial");
        }
    });

});

function send(segu) {

    if (verifyValue("#law_price") && verifyValue("#law_row_quantity")
        && verifyValue("#domestic_shipping") && verifyValue("#america_shipping_price")
        && verifyValue("#international_shipping_price") && verifyValue("#monthly_subscription_price")
        && verifyValue("#anual_subscription_price")) {

        $("#loading_text").show();
        $("#save_btn").attr("disabled", true);
        $("#myModalConfirm").modal("hide");

        $.post(up, {
            law_price: $("#law_price").val(),
            law_row_quantity: $("#law_row_quantity").val(),
            domestic_shipping_price: $("#domestic_shipping").val(),
            america_shipping_price: $("#america_shipping_price").val(),
            international_shipping_price: $("#international_shipping_price").val(),
            monthly_subscription_price: $("#monthly_subscription_price").val(),
            anual_subscription_price: $("#anual_subscription_price").val(),
            seguridad_password: segu
        }).done(function (data) {

            $("#loading_text").fadeOut(1000);
            $("#save_btn").removeAttr("disabled");

            if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                let dataJSON = $.parseJSON(data);
                if (dataJSON.status === SUCCESS) {
                    alert(dataJSON.data);
                } else {
                    alert(dataJSON.message);
                }
            } else {
                alert(data);
            }
        });
    }
}

function verifyValue(nameId) {
    let field = $(nameId);

    if (field.val() === "") {
        alert("El campo " + field.data("title") + " no puede estar vacío");
        field.focus();
        return false;
    }

    let max = field.attr("max");
    let min = field.attr("min");

    if (field.val() >= parseInt(min) && field.val() <= parseInt(max)) {
        return true;
    } else {
        alert("El valor " + field.val() + " debe estar en el rango [" + min + "," + max + "]");
        field.focus();
        return false;
    }

    /*if (field.val() > max) {
        alert("El valor en " + field.data("title") + " no puede ser " + field.val() + " mayor que " + max);
        field.focus();
        return false;
    }*/
}