var SUCCESS = 1;
var idx = 0;
var tr = null;
var id = 0;
var flag_portada = false;
var file_upload_portada = null;
var datable = $('#dataTables-seminary').DataTable({
    responsive: true,
    "aoColumnDefs": [{
        'bSortable': false,
        'aTargets': [10, 11, 12, 13, 14]
    }],
    columnDefs: [
        {className: 'text-center', targets: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]}
    ]
});

var datableRegistrados = $("#dataTables-content-registrados").DataTable({
    responsive: true
});
//$('#dataTables-seminary').dataTable().fnSetColumnVis(0, false);


function validAcceptType(type, id) {
    let size = $(id)[0].files[0].size;
    if (size < 2000000) {//2M
        let validExtensions = type; //array of valid extensions
        let fileName = $(id)[0].files[0].name;
        let fileNameExt = fileName.substr(fileName.lastIndexOf('.') + 1);
        if ($.inArray(fileNameExt, validExtensions) === -1) {
            return "Archivo con extensión desconocida.";
        }
        return true;
    } else {
        return "Solo archivos menores a 2MB";
    }
}

function verifyData(tipo_taller_sem_id, titulo_taller_sem_id, lugar_id, fecha_desde_id, fecha_hasta_id,
                    horario_id, inversion_id, telefono_id, extra_id) {

    let tipo_taller_sem = $("#" + tipo_taller_sem_id);
    let titulo_taller_sem = $("#" + titulo_taller_sem_id);
    let lugar = $("#" + lugar_id);
    let fecha_desde = $("#" + fecha_desde_id);
    let fecha_hasta = $("#" + fecha_hasta_id);
    let horario = $("#" + horario_id);
    let inversion = $("#" + inversion_id);
    let telefono = $("#" + telefono_id);
    let extra = $("#" + extra_id);

    let data = new FormData();
    data.append('tipo_taller_sem', tipo_taller_sem.val());
    data.append('titulo_taller_sem', titulo_taller_sem.val());
    data.append('lugar', lugar.val());
    data.append('fecha_desde', fecha_desde.val());
    data.append('fecha_hasta', fecha_hasta.val());
    data.append('horario', horario.val());
    data.append('inversion', inversion.val());
    data.append('telefono', telefono.val());
    data.append('extra', extra.val());


    return data;
}


function clearProgress() {
    $("#progressUpload").width("0%");
    //percent.html(percentVal);
    $("#progressUpload").attr("aria-valuenow", "0");
    $("#progressUpload").text("0%");
    $("#progressContainerUpload").hide();
}

function resetButtonForm() {
    $("#create-code-btn").removeAttr("disabled");
    $("#load-extra-gif").hide();
}


function clearForm() {

    let titulo_taller_sem = $("#titulo_taller_sem");
    let lugar = $("#lugar");
    let fecha_desde = $("#fecha_desde");
    let fecha_hasta = $("#fecha_hasta");
    let horario = $("#horario");
    let inversion = $("#inversion");
    let telefono = $("#telefono");
    let extra = $("#extra");

    $("#msg_upload_portada").text("Sin imagen");
    $("#msg_upload_portada").css("color", "#cc2704");
    $("#file_upload_portada").val("");
    flag_portada = false;
    file_upload_portada = null;

    titulo_taller_sem.val("");
    lugar.val("");
    fecha_desde.val("");
    fecha_hasta.val("");
    horario.val("");
    inversion.val("");
    telefono.val("");
    extra.val("");

    $("#tipo_taller_sem option").filter(function () {
        return this.text == "SEMINARIO";
    }).attr('selected', true);
}

function propertyCreateForm() {
    $("#myModalLabel").text("Creación del seminario o taller");
    $("#create-code-btn").text("Crear nuevo");
}

function propertyEditForm() {
    $("#myModalLabel").text("Editar seminario o taller");
    $("#create-code-btn").text("Guardar cambios");
}


function createEvent() {

    $("#create-code-btn").attr("disabled", true);
    $("#load-extra-gif").show();
    let file_upload_portada_id = $("#file_upload_portada");
    if (file_upload_portada_id.val() !== "") {

        let data = verifyData("tipo_taller_sem", "titulo_taller_sem", "lugar", "fecha_desde",
            "fecha_hasta", "horario", "inversion", "telefono",
            "extra");

        data.append('file_portada', $(file_upload_portada_id)[0].files[0]);
        $("#progressContainerUpload").show();

        $.ajax({
            processData: false,
            contentType: false,
            dataType: "html",
            type: 'POST',
            url: mc,
            data: data,
            enctype: 'multipart/form-data',
            xhr: function () {
                var xhr = new window.XMLHttpRequest();
                xhr.upload.addEventListener("progress", function (evt) {
                    if (evt.lengthComputable) {
                        var percentComplete = evt.loaded / evt.total;
                        var percentVal = (Math.round(percentComplete * 100)) + '%';
                        $("#progressUpload").width(percentVal);
                        $("#progressUpload").attr("aria-valuenow", (Math.round(percentComplete * 100)));
                        $("#progressUpload").text(percentVal);
                    }
                }, false);
                return xhr;
            },
            success: function (data) {
                if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                    let dataJSON = $.parseJSON(data);
                    if (dataJSON.status === SUCCESS) {
                        resetButtonForm();
                        clearProgress();
                        clearForm();
                        $("#myModal").modal('hide');
                        var date_desde = "";
                        if (dataJSON.data.fecha_desde !== "") {
                            date_desde = new Date(dataJSON.data.fecha_desde);
                            date_desde = getM((date_desde.getMonth() + 1)) + "/" + date_desde.getDate() + "/" + date_desde.getFullYear();
                        }
                        var date_hasta = "";
                        if (dataJSON.data.fecha_hasta !== "") {
                            date_hasta = new Date(dataJSON.data.fecha_hasta);
                            date_hasta = getM((date_hasta.getMonth() + 1)) + "/" + date_hasta.getDate() + "/" + date_hasta.getFullYear();
                        }
                        var rowIndex = $('#dataTables-seminary').dataTable().fnAddData([
                            dataJSON.data.id_taller_sem,
                            dataJSON.data.tipo_taller_sem,
                            dataJSON.data.titulo_taller_sem,
                            dataJSON.data.lugar,
                            date_desde,
                            date_hasta,
                            dataJSON.data.horario,
                            dataJSON.data.inversion,
                            dataJSON.data.telefono,
                            dataJSON.data.extra,
                            "<img style=\"cursor:pointer;\" onclick=\"showPortada(this);\" src=\"" + dataJSON.data.portada_path + "\" width=\"48\" height=\"48\">",
                            "<img style=\"cursor:pointer;\" onclick=\"editSeminary(this);\" src=\"/speedycep/admin/img/edit_icon.png\" width=\"24\" height=\"24\">",
                            "<img style=\"cursor:pointer;\" onclick=\"deleteSeminary(this);\" src=\"/speedycep/admin/img/remove_icon.png\" width=\"24\" height=\"24\">",
                            "<button class=\"btn btn-default\" onclick=\"noPublicada(this);\">No publicada</button>",
                            "<button class=\"btn btn-danger\" onclick='registrados(this);'>Registrados</button>"
                        ]);

                        var row = $('#dataTables-seminary').dataTable().fnGetNodes(rowIndex);
                        for (var i = 0; i < 14; i++) {
                            $(row).find("td:eq(" + i + ")").addClass("text-center");
                        }
                        $(row).find("td:eq(0)").attr("style", "display:none;");


                    }
                } else {
                    resetButtonForm();
                    clearProgress();
                    alert(data);
                }

            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                var json_error = $.parseJSON(XMLHttpRequest.responseText);

                resetButtonForm();
                clearProgress();

                $("#msg_error").text(json_error.message.toString());
                $("#panel-msg-error").fadeIn(1000).fadeOut(3000);
                setTimeout(function () {
                    $("#create-code-btn").removeAttr("disabled");
                }, 4000);
            }
        });

    } else {
        $("#load-extra-gif").hide();
        $("#msg_error").text("Debe seleccionar una portada.");
        $("#panel-msg-error").fadeIn(1000).fadeOut(3000);
        setTimeout(function () {
            $("#create-code-btn").removeAttr("disabled");
        }, 4000);
    }
}


function updateEvent() {

    $("#create-code-btn").attr("disabled", true);
    $("#load-extra-gif").show();
    let file_upload_portada_id = $("#file_upload_portada");

    let data = verifyData("tipo_taller_sem", "titulo_taller_sem", "lugar", "fecha_desde",
        "fecha_hasta", "horario", "inversion", "telefono",
        "extra");

    var file_portada_upd = $(file_upload_portada_id)[0].files[0];
    data.append('file_portada', file_portada_upd);
    data.append('id', id);

    $("#progressContainerUpload").show();

    $.ajax({
        processData: false,
        contentType: false,
        dataType: "html",
        type: 'POST',
        url: ec,
        data: data,
        enctype: 'multipart/form-data',
        xhr: function () {
            var xhr = new window.XMLHttpRequest();
            xhr.upload.addEventListener("progress", function (evt) {
                if (evt.lengthComputable) {
                    var percentComplete = evt.loaded / evt.total;
                    var percentVal = (Math.round(percentComplete * 100)) + '%';
                    $("#progressUpload").width(percentVal);
                    $("#progressUpload").attr("aria-valuenow", (Math.round(percentComplete * 100)));
                    $("#progressUpload").text(percentVal);
                }
            }, false);
            return xhr;
        },
        success: function (data) {
            if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                let dataJSON = $.parseJSON(data);
                if (dataJSON.status === SUCCESS) {
                    resetButtonForm();
                    clearProgress();
                    clearForm();
                    $("#myModal").modal('hide');
                    var date_desde = "";
                    if (dataJSON.data.fecha_desde !== "") {
                        date_desde = new Date(dataJSON.data.fecha_desde);
                        date_desde = getM((date_desde.getMonth() + 1)) + "/" + date_desde.getDate() + "/" + date_desde.getFullYear();
                    }
                    var date_hasta = "";
                    if (dataJSON.data.fecha_hasta !== "") {
                        date_hasta = new Date(dataJSON.data.fecha_hasta);
                        date_hasta = getM((date_hasta.getMonth() + 1)) + "/" + date_hasta.getDate() + "/" + date_hasta.getFullYear();
                    }

                    datable.cell(idx, 0).data(dataJSON.data.id_taller_sem).draw();
                    datable.cell(idx, 1).data(dataJSON.data.tipo_taller_sem).draw();
                    datable.cell(idx, 2).data(dataJSON.data.titulo_taller_sem).draw();
                    datable.cell(idx, 3).data(dataJSON.data.lugar).draw();
                    datable.cell(idx, 4).data(date_desde).draw();
                    datable.cell(idx, 5).data(date_hasta).draw();
                    datable.cell(idx, 6).data(dataJSON.data.horario).draw();
                    datable.cell(idx, 7).data(dataJSON.data.inversion).draw();
                    datable.cell(idx, 8).data(dataJSON.data.telefono).draw();
                    datable.cell(idx, 9).data(dataJSON.data.extra).draw();
                    tr.fadeOut(1000).fadeIn(1000);
                }
            } else {
                resetButtonForm();
                clearProgress();
                $("#msg_error").text(data);
                $("#panel-msg-error").fadeIn(1000).fadeOut(3000);
                setTimeout(function () {
                    $("#create-code-btn").removeAttr("disabled");
                }, 4000);
            }

        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            var json_error = $.parseJSON(XMLHttpRequest.responseText);
            resetButtonForm();
            clearProgress();
            $("#msg_error").text(json_error.message.toString());
            $("#panel-msg-error").fadeIn(1000).fadeOut(3000);
            setTimeout(function () {
                $("#create-code-btn").removeAttr("disabled");
            }, 4000);
        }
    });
}


function soloPublicidad() {

    $("#lugar").attr("disabled", true);
    $("#fecha_desde").attr("disabled", true);
    $("#fecha_hasta").attr("disabled", true);
    $("#horario").attr("disabled", true);
    $("#inversion").attr("disabled", true);
    $("#telefono").attr("disabled", true);
    $("#link_copy").text("Link de la publicidad");
}


function soloOtros() {

    $("#lugar").attr("disabled", false);
    $("#fecha_desde").attr("disabled", false);
    $("#fecha_hasta").attr("disabled", true);
    $("#horario").attr("disabled", false);
    $("#inversion").attr("disabled", false);
    $("#telefono").attr("disabled", false);
    $("#link_copy").text("Información extra");
}
$(document).ready(function () {

    $("#tipo_taller_sem").on("change", function () {

        $("#tipo_taller_sem option:selected").each(function () {

            let item = $(this);
            if (item.val() === "PUBLICIDAD") {
                soloPublicidad();
            } else {
                soloOtros();
            }

        });

    });

    $("#btn_portada").on("click", function () {
        $("#file_upload_portada").click();
    });


    $("#file_upload_portada").change(function () {
        let valid = validAcceptType(['jpg', 'png'], "#file_upload_portada");
        if (valid === true) {
            $("#msg_upload_portada").text("Imagen por subir");
            $("#msg_upload_portada").css("color", "blue");
            flag_portada = true;
        } else {
            $("#msg_upload_portada").text("Sin imagen");
            $("#msg_upload_portada").css("color", "#cc2704");
            $("#file_upload_portada").val("");
            flag_portada = false;
            alert(valid);
        }
    });

    $("#fecha_desde").on('change', function () {
        let minDate = $(this).val();
        if (minDate === "") {
            $("#fecha_hasta").val("");
            $("#fecha_hasta").attr("disabled", true);
        } else {
            $("#fecha_hasta").val("");
            $("#fecha_hasta").attr("min", minDate);
            $("#fecha_hasta").removeAttr("disabled");
        }

    });

    $("#fecha_desde_edit").on('change', function () {
        let minDate = $(this).val();
        if (minDate === "") {
            $("#fecha_hasta_edit").val("");
            $("#fecha_hasta_edit").attr("disabled", true);
        } else {
            $("#fecha_hasta_edit").val("");
            $("#fecha_hasta_edit").attr("min", minDate);
            $("#fecha_hasta_edit").removeAttr("disabled");
        }

    });

    $("#create_btn").on('click', function () {
        clearForm();
        propertyCreateForm();
        $("#load-create").hide();
        $("#panel-create").show();
        $("#myModal").modal('show');
    });

    $("#create-code-btn").on('click', function () {
        if ($(this).text() === "Crear nuevo") {
            createEvent();
        } else {
            updateEvent();
        }

    });

    $("#delete-code-btn").on('click', function () {
        $("#myModalDelete").modal('hide');
        $.post(dc, {
            id: id
        }).done(function (data) {
            if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                let dataJSON = $.parseJSON(data);
                if (dataJSON.status === SUCCESS) {
                    tr.fadeOut(1000);
                    setTimeout(function () {
                        datable.row(tr).remove()
                            .draw();
                    }, 1000);
                }
            } else {
                alert(data);
            }
        });
    });


    $("#publicar-code-btn").on('click', function () {
        $("#myModalNoPublicada").modal('hide');
        $.post(npub, {
            id: id
        }).done(function (data) {
            if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                let dataJSON = $.parseJSON(data);
                if (dataJSON.status === SUCCESS) {
                    datable.cell(idx, 13).data("<button class=\"btn btn-success\" onclick='publicada(this);'>Publicada</button>").draw();
                    tr.fadeOut(1000).fadeIn(1000);
                }
            } else {
                alert(data);
            }
        });
    });

    $("#unpublicar-code-btn").on('click', function () {
        $("#myModalPublicada").modal('hide');
        $.post(rpub, {
            id: id
        }).done(function (data) {
            if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
                let dataJSON = $.parseJSON(data);
                if (dataJSON.status === SUCCESS) {
                    datable.cell(idx, 13).data("<button class=\"btn btn-default\" onclick='noPublicada(this);'>No publicada</button>").draw();
                    tr.fadeOut(1000).fadeIn(1000);
                }
            } else {
                alert(data);
            }
        });
    });

});

function getM(mm) {
    if (parseInt(mm) >= 1 && parseInt(mm) < 10) {
        return "0" + mm;
    }
    return mm;
}

function editSeminary(td) {
    tr = $(td).parent().parent();
    idx = datable.row(tr).index();
    id = datable.cell(idx, 0).data();
    let tipo_taller_sem = datable.cell(idx, 1).data();
    let titulo_taller_sem = datable.cell(idx, 2).data();
    let lugar = datable.cell(idx, 3).data();
    let fecha_desde = datable.cell(idx, 4).data();
    let fecha_hasta = datable.cell(idx, 5).data();
    let horario = datable.cell(idx, 6).data();
    let inversion = datable.cell(idx, 7).data();
    let telefono = datable.cell(idx, 8).data();
    let extra = datable.cell(idx, 9).data();
    let ruta_portada = datable.cell(idx, 10).data();


    clearForm();
    propertyEditForm();

    file_upload_portada = $(ruta_portada).attr("src").split("?")[0];

    $("#msg_upload_portada").text("Portada guardada.");
    $("#msg_upload_portada").css("color", "#33b54e");

    var date_desde = fecha_desde.split("/");
    var date_hasta = fecha_hasta.split("/");
    $("#tipo_taller_sem").val(tipo_taller_sem);
    $("#titulo_taller_sem").val(titulo_taller_sem);
    $("#lugar").val(lugar);
    $("#fecha_desde").val(date_desde[2] + "-" + date_desde[0] + "-" + date_desde[1]);
    $("#fecha_hasta").val(date_hasta[2] + "-" + date_hasta[0] + "-" + date_hasta[1]);
    $("#horario").val(horario);
    $("#inversion").val(inversion);
    $("#telefono").val(telefono);
    $("#extra").val(extra);

    $("#load-create").hide();
    $("#panel-create").show();
    $("#myModal").modal('show');

}

function deleteSeminary(td) {
    tr = $(td).parent().parent();
    idx = datable.row(tr).index();
    id = datable.cell(idx, 0).data();

    $("#myModalDelete").modal('show');

}

function showPortada(td) {
    let ruta_portada = datable.cell(datable.row($(td).parent().parent()).index(), 10).data();
    let img = $(ruta_portada).attr("src");
    $("#img-portada-zoom").attr("src", img);
    $("#myModalShowPortada").modal('show');
}

function noPublicada(td) {

    tr = $(td).parent().parent();
    idx = datable.row(tr).index();
    id = datable.cell(idx, 0).data();
    $("#myModalNoPublicada").modal('show');
}

function publicada(td) {

    tr = $(td).parent().parent();
    idx = datable.row(tr).index();
    id = datable.cell(idx, 0).data();
    $("#myModalPublicada").modal('show');

}

function registrados(td) {
    $("#myModalRegistrados").modal('show');
    $("#panel-msg-error-registrados").hide();
    $("#img-load-registrados").show();
    $("#content-registrados").hide();
    tr = $(td).parent().parent();
    idx = datable.row(tr).index();
    id = datable.cell(idx, 0).data();
    datableRegistrados
        .clear()
        .draw();

    $.post(lus, {
        id: id
    }).done(function (data) {
        if (/^[\],:{}\s]*$/.test(data.replace(/\\["\\\/bfnrtu]/g, '@').replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']').replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {
            let dataJSON = $.parseJSON(data);
            if (dataJSON.status === SUCCESS) {
                $("#img-load-registrados").hide();
                $("#content-registrados").show();

                for (var i = 0; i < dataJSON.data.length; i++) {
                    var rowIndex = datableRegistrados.row.add([
                        dataJSON.data[i].id_usuario,
                        dataJSON.data[i].email_usuario,
                        dataJSON.data[i].cedula_usuario,
                        dataJSON.data[i].nombre_usuario,
                        dataJSON.data[i].apellido_usuario,
                        dataJSON.data[i].sexo,
                        dataJSON.data[i].pais_usuario,
                        dataJSON.data[i].ciudad_usuario,
                        dataJSON.data[i].direccion_usuario,
                        dataJSON.data[i].celular_usuario,
                        dataJSON.data[i].monto_cancelado,
                        dataJSON.data[i].estado_pago
                    ]).draw(false);

                    var row = $('#dataTables-content-registrados').dataTable().fnGetNodes(rowIndex);
                    for (var i = 0; i < 12; i++) {
                        $(row).find("td:eq(" + i + ")").addClass("text-center");
                    }
                    $(row).find("td:eq(0)").attr("style", "display:none;");
                }
            }
        } else {
            $("#img-load-registrados").hide();
            $("#content-registrados").hide();
            $("#msg_error_registrados").text(data);
            $("#panel-msg-error-registrados").fadeIn(1000).fadeOut(1000);
        }
    });

}