<?php

require_once 'Constants.php';
require_once 'ConnectionDB.php';

class Auth
{
    const TABLE_NAME = "dex_usuario_auth";
    const TABLE_NAME_DEX_USUARIO = "dex_usuario_new";
    const ID_AUTH = "id_auth";
    const ID_USUARIO = "id_usuario";
    const AUTH_PROVIDER = "auth_provider";
    const AUTH_UID = "auth_uid";
    const EMAIL_USUARIO = "email_usuario";
    const CLAVE_USUARIO = "clave_usuario";
    const IPS_VALIDAS = "ips_validas";
    const NOMBRE_USUARIO = "nombre_usuario";
    const APELLIDO_USUARIO = "apellido_usuario";
    const PAIS_USUARIO = "pais_usuario";
    const CIUDAD_USUARIO = "ciudad_usuario";
    const DIRECCION_USUARIO = "direccion_usuario";
    const CELULAR_USUARIO = "celular_usuario";
    const CONVENCIONAL_USUARIO = "convencional_usuario";
    const ESTADO_USUARIO = "estado_usuario";//char
    const FECHA_REGISTRO = "fecha_registro";
    const FECHA_CADUCIDAD_CEPWEB = "fecha_caducidad_cepweb";
    const CANT_LICENCIAS = "cant_licencias";
    const ID_COMO_SE_ENTERO = "id_como_se_entero";
    const ID_VENDEDOR_CEP = "id_vendedor_cep";
    const OBSERVACIONES = "observaciones";
    const APP_API_KEY = "app_api_key";
    const SEXO = "sexo";
    const CEDULA_USUARIO = "cedula_usuario";
    const SERVICIO_SPEEDY = "servicio_speedy";
    const FECHA_CADUCA_PREMIUM = "fecha_caduca_premium";
    const METODO_DE_PAGO = "metodo_de_pago";


    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;

    const DEFAULT_SERVICIO_SPEEDY = "GRATUITO";
    const DEFAULT_METODO_DE_PAGO = "NINGUNO";

    public static function setPostRequest($request)
    {

        if ($request[0] == 'auth_user') {
            return Auth::getByDataFromUid();
        }

    }

    public static function setGetRequest($request)
    {


    }


    private function createAuth($id_usuario, $auth_provider, $auth_uid)
    {

        $query = "INSERT INTO " . self::TABLE_NAME . "(" . self::ID_USUARIO . ", 
        " . self::AUTH_PROVIDER . ", 
        " . self::AUTH_UID . ") VALUES (?,?,?)";

        if ($auth_provider != NULL) {

            try {
                $pdo = ConnectionDB::getInstance()->getDataBase();
                $prepare_stm = $pdo->prepare($query);

                $prepare_stm->bindValue(1, $id_usuario);
                $prepare_stm->bindValue(2, $auth_provider);
                $prepare_stm->bindValue(3, $auth_uid);

                $result = $prepare_stm->execute();

                if ($result) {
                    return self::SUCCESSFUL_CREATION;
                } else {
                    return self::FAILED_CREATION;
                }
            } catch (PDOException $e) {
                throw new ExceptionApi(self::ERROR_DATABASE, $e->getMessage());
            }

        } else {
            throw new ExceptionApi(self::ERROR_DATABASE, "Error Interno");
        }


    }

    private function createUser($email_usuario, $nombre_usuario, $apellido_usuario)
    {

        $app_api_key = self::generateApiPassword();
        $clave_usuario = self::encryptPassword($app_api_key);
        $direccion_usuario = "";
        $ciudad_usuario = "";
        $pais_usuario = "";
        $cedula_usuario = "";
        $sexo = "M";
        $celular_usuario = "";

        $estado_usuario = "A";
        $cant_licencias = 1;
        $id_como_se_entero = 1;
        $id_vendedor_cep = 1;

        $query = "INSERT INTO " . self::TABLE_NAME_DEX_USUARIO . "(" . self::EMAIL_USUARIO . ", 
                " . self::CLAVE_USUARIO . ", 
                " . self::NOMBRE_USUARIO . ", 
                " . self::APELLIDO_USUARIO . ", 
                " . self::DIRECCION_USUARIO . ", 
                " . self::CIUDAD_USUARIO . ", 
                " . self::PAIS_USUARIO . ", 
                " . self::CEDULA_USUARIO . ", 
                " . self::SEXO . ", 
                " . self::CELULAR_USUARIO . ", 
                " . self::APP_API_KEY . ", 
                " . self::ESTADO_USUARIO . ", 
                " . self::CANT_LICENCIAS . ", 
                " . self::ID_COMO_SE_ENTERO . ", 
                " . self::ID_VENDEDOR_CEP . ", 
                " . self::SERVICIO_SPEEDY . ", 
                " . self::FECHA_REGISTRO . ", 
                " . self::FECHA_CADUCIDAD_CEPWEB . ",
                " . self::FECHA_CADUCA_PREMIUM . ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,NOW(), NOW() + INTERVAL 15 DAY, NOW())";
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $prepare_stm = $pdo->prepare($query);

        $prepare_stm->bindValue(1, strtolower($email_usuario), PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $clave_usuario, PDO::PARAM_STR);
        $prepare_stm->bindValue(3, $nombre_usuario, PDO::PARAM_STR);
        $prepare_stm->bindValue(4, $apellido_usuario, PDO::PARAM_STR);
        $prepare_stm->bindValue(5, $direccion_usuario, PDO::PARAM_STR);
        $prepare_stm->bindValue(6, $ciudad_usuario, PDO::PARAM_STR);
        $prepare_stm->bindValue(7, $pais_usuario, PDO::PARAM_STR);
        $prepare_stm->bindValue(8, $cedula_usuario, PDO::PARAM_STR);
        $prepare_stm->bindValue(9, $sexo, PDO::PARAM_STR);
        $prepare_stm->bindValue(10, $celular_usuario, PDO::PARAM_STR);
        $prepare_stm->bindValue(11, $app_api_key, PDO::PARAM_STR);

        $prepare_stm->bindValue(12, $estado_usuario, PDO::PARAM_STR);
        $prepare_stm->bindValue(13, $cant_licencias, PDO::PARAM_INT);
        $prepare_stm->bindValue(14, $id_como_se_entero, PDO::PARAM_INT);
        $prepare_stm->bindValue(15, $id_vendedor_cep, PDO::PARAM_INT);
        $prepare_stm->bindValue(16, self::DEFAULT_SERVICIO_SPEEDY, PDO::PARAM_STR);

        $result = $prepare_stm->execute();

        if ($result) {
            return json_encode([
                "status" => self::SUCCESSFUL_CREATION,
                "message" => "Registro exitoso",
                "id_user" => $pdo->lastInsertId()
            ]);
        } else {
            return self::FAILED_CREATION;
        }

    }


    private function encryptPassword($password)
    {
        $cost = 10;
        $salt = strtr(base64_encode(mcrypt_create_iv(16, MCRYPT_DEV_URANDOM)), '+', '.');
        $salt = sprintf("$2a$%02d$", $cost) . $salt;
        $hash = crypt($password, $salt);

        return $hash;

    }

    private function generateApiPassword()
    {
        return md5(microtime() . rand());
    }


    private function getByDataFromUid()
    {

        $body = file_get_contents('php://input');
        $auth = json_decode($body);

        if ($auth != NULL) {

            try {

                $auth_uid = isset($auth->auth_uid) ? $auth->auth_uid : null;
                $auth_provider = isset($auth->auth_provider) ? $auth->auth_provider : null;

                if ($auth_provider == null || $auth_uid == null) {
                    throw new ExceptionApi(self::FAILED_CREATION, "Faltan las variables auth");
                }

                $exist_auth = self::existAuthForUidAndProvider($auth_uid, $auth_provider);

                if ($exist_auth == self::SUCCESSFUL_CREATION) {
                    return self::getAllDataForAuth($auth_uid, $auth_provider);
                } else if ($exist_auth == self::FAILED_CREATION) { // verify if exist email in the table user.

                    $email = isset($auth->email) ? strtolower($auth->email) : null;

                    if ($email == null) {
                        throw new ExceptionApi(self::FAILED_CREATION, "Email incorrecto");
                    }

                    if (self::existEmailUser($email) == self::SUCCESSFUL_CREATION) {//email exist solo register auth

                        //get id user.
                        $id_usuario = self::getIdUser($email);
                        $result_create_auth = self::createAuth($id_usuario, $auth_provider, $auth_uid);
                        if ($result_create_auth == self::SUCCESSFUL_CREATION) {
                            return self::getAllDataForAuth($auth_uid, $auth_provider);
                        } else {
                            throw new ExceptionApi(self::FAILED_CREATION, "Error al crear el auth");
                        }

                    } else {


                        $nombre_usuario = isset($auth->nombre_usuario) ? $auth->nombre_usuario : null;
                        $apellido_usuario = isset($auth->apellido_usuario) ? $auth->apellido_usuario : null;

                        if ($nombre_usuario == null || $apellido_usuario == null) {
                            throw new ExceptionApi(self::FAILED_CREATION, "Datos de usuario incorrectos");
                        }

                        //need register all information into table user.
                        $result_create_user = self::createUser($email, $nombre_usuario,
                            $apellido_usuario);

                        if ($result_create_user != self::FAILED_CREATION) {

                            $decode_result_create_user = json_decode($result_create_user);

                            if ($decode_result_create_user->status == self::SUCCESSFUL_CREATION) {

                                $id_usuario = $decode_result_create_user->id_user;
                                $result_create_auth = self::createAuth($id_usuario, $auth_provider, $auth_uid);
                                if ($result_create_auth == self::SUCCESSFUL_CREATION) {
                                    return self::getAllDataForAuth($auth_uid, $auth_provider);
                                } else {
                                    throw new ExceptionApi(self::FAILED_CREATION, "Error al crear el auth");
                                }
                            }

                        }


                    }

                }

            } catch (PDOException $e) {
                throw new ExceptionApi(self::ERROR_DATABASE, $e->getMessage());
            }


        } else {

            throw new ExceptionApi(self::FAILED_CREATION, "Objeto nulo");

        }


    }


    private function getIdUser($email)
    {

        $query = "SELECT * FROM " . self::TABLE_NAME_DEX_USUARIO . " WHERE " . self::EMAIL_USUARIO . "=?";

        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);

        $prepare_stm->bindParam(1, $email);

        if ($prepare_stm->execute()) {

            if ($prepare_stm->rowCount() > 0) {
                return $prepare_stm->fetch(PDO::FETCH_ASSOC)['id_usuario'];
            } else {
                return self::FAILED_CREATION;
            }

        } else {
            return self::FAILED_CREATION;
        }

    }

    private function existEmailUser($email)
    {

        $query = "SELECT * FROM " . self::TABLE_NAME_DEX_USUARIO . " WHERE " . self::EMAIL_USUARIO . "=?";

        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);

        $prepare_stm->bindParam(1, $email);

        if ($prepare_stm->execute()) {

            if ($prepare_stm->rowCount() > 0) {
                return self::SUCCESSFUL_CREATION;
            } else {
                return self::FAILED_CREATION;
            }

        } else {
            return self::FAILED_CREATION;
        }

    }

    private function existAuthForUidAndProvider($auth_uid, $auth_provider)
    {

        $query = "SELECT * FROM " . self::TABLE_NAME . " WHERE " . self::AUTH_UID . "=? AND " . self::AUTH_PROVIDER . "=?";

        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);

        $prepare_stm->bindParam(1, $auth_uid);
        $prepare_stm->bindParam(2, $auth_provider);

        if ($prepare_stm->execute()) {

            if ($prepare_stm->rowCount() > 0) {
                return self::SUCCESSFUL_CREATION;
            } else {
                return self::FAILED_CREATION;
            }

        } else {
            return self::FAILED_CREATION;
        }

    }


    private function getAllDataForAuth($auth_uid, $auth_provider)
    {

        $query = "SELECT " . self::TABLE_NAME . ".*," . self::TABLE_NAME_DEX_USUARIO . "." . self::EMAIL_USUARIO . ",
        " . self::TABLE_NAME_DEX_USUARIO . "." . self::ID_USUARIO . "," . self::TABLE_NAME_DEX_USUARIO . "." . self::NOMBRE_USUARIO . ",
        " . self::TABLE_NAME_DEX_USUARIO . "." . self::APELLIDO_USUARIO . "," . self::TABLE_NAME_DEX_USUARIO . "." . self::DIRECCION_USUARIO . ",
        " . self::TABLE_NAME_DEX_USUARIO . "." . self::CIUDAD_USUARIO . "," . self::TABLE_NAME_DEX_USUARIO . "." . self::PAIS_USUARIO . ",
        " . self::TABLE_NAME_DEX_USUARIO . "." . self::CELULAR_USUARIO . "," . self::TABLE_NAME_DEX_USUARIO . "." . self::CEDULA_USUARIO . ",
        " . self::TABLE_NAME_DEX_USUARIO . "." . self::SEXO . "," . self::TABLE_NAME_DEX_USUARIO . "." . self::APP_API_KEY . ",
        " . self::TABLE_NAME_DEX_USUARIO . "." . self::FECHA_CADUCIDAD_CEPWEB . ",
        " . self::TABLE_NAME_DEX_USUARIO . "." . self::FECHA_CADUCA_PREMIUM . ",
        " . self::TABLE_NAME_DEX_USUARIO . "." . self::ESTADO_USUARIO . ",
        " . self::TABLE_NAME_DEX_USUARIO . "." . self::SERVICIO_SPEEDY . ",
        " . self::TABLE_NAME_DEX_USUARIO . "." . self::METODO_DE_PAGO . " FROM " . self::TABLE_NAME . "," . self::TABLE_NAME_DEX_USUARIO . " 
                WHERE  " . self::TABLE_NAME_DEX_USUARIO . "." . self::ID_USUARIO . " = " . self::TABLE_NAME . "." . self::ID_USUARIO . " AND " . self::AUTH_UID . "=? AND " . self::AUTH_PROVIDER . "=?";

        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);

        $prepare_stm->bindParam(1, $auth_uid);
        $prepare_stm->bindParam(2, $auth_provider);

        if ($prepare_stm->execute()) {
            if ($prepare_stm->rowCount() > 0) {
                http_response_code(200);
                $resultado = $prepare_stm->fetch(PDO::FETCH_ASSOC);
               /* if ($resultado[self::ESTADO_USUARIO] == "A") {

                } else {
                    throw new ExceptionApi(self::FAILED_CREATION, "Usuario inactivo, comunicate con el soporte técnico.");
                }*/

                if ($resultado != NULL) {
                    http_response_code(200);
                    //antes de enviar verificar si la persona ha usado un cupo de suscripción adicional.
                    if ($resultado["app_api_key"] == null || $resultado["app_api_key"] == "") {
                        //update
                        $resultado["app_api_key"] = self::generateApiPassword();
                        User::updateApiKey($resultado["id_usuario"], $resultado["app_api_key"]);
                    }

                    //verificar caducidad premium.
                    $resultado["servicio_speedy"] = User::verifyPremiumAccount($resultado["fecha_caduca_premium"], $resultado["servicio_speedy"], $resultado["id_usuario"]);

                    return [
                        "status" => 1,
                        "message" => "Información encontrada.",
                        "data" => $resultado
                    ];
                } else {
                    throw new ExceptionApi(self::UNKNOWN_FAULT,
                        "Ha ocurrido un error");
                }

            } else {
                throw new ExceptionApi(self::FAILED_CREATION, "No hay registros");
            }

        } else {
            throw new ExceptionApi(self::FAILED_CREATION, "No se ejecuto la sentencia");
        }

    }


}