<?php

require_once 'ConnectionDB.php';
require_once 'API.php';

class Book
{

    const TABLE_NAME = "dex_libro_premium_speedy";
    const ID_LIBRO_PREMIUM = "id_libro_premium";
    const TITULO_LIBRO = "titulo_libro";
    const AUTOR = "autor";
    const EDICION = "edicion";
    const EDITORIAL = "editorial";
    const ANNIO_EDICION = "annio_edicion";
    const PRECIO_FISICO = "precio_fisico";
    const PRECIO_EBOOK = "precio_ebook";
    const RUTA_ENLACE = "ruta_enlace";
    const FECHA_ACTUALIZACION = "fecha_actualizacion";
    const RUTA_PORTADA = "ruta_portada";
    const EXISTENCIA_FISICA = "existencia_fisica";
    const EXISTENCIA_EBOOK = "existencia_ebook";
    const PUBLICAR = "publicar";
    const FECHA_COMPRA = "fecha_compra";
    const RESUMEN = "resumen";

    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private static $encryption_key = '5166546A576E5A72';
    const DEFAULT_PUBLICAR = "NO PUBLICADA";
    const TYPE_PUBLICAR = "PUBLICADA";

    public static function setPostRequest($request)
    {
        if ($request[0] == 'register_todo_code') {
            return Book::registerTodoCode();
        } else if ($request[0] == 'edit_todo_code') {
            return Book::editTodoCode();
        } else if ($request[0] == 'delete_todo_code') {
            return Book::deleteTodoCode();
        } else if ($request[0] == 'get_todo_code') {
            return Book::getTodoCode();
        } else if ($request[0] == 'publish_todo_code') {
            return Book::publishTodoCode();
        } else if ($request[0] == 'unpublish_todo_code') {
            return Book::unPublishTodoCode();
        } else if ($request[0] == 'get_buyer') {
            return Book::getBuyer();
        } else if ($request[0] == 'get_buyer_details') {
            return Book::getBuyerDetails();
        } else if ($request[0] == 'get_user_data_buyer') {
            return Book::getUserDataBuyer();
        } else if ($request[0] == 'get_info_book_by_code') {
            return Book::getInfoBookByCode();
        } else if ($request[0] == 'update_detail_user_book') {
            return Book::updateDetailUserBook();
        } else if ($request[0] == 'get_book_by_code') {
            return Book::getBookByCode();
        } else if ($request[0] == 'get_book_post_by_code') {
            return Book::getBookPostByCode();
        } else if ($request[0] == 'update_portada') {
            return Book::updatePortada();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    private static function updatePortada()
    {

        User::authorizationFromApp();

        if (isset($_POST['id_libro_premium']) && isset($_POST['ruta_portada'])) {

            $pdo = ConnectionDB::getInstance()->getDataBase();
            $result = self::uptPort($pdo, $_POST['id_libro_premium'], $_POST['ruta_portada']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Actualizado!"
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Error - no fue posible actualizar."
                ];
            }

        }

    }

    private static function getBookByCode()
    {

        $body = file_get_contents('php://input');
        $Data = json_decode($body);
        // Validar campos
        User::authorizationFromApp();
        if ($Data !== null && ValidComponent::issetField($Data->id_libro_premium, 900)) {
            //extraer primero las notificaciones de códigos promocionales - DISPONIBLES
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => self::getDataCode($Data->id_libro_premium)
            ];
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Parametros incorrectos", 400);
        }

    }

    private static function getBookPostByCode()
    {

        if (isset($_POST['id_libro_premium'])) {
            //extraer primero las notificaciones de códigos promocionales - DISPONIBLES
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => self::getDataCode($_POST['id_libro_premium'])
            ];
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Parametros incorrectos", 400);
        }

    }


    private static function updateDetailUserBook()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $result = self::updateEnvioUsuario($pdo, $_POST['id'], $_POST['estado_envio'], $_POST['observacion']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Actualizado!",
                    "data" => self::getLastDetailsSendBook($pdo, $_POST['id'])
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Error - no fue posible actualizar."
                ];
            }
        }
    }

    private static function getInfoBookByCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Book();
            $result = $cd->getAllByID($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Encontrado!",
                    "data" => $result
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "No hay datos"
                ];
            }
        }
    }

    private static function getUserDataBuyer()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Book();
            $result = $cd->getDataBuyer($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Encontrado!",
                    "data" => $result
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "No hay datos"
                ];
            }
        }
    }

    private static function getBuyerDetails()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Book();
            $result = $cd->getBuyerUsersDetails($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Encontrado!",
                    "data" => $result
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "No hay datos"
                ];
            }
        }
    }

    private static function getBuyer()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Book();
            $result = $cd->getBuyerUsers($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Encontrado!",
                    "data" => $result
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "No hay datos"
                ];
            }
        }
    }


    public static function getByNotificationWithUserLimit($id_usuario, $search_text, $start_limit, $end_limit, $addOptions = false)
    {
        //User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        //$cd = new Book();
        $result = self::getBookOrderByPublicarLimit($pdo, $search_text, $start_limit, $end_limit);
        if ($result) {
            for ($i = 0; $i < count($result); $i++) {
                if ($addOptions) {
                    $result[$i]['inscripcion'] = self::getInscriptionBookUser($pdo, $result[$i]['id_libro_premium'], $id_usuario);
                }
                $result[$i]['id_libro_premium'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $result[$i]['id_libro_premium']);
            }

            return $result;
        }
        return null;
    }


    public static function getByNotificationWithOutUser()
    {
        //User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $cd = new Book();
        $result = $cd->getBookOrderByPublicar($pdo);
        if ($result) {
            for ($i = 0; $i < count($result); $i++) {
                $result[$i]['id_libro_premium'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $result[$i]['id_libro_premium']);
            }
            return $result;
        }
        return null;
    }

    public static function getByNotificationWithUser($id_usuario)
    {
        //User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $cd = new Book();
        $result = $cd->getBookOrderByPublicar($pdo);
        if ($result) {
            for ($i = 0; $i < count($result); $i++) {
                $result[$i]['inscripcion'] = self::getInscriptionBookUser($pdo, $result[$i]['id_libro_premium'], $id_usuario);
                $result[$i]['id_libro_premium'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $result[$i]['id_libro_premium']);
            }

            return $result;
        }
        return null;
    }

    private static function unPublishTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Book();
            $result = $cd->unPublishTodo($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡No Publicada!"
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Error - no fue posible cambiar la opción."
                ];
            }
        }
    }

    private static function publishTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Book();
            $result = $cd->publishTodo($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Publicada!"
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Error - no fue posible publicar."
                ];
            }
        }
    }

    private static function getTodoCode()
    {
        User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $cd = new Book();
        $result = self::getAll($pdo);
        if ($result) {
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "message" => "¡Encontrado!",
                "data" => $result
            ];
        }
    }

    private static function deleteTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Book();
            $result = $cd->deleteTodo($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Eliminado!"
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Error - no fue posible eliminar el seminario/taller."
                ];
            }
        }
    }

    private static function editTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['id']) && isset($_POST['titulo_libro']) && isset($_POST['resumen']) && isset($_POST['autor']) && isset($_POST['edicion'])
            && isset($_POST['editorial']) && isset($_POST['annio_edicion']) && isset($_POST['precio_fisico']) && isset($_POST['precio_ebook'])
            && isset($_POST['existencia_fisica']) && isset($_POST['existencia_ebook'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Book();
            $result = $cd->modifyTodo($pdo, $_POST['id'], $_POST['titulo_libro'], $_POST['resumen'], $_POST['autor'], $_POST['edicion'],
                $_POST['editorial'], $_POST['annio_edicion'], $_POST['precio_fisico'], $_POST['precio_ebook'],
                $_POST['existencia_fisica'], $_POST['existencia_ebook']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Editado!",
                    "data" => self::getDataCode($_POST['id'])
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "No se pudo editar por SQLERROR"
                ];
            }
        }
    }

    private static function registerTodoCode()
    {
        User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $cd = new Book();
        $result = $cd->insertTodo($pdo, $_POST['titulo_libro'], $_POST['resumen'], $_POST['autor'], $_POST['edicion'],
            $_POST['editorial'], $_POST['annio_edicion'], $_POST['precio_fisico'], $_POST['precio_ebook'],
            $_POST['existencia_fisica'], $_POST['existencia_ebook'], $_POST['ruta_portada'], $_POST['ruta_enlace']);

        if ($result) {
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "message" => "¡Registrado!",
                "data" => self::getDataCode($pdo->lastInsertId())
            ];
        } else {
            return [
                "status" => self::FAILED_CREATION,
                "message" => "No se pudo realizar el registro, SQLERROR."
            ];
        }
    }

    private static function getDataCode($id)
    {
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $cd = new Book();
        return $cd->getInfoByID($id, $pdo);
    }

    public static function getInfoByID($id, $pdo)
    {
        $query = "SELECT * FROM  " . self::TABLE_NAME . " WHERE " . self::ID_LIBRO_PREMIUM . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetchObject();
            return $result;
        } else {
            return null;
        }
    }


    public function insertTodo($pdo, $titulo_libro, $resumen, $autor, $edicion, $editorial, $annio_edicion,
                               $precio_fisico, $precio_ebook, $existencia_fisica, $existencia_ebook,
                               $ruta_portada, $ruta_enlace)
    {

        $query = "INSERT INTO " . self::TABLE_NAME . "(" . self::TITULO_LIBRO . ", 
                " . self::RESUMEN . ", 
                " . self::AUTOR . ", 
                " . self::EDICION . ", 
                " . self::EDITORIAL . ", 
                " . self::ANNIO_EDICION . ",
                " . self::PRECIO_FISICO . ", 
                " . self::PRECIO_EBOOK . ", 
                " . self::RUTA_ENLACE . ", 
                " . self::RUTA_PORTADA . ", 
                " . self::EXISTENCIA_FISICA . ", 
                " . self::EXISTENCIA_EBOOK . ", 
                " . self::TYPE_PUBLICAR . ", 
                " . self::FECHA_ACTUALIZACION . ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?, NOW())";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $titulo_libro, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $resumen, PDO::PARAM_STR);
        $prepare_stm->bindValue(3, $autor, PDO::PARAM_STR);
        $prepare_stm->bindValue(4, $edicion, PDO::PARAM_STR);
        $prepare_stm->bindValue(5, $editorial, PDO::PARAM_STR);
        $prepare_stm->bindValue(6, $annio_edicion, PDO::PARAM_INT);
        $prepare_stm->bindValue(7, $precio_fisico, PDO::PARAM_STR);
        $prepare_stm->bindValue(8, $precio_ebook, PDO::PARAM_STR);
        $prepare_stm->bindValue(9, $ruta_enlace, PDO::PARAM_STR);
        $prepare_stm->bindValue(10, $ruta_portada, PDO::PARAM_STR);
        $prepare_stm->bindValue(11, $existencia_fisica, PDO::PARAM_STR);
        $prepare_stm->bindValue(12, $existencia_ebook, PDO::PARAM_STR);
        $prepare_stm->bindValue(13, self::PUBLICAR, PDO::PARAM_STR);

        return $prepare_stm->execute();
    }


    public function deleteTodo($pdo, $id)
    {

        $query = "DELETE FROM " . self::TABLE_NAME . " WHERE " . self::ID_LIBRO_PREMIUM . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

    public function modifyTodo($pdo, $id, $titulo_libro, $resumen, $autor, $edicion, $editorial, $annio_edicion,
                               $precio_fisico, $precio_ebook, $existencia_fisica, $existencia_ebook)
    {


        $query = "UPDATE " . self::TABLE_NAME . "
                        SET 
                        " . self::TITULO_LIBRO . " = ?,
                        " . self::RESUMEN . " = ?,
                        " . self::AUTOR . " = ?,
                        " . self::EDICION . " = ?,
                        " . self::EDITORIAL . " = ?,
                        " . self::ANNIO_EDICION . " = ?,
                        " . self::PRECIO_FISICO . " = ?,
                        " . self::PRECIO_EBOOK . " = ?,
                        " . self::EXISTENCIA_FISICA . " = ?,
                        " . self::EXISTENCIA_EBOOK . " = ?,
                        " . self::FECHA_ACTUALIZACION . " = NOW()
                        WHERE " . self::ID_LIBRO_PREMIUM . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $titulo_libro, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $resumen, PDO::PARAM_STR);
        $prepare_stm->bindValue(3, $autor, PDO::PARAM_STR);
        $prepare_stm->bindValue(4, $edicion, PDO::PARAM_STR);
        $prepare_stm->bindValue(5, $editorial, PDO::PARAM_STR);
        $prepare_stm->bindValue(6, $annio_edicion, PDO::PARAM_INT);
        $prepare_stm->bindValue(7, $precio_fisico, PDO::PARAM_STR);
        $prepare_stm->bindValue(8, $precio_ebook, PDO::PARAM_STR);
        $prepare_stm->bindValue(9, $existencia_fisica, PDO::PARAM_STR);
        $prepare_stm->bindValue(10, $existencia_ebook, PDO::PARAM_STR);
        $prepare_stm->bindValue(11, $id, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

    public function publishTodo($pdo, $id)
    {
        $query = "UPDATE " . self::TABLE_NAME . "
                        SET 
                        " . self::PUBLICAR . " = ?
                        WHERE " . self::ID_LIBRO_PREMIUM . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, "PUBLICADA", PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

    public function unPublishTodo($pdo, $id)
    {
        $query = "UPDATE " . self::TABLE_NAME . "
                        SET 
                        " . self::PUBLICAR . " = ?
                        WHERE " . self::ID_LIBRO_PREMIUM . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, "NO PUBLICADA", PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }


    public static function getInscriptionBookUser($pdo, $id_libro_premium, $id_usuario)
    {
        $query = "SELECT dex_usuario_libro_comprador.id_usuario_comprador,
    dex_usuario_libro_comprador.tipo_compra,
    dex_usuario_libro_comprador.direccion_envio,
    dex_usuario_libro_comprador.nombres_envio,
    dex_usuario_libro_comprador.apellidos_envio,
    dex_usuario_libro_comprador.cedula_envio,
    dex_usuario_libro_comprador.telefono_envio,
    dex_usuario_libro_comprador.ciudad_envio,
    dex_usuario_libro_comprador.pais_envio,
    dex_usuario_libro_comprador.email_envio,
    dex_usuario_libro_comprador.precio_compra,
    dex_usuario_libro_comprador.numero_referencia,
    dex_usuario_libro_comprador.fecha_compra FROM dex_usuario_libro_comprador INNER JOIN dex_libro_premium_speedy ON dex_usuario_libro_comprador.id_libro_premium = dex_libro_premium_speedy.id_libro_premium INNER JOIN dex_usuario_new ON dex_usuario_new.id_usuario = dex_usuario_libro_comprador.id_usuario AND dex_libro_premium_speedy.id_libro_premium  = ? AND dex_usuario_new.id_usuario = ?";
        //$pdo = ConnectionDB::getInstance()->getDataBase();
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_libro_premium, PDO::PARAM_INT);
        $prepare_stm->bindValue(2, $id_usuario, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }

            for ($i = 0; $i < count($rows); $i++) {
                if ($rows[$i]['tipo_compra'] == "FISICO") {
                    $rows[$i]['details_buyer'] = self::getBuyerUsersDetails($pdo, $rows[$i]['id_usuario_comprador']);
                }
                $rows[$i]['id_usuario_comprador'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]['id_usuario_comprador']);
            }
            return $rows;
        } else {
            return null;
        }
    }

    public static function getBookOrderByPublicarLimit($pdo, $search_text, $start_limit, $end_limit)
    {
        $query = "SELECT * FROM " . self::TABLE_NAME . " WHERE " . self::PUBLICAR . " = ? AND " . self::TITULO_LIBRO . " LIKE ? ORDER BY " . self::ID_LIBRO_PREMIUM . " DESC LIMIT  ?, ?;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, "PUBLICADA", PDO::PARAM_STR);
        $prepare_stm->bindValue(2, "%" . $search_text . "%", PDO::PARAM_STR);
        $prepare_stm->bindValue(3, $start_limit, PDO::PARAM_INT);
        $prepare_stm->bindValue(4, $end_limit, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    public static function getBookOrderByPublicar($pdo)
    {
        //$query = "SELECT * FROM " . self::TABLE_NAME . " WHERE " . self::PUBLICAR . " = ? ORDER BY " . self::ID_LIBRO_PREMIUM . " DESC;";
        $query = "SELECT * FROM " . self::TABLE_NAME . " ORDER BY " . self::ID_LIBRO_PREMIUM . " DESC;";
        $prepare_stm = $pdo->prepare($query);
        //$prepare_stm->bindValue(1, "PUBLICADA", PDO::PARAM_STR);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    private static function getBuyerUsersDetails($pdo, $id_usuario_libro_comprador)
    {
        $query = "SELECT * FROM dex_detalle_envio_speedy WHERE id_usuario_libro_comprador = ? ORDER BY fecha_actualizacion ASC;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario_libro_comprador, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    private static function getBuyerUsers($pdo, $id_libro_premium)
    {
        $query = "SELECT dex_usuario_libro_comprador.id_usuario_comprador, dex_usuario_libro_comprador.numero_referencia, 
                  dex_usuario_libro_comprador.nombres_envio, dex_usuario_libro_comprador.apellidos_envio, 
                  dex_usuario_libro_comprador.tipo_compra, dex_usuario_libro_comprador.direccion_envio, 
                  dex_usuario_libro_comprador.cedula_envio, dex_usuario_libro_comprador.telefono_envio, 
                  dex_usuario_libro_comprador.ciudad_envio, dex_usuario_libro_comprador.pais_envio, 
                  dex_usuario_libro_comprador.email_envio, dex_usuario_libro_comprador.precio_compra, dex_usuario_libro_comprador.fecha_compra  
                  FROM dex_usuario_libro_comprador INNER JOIN dex_usuario_new ON 
                  dex_usuario_new.id_usuario = dex_usuario_libro_comprador.id_usuario INNER JOIN dex_libro_premium_speedy ON 
                  dex_libro_premium_speedy.id_libro_premium = dex_usuario_libro_comprador.id_libro_premium AND 
                  dex_libro_premium_speedy.id_libro_premium = ?;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_libro_premium, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    public static function getAll($pdo)
    {
        $query = "SELECT * FROM  " . self::TABLE_NAME . " ORDER BY " . self::FECHA_ACTUALIZACION . " ASC;";
        $prepare_stm = $pdo->prepare($query);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    public static function getDataBuyer($pdo, $id_usuario_comprador)
    {
        $query = "SELECT * FROM dex_usuario_libro_comprador WHERE id_usuario_comprador = ?;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario_comprador, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            return $prepare_stm->fetch(PDO::FETCH_ASSOC);
        } else {
            return null;
        }
    }

    public static function getAllByID($pdo, $id_libro_premium)
    {
        $query = "SELECT * FROM  " . self::TABLE_NAME . " WHERE " . self::ID_LIBRO_PREMIUM . " = ?;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_libro_premium, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            return $prepare_stm->fetch(PDO::FETCH_ASSOC);
        } else {
            return null;
        }
    }

    private static function updateEnvioUsuario($pdo, $id_usuario_libro_comprador, $estado_envio, $observacion)
    {

        $query = "INSERT INTO dex_detalle_envio_speedy(id_usuario_libro_comprador,estado_envio,
                  observacion,fecha_actualizacion) VALUES (?,?,?, NOW());";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario_libro_comprador, PDO::PARAM_INT);
        $prepare_stm->bindValue(2, $estado_envio, PDO::PARAM_STR);
        $prepare_stm->bindValue(3, $observacion, PDO::PARAM_STR);

        return $prepare_stm->execute();
    }

    public static function getLastDetailsSendBook($pdo, $id_usuario_libro_comprador)
    {
        $query = "SELECT * FROM  dex_detalle_envio_speedy WHERE id_usuario_libro_comprador = ? ORDER BY fecha_actualizacion DESC LIMIT 1;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario_libro_comprador, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            return $prepare_stm->fetch(PDO::FETCH_ASSOC);
        } else {
            return null;
        }
    }


    private static function uptPort($pdo, $id_libro_premium, $ruta_portada)
    {

        $query = "UPDATE `dex_libro_premium_speedy` SET `ruta_portada` = ? WHERE `id_libro_premium` = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $ruta_portada, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id_libro_premium, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

}

?>