<?php

require_once 'ConnectionDB.php';
require_once 'API.php';

class Book_User
{

    const TABLE_NAME = "dex_usuario_libro_comprador";
    const ID_USUARIO_COMPRADOR = "id_usuario_comprador";
    const ID_USUARIO = "id_usuario";
    const ID_LIBRO_PREMIUM = "id_libro_premium";
    const TIPO_COMPRA = "tipo_compra";
    const DIRECCION_ENVIO = "direccion_envio";
    const NOMBRES_ENVIO = "nombres_envio";
    const APELLIDOS_ENVIO = "apellidos_envio";
    const CEDULA_ENVIO = "cedula_envio";
    const TELEFONO_ENVIO = "telefono_envio";
    const CIUDAD_ENVIO = "ciudad_envio";
    const PAIS_ENVIO = "pais_envio";
    const EMAIL_ENVIO = "email_envio";
    const PRECIO_COMPRA = "precio_compra";
    const NUMERO_REFERENCIA = "numero_referencia";
    const FECHA_COMPRA = "fecha_compra";
    const ESTADO_COMPRA = "estado_compra";
    const TIPO_PAGO = "tipo_pago";

    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private static $encryption_key = '5166546A576E5A72';
    private static $keyApp = "A80D313B049E3A50E2B4DA77C62B779E0631FC4F8A1B118E99063A7524AB154B";

    public static function setPostRequest($request)
    {
        if ($request[0] == 'register') {
            return Book_User::register();
        }/* else if ($request[0] == 'ebook_download') {
            return Book_User::ebookDownload();
        }*/ else if ($request[0] == 'law_download') {
            return Book_User::lawDownload();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    private static function lawDownload()
    {

        $body = file_get_contents('php://input');
        $Data = json_decode($body);
        // Validar campos
        User::authorizationFromApp();

        if ($Data !== null && ValidComponent::issetField($Data->id_usuario, 900)) {

            $headers = apache_request_headers();
            $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $Data->id_usuario);
            //$id_usuario_php = $Data->id_usuario;
            $emailUser = strtolower(User::getEmailFromID($id_usuario_php));
            $fullNameUser = strtolower(User::getFullNameFromID($id_usuario_php));


            $sending = API::POST(Constants::LOCAL_SERVER() . "/speedycep/mail/sending_buy.php",
                array(
                    "invitation_email" => serialize(array($fullNameUser => $emailUser))
                ), $headers["Authorization"]);

            if ($sending != "true") {
                throw new ExceptionApi(self::UNKNOWN_FAULT, "No se envio el mensaje al correo, pero su transacción ya fue completada.");
            } else {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "Revisa tu correo, la transacción fue completada."
                ];
            }


        }

    }

    /*private static function ebookDownload()
    {

        $body = file_get_contents('php://input');
        $Data = json_decode($body);
        // Validar campos
        User::authorizationFromApp();

        if ($Data !== null && ValidComponent::issetField($Data->id_usuario, 900)
            && ValidComponent::issetField($Data->id_libro_premium, 901)) {

            $headers = apache_request_headers();
            $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $Data->id_usuario);
            //$id_usuario_php = $Data->id_usuario;
            $emailUser = strtolower(User::getEmailFromID($id_usuario_php));
            $fullNameUser = strtolower(User::getFullNameFromID($id_usuario_php));
            if (self::getDataUserBook($id_usuario_php, $Data->id_libro_premium)) {
                $bookData = self::getAllByID($Data->id_libro_premium);
                $subPathSlash = substr($bookData['ruta_portada'], strripos($bookData['ruta_portada'], "/") + 1);
                $subPathWithPoint = substr($subPathSlash, 0, strripos($subPathSlash, "."));

                $sending = API::POST(Constants::LOCAL_SERVER() . "/speedycep/mail/ebookdownload.php",
                    array(
                        "path_ebook" => Constants::PATH_SERVER() . "/speedycep/doc/ebook.php?id=" .  base64_encode(PHP_AES_Cipher::encrypt(self::$encryption_key,$Data->id_libro_premium)) . "&du=" . base64_encode(PHP_AES_Cipher::encrypt(self::$encryption_key, $id_usuario_php)) . "&en=" . base64_encode(PHP_AES_Cipher::encrypt(self::$encryption_key, $subPathWithPoint)),
                        "invitation_email" => serialize(array($fullNameUser => $emailUser))
                    ), $headers["Authorization"]);

                if ($sending != "true") {
                    throw new ExceptionApi(self::UNKNOWN_FAULT, "No se pudo enviar el mensaje al email.");
                } else {
                    return [
                        "status" => self::SUCCESSFUL_CREATION,
                        "message" => "Información enviada al email."
                    ];
                }
            } else {
                throw new ExceptionApi(self::UNKNOWN_FAULT, "No existe una compra en la busqueda.");
            }


        }

    }*/

    private static function register()
    {
        $body = file_get_contents('php://input');
        $Data = json_decode($body);
        // Validar campos
        User::authorizationFromApp();

        if ($Data !== null && ValidComponent::issetField($Data->id_usuario, 900)
            && ValidComponent::issetField($Data->id_libro_premium, 901)
            && ValidComponent::issetField($Data->tipo_compra, 903)
            && ValidComponent::issetField($Data->nombres, 905) && ValidComponent::issetField($Data->apellidos, 906)
            && ValidComponent::issetField($Data->telefono, 907) && ValidComponent::issetField($Data->cedula, 908)
            && ValidComponent::issetField($Data->direccion, 909) && ValidComponent::issetField($Data->ciudad, 910)
            && ValidComponent::issetField($Data->pais, 911) && ValidComponent::issetField($Data->email, 912)
            && ValidComponent::issetField($Data->numero_referencia, 914) && ValidComponent::issetField($Data->precio_compra, 915)
            && ValidComponent::issetField($Data->tipo_pago, 916)) {

            $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $Data->id_usuario);
            //$id_usuario_php = $Data->id_usuario;
            $id_libro_premium_php = $Data->id_libro_premium;
            $tipo_compra = $Data->tipo_compra;//fisico o digital
            $nombres = $Data->nombres;
            $apellidos = $Data->apellidos;
            $telefono = $Data->telefono;
            $cedula = $Data->cedula;
            $direccion = $Data->direccion;
            $ciudad = $Data->ciudad;
            $pais = $Data->pais;
            $email = $Data->email;
            $numero_referencia = $Data->numero_referencia;
            $precio_compra = $Data->precio_compra;
            $tipo_pago = $Data->tipo_pago;//paypal o credito

            //fecha_pago
            $date_pago = new DateTime('now');
            $fecha_compra = $date_pago->format("Y-m-d h:i:s");
            $estado_compra = "PAGADO";
            $fecha_compraT = $date_pago->format("m/d/Y h:i:s a");

            /**/
            $query = "INSERT INTO " . self::TABLE_NAME . " (" . self::ID_USUARIO . ", " . self::ID_LIBRO_PREMIUM . ", " . self::TIPO_COMPRA . ", " . self::DIRECCION_ENVIO . ", " . self::NOMBRES_ENVIO . ", " . self::APELLIDOS_ENVIO . ", " . self::CEDULA_ENVIO . ", " . self::TELEFONO_ENVIO . ",  " . self::CIUDAD_ENVIO . ", " . self::PAIS_ENVIO . ", " . self::EMAIL_ENVIO . ", " . self::PRECIO_COMPRA . ", " . self::NUMERO_REFERENCIA . ", " . self::FECHA_COMPRA . ", " . self::ESTADO_COMPRA . ", " . self::TIPO_PAGO . ") VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

            $pdo = ConnectionDB::getInstance()->getDataBase();
            $prepare_stm = $pdo->prepare($query);
            $prepare_stm->bindParam(1, $id_usuario_php);
            $prepare_stm->bindParam(2, $id_libro_premium_php);
            $prepare_stm->bindParam(3, $tipo_compra);
            $prepare_stm->bindParam(4, $direccion);
            $prepare_stm->bindParam(5, $nombres);
            $prepare_stm->bindParam(6, $apellidos);
            $prepare_stm->bindParam(7, $cedula);
            $prepare_stm->bindParam(8, $telefono);
            $prepare_stm->bindParam(9, $ciudad);
            $prepare_stm->bindParam(10, $pais);
            $prepare_stm->bindParam(11, $email);
            $prepare_stm->bindParam(12, $precio_compra);
            $prepare_stm->bindParam(13, $numero_referencia);
            $prepare_stm->bindParam(14, $fecha_compra);
            $prepare_stm->bindParam(15, $estado_compra);
            $prepare_stm->bindParam(16, $tipo_pago);

            $result = $prepare_stm->execute();
            if ($result) {
                $id_usuario_libro_comprador = $pdo->lastInsertId();
                http_response_code(200);


                $emailUser = strtolower(User::getEmailFromID($id_usuario_php));
                $fullNameUser = strtolower(User::getFullNameFromID($id_usuario_php));

                //get emails to send copy.
                $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/setting_app/get/",
                    array(), self::$keyApp);
                $data = API::JSON_TO_ARRAY($multi_info_api);
                $emails_for_books = $data["data"][0]['emails_for_books'];
                $arr_data = json_decode($emails_for_books, true);

                $email_principal = $arr_data['email_principal'];
                $email_option_a = $arr_data['email_option_a'];
                $email_option_b = $arr_data['email_option_b'];
                //create array emails
                $invitation_emails = array(
                    $fullNameUser => $emailUser
                );

                if ($email_principal != "") {
                    $invitation_emails["Correo principal"] = $email_principal;
                }

                if ($email_option_a != "") {
                    $invitation_emails["Correo opcional 1"] = $email_option_a;
                }

                if ($email_option_b != "") {
                    $invitation_emails["Correo opcional 2"] = $email_option_b;
                }

                $pdo = ConnectionDB::getInstance()->getDataBase();
                $arr_data = Book::getInfoByID($id_libro_premium_php, $pdo);

                API::POST(Constants::LOCAL_SERVER() . "/speedycep/mail/sending_message_pay_book.php",
                    array(
                        "nombre_usuario" => $fullNameUser,
                        "email_usuario" => $emailUser,
                        "tipo_book" => $tipo_compra,
                        "titulo_book" => strtoupper($arr_data->titulo_libro),
                        "autor_book" => strtoupper($arr_data->autor),
                        "edicion_book" => strtoupper($arr_data->edicion),
                        "direccion_usuario" => $direccion . ", Ciudad " . $ciudad . ", " . $pais,
                        "telefono_usuario" => $telefono,
                        "fecha_y_hora_compra" => strtoupper($fecha_compraT),
                        "num_transaccion" => $numero_referencia,
                        "monto_pagado" => $precio_compra,
                        "invitation_email" => serialize($invitation_emails)
                    ), self::$keyApp);



                if ($tipo_compra == "FISICO") {
                    return [
                        "status" => self::SUCCESSFUL_CREATION,
                        "message" => "¡Enhorabuena el libro ha sido comprado!",
                        "id_usuario_libro_comprador" => $id_usuario_libro_comprador,
                        "fecha_compra" => $fecha_compra,
                        "id_detalle_envio_speedy" => self::registerDetails($id_usuario_libro_comprador)
                    ];
                } else {
                    return [
                        "status" => self::SUCCESSFUL_CREATION,
                        "message" => "¡Enhorabuena! El libro digital va a ser enviado al email",
                        "id_usuario_libro_comprador" => $id_usuario_libro_comprador,
                        "fecha_compra" => $fecha_compra
                    ];
                }
            } else {
                throw new ExceptionApi(self::ERROR_DATABASE, "Ocurrio un error al insertar la información", 400);
            }

        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Parametros incorrectos", 400);
        }
    }


    private static function registerDetails($id_usuario_libro_comprador)
    {

        $query = "INSERT INTO dex_detalle_envio_speedy (id_usuario_libro_comprador, estado_envio, fecha_actualizacion, observacion) VALUES (?, ?, ?, ?)";
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $prepare_stm = $pdo->prepare($query);

        $date_pago = new DateTime('now');
        $fecha_actualizacion = $date_pago->format("Y-m-d h:i:s");
        $estado = "INFORMACION RECIBIDA";
        $obs = "INFORMACION RECIBIDA DESDE APP";
        $prepare_stm->bindParam(1, $id_usuario_libro_comprador);
        $prepare_stm->bindParam(2, $estado);
        $prepare_stm->bindParam(3, $fecha_actualizacion);
        $prepare_stm->bindParam(4, $obs);
        $result = $prepare_stm->execute();
        if ($result) {
            $id_detalle_envio_speedy = $pdo->lastInsertId();
            return $id_detalle_envio_speedy;
        } else {
            return -1;
        }
    }

    private static function getDataUserBook($id_usuario, $id_libro_premium)
    {

        $query = "SELECT dex_usuario_libro_comprador.id_usuario_comprador FROM dex_usuario_libro_comprador INNER JOIN dex_usuario_new ON dex_usuario_new.id_usuario = dex_usuario_libro_comprador.id_usuario INNER JOIN dex_libro_premium_speedy ON dex_libro_premium_speedy.id_libro_premium = dex_usuario_libro_comprador.id_libro_premium AND dex_usuario_libro_comprador.tipo_compra = ? AND dex_usuario_libro_comprador.id_usuario = ? AND dex_libro_premium_speedy.id_libro_premium = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, "EBOOK", PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id_usuario, PDO::PARAM_INT);
        $prepare_stm->bindValue(3, $id_libro_premium, PDO::PARAM_INT);
        $prepare_stm->execute();
        return $prepare_stm->fetchColumn(0) > 0;
    }

    public static function getAllByID($id_libro_premium)
    {
        $query = "SELECT * FROM  dex_libro_premium_speedy WHERE " . self::ID_LIBRO_PREMIUM . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $id_libro_premium, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            return $prepare_stm->fetch(PDO::FETCH_ASSOC);
        } else {
            return null;
        }
    }
}

?>