<?php

require_once 'ConnectionDB.php';
require_once 'API.php';

class Cod_promocional
{

    const TABLE_NAME = "dex_cod_promocional";
    const ID_DEX_COD_PROMOCIONAL = "id_dex_cod_promocional";
    const CODIGO = "codigo";
    const DURACION = "duracion";
    const FECHA_INICIAL = "fecha_inicial";
    const FECHA_EXPIRACION = "fecha_expiracion";
    const TIPO_PROMOCIONAL = "tipo_promocional";
    const ESTADO = "estado";
    const EMAIL_ASSOC = "email_assoc";
    const EMAIL_CREADOR = "email_creador";
    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private static $encryption_key = '5166546A576E5A72';

    public static function setPostRequest($request)
    {

        if ($request[0] == 'register_invitation') {
            return Cod_promocional::registerInvitations();
        } else if ($request[0] == 'assign_invitation') {
            return Cod_promocional::assignInvitation();
        } else if ($request[0] == 'generate') {
            return Cod_promocional::autoGenerate();
        } else if ($request[0] == 'verify') {
            return Cod_promocional::verifyGenerate();
        } else if ($request[0] == 'register_todo_code') {
            return Cod_promocional::registerTodoCode();
        } else if ($request[0] == 'register_multiple_todo_code') {
            return Cod_promocional::registerMultipleTodoCode();
        } else if ($request[0] == 'edit_todo_code') {
            return Cod_promocional::editTodoCode();
        } else if ($request[0] == 'delete_todo_code') {
            return Cod_promocional::deleteTodoCode();
        } else if ($request[0] == 'get_todo_code') {
            return Cod_promocional::getTodoCode();
        } else if ($request[0] == 'send_code_to_email') {
            return Cod_promocional::sendCodeToEmail();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    private static function sendCodeToEmail()
    {

        $body = file_get_contents('php://input');
        $data = json_decode($body);
        // Validar campos
        User::authorizationFromApp();


        if ($data != null) {
            if (ValidComponent::issetField($data->id_usuario, 100)
                && ValidComponent::issetField($data->cod_promocional, 101)) {

                $headers = apache_request_headers();
                $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $data->id_usuario);
                //$id_usuario_php = $data->id_usuario;
                $pdo = ConnectionDB::getInstance()->getDataBase();
                $emailUser = strtolower(User::getEmailFromID($id_usuario_php));
                $fullNameUser = strtolower(User::getFullNameFromID($id_usuario_php));

                $sending = API::POST(Constants::LOCAL_SERVER() . "/speedycep/mail/reinvitations.php",
                    array(
                        "codigo" => $data->cod_promocional,
                        "invitation_email" => serialize(array($fullNameUser => $emailUser))
                    ), $headers["Authorization"]);


                if ($sending != "true") {
                    throw new ExceptionApi(self::UNKNOWN_FAULT, "No se pudo enviar el mensaje al email.");
                } else {
                    return [
                        "status" => self::SUCCESSFUL_CREATION,
                        "message" => "Información enviada al email."
                    ];
                }
            }
        } else {
            throw new ExceptionApi(self::UNKNOWN_FAULT, "Información incompleta.");
        }

    }

    private static function getTodoCode()
    {
        User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $result = self::getAll($pdo);
        if ($result) {
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "message" => "¡Encontrado!",
                "data" => $result
            ];
        }
    }

    private static function deleteTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['code'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Cod_promocional();
            $result = $cd->deleteTodo($pdo, $_POST['code']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Eliminado!"
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Error - no fue posible eliminar el código promocional."
                ];
            }
        }
    }

    private static function editTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['duration']) && isset($_POST['code'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Cod_promocional();
            $result = $cd->modifyTodo($pdo, $_POST['code'], $_POST['duration']);
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "message" => "¡Editado!",
                "data" => self::getDataCode($_POST['code'])
            ];
        }
    }

    private static function registerMultipleTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['count_codes']) && isset($_POST['duracion_codes'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Cod_promocional();
            //$result = $cd->insertCodPromocionalTODO($pdo, $_POST['code'], $_POST['duration'], $_POST['date']);
            $count_codes = $_POST['count_codes'];
            $duracion_codes = $_POST['duracion_codes'];
            $customInsert = "INSERT INTO " . self::TABLE_NAME . " (" . self::CODIGO . ", " . self::DURACION . ", " . self::FECHA_INICIAL . ", " . self::TIPO_PROMOCIONAL . ", " . self::ESTADO . ") VALUES ";
            $tipo_promocional = "TODO";
            $estado = "INVITACION";
            $fecha_inicial = date("Y-m-d H:i:s");
            $data = array();
            for ($i = 0; $i < $count_codes; $i++) {
                $codigo_promocional = $cd->generateCodPromocional($pdo);
                $customInsert .= "('" . $codigo_promocional . "','" . $duracion_codes . "', '" . $fecha_inicial . "','" . $tipo_promocional . "','" . $estado . "')";
                if ($i >= 0 && $i < $count_codes - 1) {
                    $customInsert .= ",";
                }
                $row = array(
                    "codigo" => $codigo_promocional,
                    "duracion" => $duracion_codes,
                    "fecha_inicial" => $fecha_inicial,
                    "estado" => $estado
                );
                $data[] = $row;
            }

            $customInsert .= ";";
            $prepare_stm = $pdo->prepare($customInsert);
            if ($prepare_stm->execute()){
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "Insertados correctamente.",
                    "data" => $data
                ];
            }
        }
    }


    private static function registerTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['duration']) && isset($_POST['date']) && isset($_POST['code'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Cod_promocional();
            $result = $cd->insertCodPromocionalTODO($pdo, $_POST['code'], $_POST['duration'], $_POST['date']);
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "message" => "¡Registrado!",
                "data" => self::getDataCode($_POST['code'])
            ];
        }
    }

    private static function getDataCode($code)
    {
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $cd = new Cod_promocional();
        return $cd->getInfoByCode($code, $pdo);
    }

    private static function verifyGenerate()
    {
        if (isset($_POST['auto_code'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Cod_promocional();
            $result = $cd->getInfoByCode($_POST['auto_code'], $pdo);
            if (!$result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "No existe el código promocional",
                    "data" => false
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Ya existe el código promocional",
                    "data" => true
                ];
            }
        } else {
            return [
                "status" => self::FAILED_CREATION,
                "message" => "No se pudo verificar el código"
            ];
        }
    }

    private static function autoGenerate()
    {
        // Validar campos
        User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $cd = new Cod_promocional();
        return [
            "status" => self::SUCCESSFUL_CREATION,
            "message" => "Generado.",
            "data" => $cd->generateCodPromocional($pdo)
        ];
    }

    private static function assignInvitation()
    {
        $body = file_get_contents('php://input');
        $data = json_decode($body);
        // Validar campos
        User::authorizationFromApp();

        if ($data != null) {
            if (ValidComponent::issetField($data->id_usuario, 100)
                && ValidComponent::issetField($data->cod_promocional, 101)) {

                $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $data->id_usuario);
                //$id_usuario_php = $data->id_usuario;
                $pdo = ConnectionDB::getInstance()->getDataBase();
                $cd = new Cod_promocional();
                $dataCodPromocional = $cd->getInfoByCode($data->cod_promocional, $pdo);
                $flag_promocional = false;
                if (is_object($dataCodPromocional)) {
                    if ($dataCodPromocional->estado == "INVITACION") {
                        $temp_duracion_cod_promocional = $dataCodPromocional->duracion;
                        $temp_id_cod_promocional = $dataCodPromocional->id_dex_cod_promocional;
                        $temp_email_creador = $dataCodPromocional->email_creador;
                        $temp_email_assoc = $dataCodPromocional->email_assoc;

                        if ($dataCodPromocional->tipo_promocional == "EMAIL") {
                            //verificar si el email tiene assoc el codigo.
                            if (strtolower($temp_email_assoc) == strtolower(User::getEmailFromID($id_usuario_php))) {
                                $flag_promocional = true;
                            } else {
                                throw new ExceptionApi(self::FAILED_CREATION, "Código promocional " . $data->cod_promocional . " pertenece a otro usuario.");
                            }
                        } else {
                            $flag_promocional = true;
                        }


                        if ($flag_promocional) {
                            $id_usuario_temp = $id_usuario_php;
                            //registro en tabla usuario_cod_pro
                            $objUsuario_cod_pro = new Usuario_cod_pro();
                            $dia_q_caduca = User::newFechaCaducidadPremium($id_usuario_temp, $temp_duracion_cod_promocional);
                            $res = $objUsuario_cod_pro->registerUsuarioCodPromocional($pdo, $temp_duracion_cod_promocional, $id_usuario_temp, $temp_id_cod_promocional, $dia_q_caduca);
                            if ($res) {
                                //se puede modificar el estado del codigo a usado.
                                $cd->modifyEstado($pdo, $temp_id_cod_promocional, "EN USO");
                                //modifica la fecha de caducidad agregando la duración del código promocional.
                                User::updateFechaCaducidadPremium($id_usuario_temp, $temp_duracion_cod_promocional);
                                if ($temp_email_creador != "") {
                                    //crear un cupo al usuario creador o que invita.
                                    $cd->insertCodPromocional($pdo, $temp_email_creador, "EMAIL", "");
                                }
                                http_response_code(200);
                                return [
                                    "status" => self::SUCCESSFUL_CREATION,
                                    "message" => "¡Código promocional aceptado!",
                                    "new_date_expire" => $dia_q_caduca
                                ];
                            }
                        }

                    } else {
                        throw new ExceptionApi(self::FAILED_CREATION, "Código promocional " . $data->cod_promocional . " usado, por favor ingrese otro.");
                    }

                } else {
                    throw new ExceptionApi(self::UNKNOWN_FAULT, "No existe el código ingresado.");
                }
            }
        } else {
            throw new ExceptionApi(self::UNKNOWN_FAULT, "Información incompleta.");
        }
    }

    private static function registerInvitations()
    {
        $body = file_get_contents('php://input');
        $emails = json_decode($body);
        // Validar campos
        User::authorizationFromApp();

        if ($emails != null) {
            if (ValidComponent::issetField($emails->email_creador, 100)
                && ValidComponent::issetField($emails->name_creador, 101)
                && ValidComponent::issetField($emails->email_invitation_one, 102)
                && ValidComponent::issetField($emails->email_invitation_two, 103)
                && ValidComponent::issetField($emails->email_invitation_three, 104)
                && !ValidComponent::compareStrings($emails->email_invitation_one, $emails->email_invitation_two)
                && !ValidComponent::compareStrings($emails->email_invitation_one, $emails->email_invitation_three)
                && !ValidComponent::compareStrings($emails->email_invitation_two, $emails->email_invitation_three)) {

                $email_one = $emails->email_invitation_one;
                $email_two = $emails->email_invitation_two;
                $email_three = $emails->email_invitation_three;
                $email_creador = $emails->email_creador;
                $name_creador = $emails->name_creador;
                $flag = "";
                $bool_flag_one = false;
                $bool_flag_two = false;
                $bool_flag_three = false;

                if ((Valid::validEmailWithEmpty($emails->email_invitation_one) && User::notExistEmail(strtolower($emails->email_invitation_one)) && self::getNotInvitationEmail($emails->email_invitation_one))
                    && (Valid::validEmailWithEmpty($emails->email_invitation_two) && User::notExistEmail(strtolower($emails->email_invitation_two)) && self::getNotInvitationEmail($emails->email_invitation_two))
                    && (Valid::validEmailWithEmpty($emails->email_invitation_three) && User::notExistEmail(strtolower($emails->email_invitation_three))) && self::getNotInvitationEmail($emails->email_invitation_three)) {

                    //register
                    $pdo = ConnectionDB::getInstance()->getDataBase();
                    $objCod_promocional = new Cod_promocional();
                    $headers = apache_request_headers();

                    if ($email_one != "") {
                        $resul = $objCod_promocional->insertCodPromocional($pdo, $email_one, "EMAIL", $email_creador);
                        if (!$resul) {
                            $flag = self::setFlagValue($flag, "Hubo un problema al realizar la invitación al primer email, no se realizo el registro.");
                        } else {
                            //enviar email --> usando protocolo.
                            $last_id_dex_cod_promocional = $pdo->lastInsertId();
                            $dataLastCodPromocional = $objCod_promocional->getInfoByID($last_id_dex_cod_promocional, $pdo);
                            $sending = API::POST(Constants::LOCAL_SERVER() . "/speedycep/mail/invitations.php",
                                array(
                                    "name_creador" => $name_creador,
                                    "codigo" => $dataLastCodPromocional->codigo,
                                    "invitation_email" => serialize(array($name_creador => $email_one))
                                ), $headers["Authorization"]);

                            if ($sending != "true") {
                                //si no se envia el mensaje se elimina de la base de datos.
                                $objCod_promocional->delete($pdo, $last_id_dex_cod_promocional);
                                $flag = self::setFlagValue($flag, "No se pudo enviar el mensaje al primer email.");
                            } else {
                                $flag = self::setFlagValue($flag, "El mensaje con el código promocional fue enviado a: " . $email_one);
                                $bool_flag_one = $sending;
                            }
                        }

                    }

                    if ($email_two != "") {
                        $resul = $objCod_promocional->insertCodPromocional($pdo, $email_two, "EMAIL", $email_creador);
                        if (!$resul) {
                            $flag = self::setFlagValue($flag, "Hubo un problema al realizar la invitación al segundo email, no se realizo el registro.");
                        } else {

                            //enviar email --> usando protocolo.
                            $last_id_dex_cod_promocional = $pdo->lastInsertId();
                            $dataLastCodPromocional = $objCod_promocional->getInfoByID($last_id_dex_cod_promocional, $pdo);
                            $sending = API::POST(Constants::LOCAL_SERVER() . "/speedycep/mail/invitations.php",
                                array(
                                    "name_creador" => $name_creador,
                                    "codigo" => $dataLastCodPromocional->codigo,
                                    "invitation_email" => serialize(array($name_creador => $email_two))
                                ), $headers["Authorization"]);

                            if ($sending != "true") {
                                //si no se envia el mensaje se elimina de la base de datos.
                                $objCod_promocional->delete($pdo, $last_id_dex_cod_promocional);
                                $flag = self::setFlagValue($flag, "No se pudo enviar el mensaje al segundo email.");
                            } else {
                                $flag = self::setFlagValue($flag, "El mensaje con el código promocional fue enviado a: " . $email_two);
                                $bool_flag_two = $sending;
                            }
                        }
                    }

                    if ($email_three != "") {
                        $resul = $objCod_promocional->insertCodPromocional($pdo, $email_three, "EMAIL", $email_creador);
                        if (!$resul) {
                            $flag = self::setFlagValue($flag, "Hubo un problema al realizar la invitación al tercer email, no se realizo el registro.");
                        } else {
                            //enviar email --> usando protocolo.
                            $last_id_dex_cod_promocional = $pdo->lastInsertId();
                            $dataLastCodPromocional = $objCod_promocional->getInfoByID($last_id_dex_cod_promocional, $pdo);
                            $sending = API::POST(Constants::LOCAL_SERVER() . "/speedycep/mail/invitations.php",
                                array(
                                    "name_creador" => $name_creador,
                                    "codigo" => $dataLastCodPromocional->codigo,
                                    "invitation_email" => serialize(array($name_creador => $email_three))
                                ), $headers["Authorization"]);

                            if ($sending != "true") {
                                //si no se envia el mensaje se elimina de la base de datos.
                                $objCod_promocional->delete($pdo, $last_id_dex_cod_promocional);
                                $flag = self::setFlagValue($flag, "No se pudo enviar el mensaje al tercer email.");
                            } else {
                                $flag = self::setFlagValue($flag, "El mensaje con el código promocional fue enviado a: " . $email_three);
                                $bool_flag_three = $sending;
                            }
                        }
                    }
                }

                if ($bool_flag_one || $bool_flag_two || $bool_flag_three) {
                    http_response_code(200);
                } else {
                    http_response_code(422);
                }

                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => $flag
                ];


            }
        } else {
            throw new ExceptionApi(self::UNKNOWN_FAULT, "Información incompleta.");
        }

    }

    private static function setFlagValue($flag, $text)
    {
        return $flag . $text . "\n";
    }

    private static function getNotInvitationEmail($email_assoc)
    {
        $query = "SELECT COUNT(" . self::EMAIL_ASSOC . ") FROM " . self::TABLE_NAME . " WHERE " . self::EMAIL_ASSOC . " = ? AND " . self::ESTADO . " = ? AND " . self::FECHA_EXPIRACION . " > NOW()";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, strtolower($email_assoc));
        $prepare_stm->bindValue(2, "INVITACION");
        $prepare_stm->execute();
        if ($prepare_stm->fetchColumn(0) <= 0) {
            return true;
        } else {
            throw new ExceptionApi(self::ERROR_DATABASE, "El email " . $email_assoc . " ya posee una invitación, ingrese otro.", 422);
        }
    }

    public function getInfoByCode($codigo, $pdo)
    {
        $query = "SELECT " . self::ID_DEX_COD_PROMOCIONAL . "," . self::FECHA_INICIAL . "," . self::FECHA_EXPIRACION . "," . self::ESTADO . "," . self::TIPO_PROMOCIONAL . "," . self::EMAIL_ASSOC . "," . self::DURACION . "," . self::EMAIL_CREADOR . " FROM  " . self::TABLE_NAME . " WHERE " . self::CODIGO . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $codigo, PDO::PARAM_STR);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetchObject();
            return $result;
        } else {
            return null;
        }
    }


    public static function getInfoByID($id, $pdo)
    {
        $query = "SELECT " . self::CODIGO . "," . self::FECHA_EXPIRACION . "," . self::ESTADO . "," . self::TIPO_PROMOCIONAL . "," . self::EMAIL_ASSOC . "," . self::DURACION . "," . self::EMAIL_CREADOR . " FROM  " . self::TABLE_NAME . " WHERE " . self::ID_DEX_COD_PROMOCIONAL . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetchObject();
            return $result;
        } else {
            return null;
        }
    }

    private function generateCodPromocional($pdo)
    {
        do {
            $auto_code = rand(1000, 9999) . "-" . rand(1000, 9999) . "-" . rand(1000, 9999);
        } while ($this->getInfoByCode($auto_code, $pdo));

        return $auto_code;
    }

    public function insertCodPromocional($pdo, $email_assoc, $tipo_promocional, $email_creador)
    {

        $query = "INSERT INTO " . self::TABLE_NAME . "(" . self::CODIGO . ", 
                " . self::TIPO_PROMOCIONAL . ", 
                " . self::ESTADO . ", 
                " . self::EMAIL_ASSOC . ", 
                " . self::EMAIL_CREADOR . ",
                " . self::DURACION . ", 
                " . self::FECHA_INICIAL . ") VALUES (?,?,?,?,?,?,NOW())";

        $codigo = $this->generateCodPromocional($pdo);

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $codigo, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $tipo_promocional, PDO::PARAM_STR);
        $prepare_stm->bindValue(3, "INVITACION", PDO::PARAM_STR);
        $prepare_stm->bindValue(4, $email_assoc, PDO::PARAM_STR);
        $prepare_stm->bindValue(5, $email_creador, PDO::PARAM_STR);
        $prepare_stm->bindValue(6, 90, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

    public function modifyEstado($pdo, $id_dex_cod_promocional, $estado)
    {

        $query = "UPDATE " . self::TABLE_NAME . "
                        SET 
                        " . self::ESTADO . " = ?
                        WHERE " . self::ID_DEX_COD_PROMOCIONAL . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $estado, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id_dex_cod_promocional, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

    public function delete($pdo, $id_dex_cod_promocional)
    {

        $query = "DELETE FROM " . self::TABLE_NAME . " WHERE " . self::ID_DEX_COD_PROMOCIONAL . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_dex_cod_promocional, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

    public function deleteTodo($pdo, $codigo)
    {

        $query = "DELETE FROM " . self::TABLE_NAME . " WHERE " . self::CODIGO . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $codigo, PDO::PARAM_STR);

        return $prepare_stm->execute();
    }

    public function modifyTodo($pdo, $codigo, $duracion)
    {
        $query = "UPDATE " . self::TABLE_NAME . "
                        SET 
                        " . self::DURACION . " = ?
                        WHERE " . self::CODIGO . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $duracion, PDO::PARAM_INT);
        $prepare_stm->bindValue(2, $codigo, PDO::PARAM_STR);

        return $prepare_stm->execute();
    }

    public function insertCodPromocionalTODO($pdo, $codigo, $duracion, $fecha_inicial)
    {

        $query = "INSERT INTO " . self::TABLE_NAME . "(" . self::CODIGO . ", 
                " . self::TIPO_PROMOCIONAL . ", 
                " . self::ESTADO . ", 
                " . self::DURACION . ", 
                " . self::FECHA_INICIAL . ") VALUES (?,?,?,?,?)";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $codigo, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, "TODO", PDO::PARAM_STR);
        $prepare_stm->bindValue(3, "INVITACION", PDO::PARAM_STR);
        $prepare_stm->bindValue(4, $duracion, PDO::PARAM_INT);
        $prepare_stm->bindValue(5, $fecha_inicial, PDO::PARAM_STR);

        return $prepare_stm->execute();
    }

    public static function getAll($pdo)
    {
        $query = "SELECT " . self::CODIGO . "," . self::FECHA_INICIAL . "," . self::FECHA_EXPIRACION . "," . self::ESTADO . "," . self::TIPO_PROMOCIONAL . "," . self::DURACION . " FROM  " . self::TABLE_NAME . "  ORDER BY " . self::FECHA_EXPIRACION . " ASC;";
        $prepare_stm = $pdo->prepare($query);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    public static function getCodAssocUser($id_usuario)
    {
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $pdo->query("SET lc_time_names = 'es_EC'");
        $query = "SELECT * FROM (SELECT contrat.id_usu_ser_contratado as id, contrat.metodo_pago as tipo, contrat.fecha_expiracion as fecha, CONCAT(\"Tienes activado el servicio premium hasta el \", DATE_FORMAT(contrat.fecha_expiracion, \"%d\"), \" de \", DATE_FORMAT(contrat.fecha_expiracion, \"%M\"), \" de \", DATE_FORMAT(contrat.fecha_expiracion, \"%Y\")) as tiempo_suscripcion FROM cepweb.dex_usu_ser_contratado as contrat INNER JOIN dex_usuario_new as user_credit ON contrat.id_usuario = user_credit.id_usuario AND user_credit.id_usuario = ? 
UNION ALL SELECT user_cod.id_usuario_cod_pro as id, 'CODIGO PROMOCIONAL' as tipo, cod.fecha_expiracion as fecha, CONCAT(\"Tienes activado el servicio premium hasta el \", DATE_FORMAT(user_cod.fecha_expiracion, \"%d\"), \" de \", DATE_FORMAT(user_cod.fecha_expiracion, \"%M\"), \" de \", DATE_FORMAT(user_cod.fecha_expiracion, \"%Y\")) as tiempo_suscripcion FROM cepweb.dex_usuario_cod_pro as user_cod INNER JOIN dex_usuario_new as user INNER JOIN dex_cod_promocional as cod ON user_cod.id_usuario = user.id_usuario AND user_cod.id_cod_promocional = cod.id_dex_cod_promocional AND user.id_usuario = ?) as a ORDER BY fecha DESC;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario, PDO::PARAM_INT);
        $prepare_stm->bindValue(2, $id_usuario, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            ConnectionDB::getInstance()->_destructor();
            return $rows;
        } else {
            return null;
        }
    }


}

?>