<?php
require_once 'ConnectionDB.php';
require_once 'API.php';

class Contact
{
    const TABLE_NAME = "dex_contact";
    const ID_CONTACT = "id_contact";
    const NOMBRES = "nombres";
    const APELLIDOS = "apellidos";
    const EMAIL = "email";
    const MENSAJE = "mensaje";
    const SUBJECT = "subject";
    const TEMA = "tema";
    const FECHA_ENVIO = "fecha_envio";

    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;

    public static function setPostRequest($request)
    {

        if ($request[0] == 'register') {
            return Contact::registerMessage();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    public static function setGetRequest($request)
    {
        if ($request[0] == 'all') {

        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }


    private static function registerMessage()
    {
        $body = file_get_contents('php://input');
        $contact = json_decode($body);
        // Validar campos
        User::authorizationFromApp();

        if ($contact != null) {
            if (ValidComponent::issetField($contact->nombre_usuario, 100)
                && ValidComponent::isEmptyField("Nombres*", $contact->nombre_usuario)
                && ValidComponent::issetField($contact->apellido_usuario, 101)
                && ValidComponent::isEmptyField("Apellidos*", $contact->apellido_usuario)
                && ValidComponent::issetField($contact->email_usuario, 102)
                && ValidComponent::isEmptyField("Email*", $contact->email_usuario)
                && Valid::validEmail($contact->email_usuario)
                && ValidComponent::issetField($contact->message, 103)
                && ValidComponent::isEmptyField("Mensaje*", $contact->message)
                && ValidComponent::issetField($contact->tema, 104)
                && ValidComponent::isEmptyField("Tema*", $contact->tema)
                && ValidComponent::issetField($contact->subject, 105)
                && ValidComponent::isEmptyField("Subject*", $contact->subject)
                && ValidComponent::issetField($contact->servicio_speedy, 106)
                && ValidComponent::issetField($contact->direccion, 107)
                && ValidComponent::issetField($contact->telefono, 108)) {

                $nombre_usuario = $contact->nombre_usuario;
                $apellido_usuario = $contact->apellido_usuario;
                $email_usuario = $contact->email_usuario;
                $message = $contact->message;
                $tema = $contact->tema;
                $subject = $contact->subject;

                $servicio_speedy = $contact->servicio_speedy;
                $direccion = $contact->direccion;
                $telefono = $contact->telefono;

                //register
                $pdo = ConnectionDB::getInstance()->getDataBase();

                $query = "INSERT INTO " . self::TABLE_NAME . "(" . self::NOMBRES . ", 
                " . self::APELLIDOS . ", 
                " . self::EMAIL . ", 
                " . self::MENSAJE . ",
                " . self::TEMA . ", 
                " . self::SUBJECT . ", 
                " . self::FECHA_ENVIO . ") VALUES (?,?,?,?,?,?,NOW())";


                $prepare_stm = $pdo->prepare($query);
                $prepare_stm->bindValue(1, $nombre_usuario, PDO::PARAM_STR);
                $prepare_stm->bindValue(2, $apellido_usuario, PDO::PARAM_STR);
                $prepare_stm->bindValue(3, $email_usuario, PDO::PARAM_STR);
                $prepare_stm->bindValue(4, $message, PDO::PARAM_STR);
                $prepare_stm->bindValue(5, $tema, PDO::PARAM_STR);
                $prepare_stm->bindValue(6, $subject, PDO::PARAM_STR);

                $result = $prepare_stm->execute();
                if ($result) {
                    $headers = apache_request_headers();
                    $sending = API::POST_SERVER(Constants::LOCAL_SERVER()."/speedycep/mail/sending.php",
                        array(
                            "names" => $nombre_usuario . " " . $apellido_usuario,
                            "email_usuario" => $email_usuario,
                            "tema" => $tema,
                            "message" => $message,
                            "subject" => $subject,
                            "servicio_speedy" => $servicio_speedy,
                            "direccion" => $direccion,
                            "telefono" => $telefono
                        ), $headers["Authorization"]);

                    if ($sending == "true") {
                        http_response_code(200);
                        return [
                            "status" => self::SUCCESSFUL_CREATION,
                            "message" => "¡Mensaje enviado!"
                        ];
                    } else {
                        throw new ExceptionApi(self::UNKNOWN_FAULT, "Error al enviar");
                    }
                } else {
                    throw new ExceptionApi(self::UNKNOWN_FAULT, "1001 - No se pudo enviar el mensaje");
                }
            }
        } else {
            throw new ExceptionApi(self::UNKNOWN_FAULT, "Información incompleta.");
        }

    }


}

?>