<?php
/**
 * Created by PhpStorm.
 * User: chaGB
 * Date: 8/8/2019
 * Time: 9:43 a.m.
 */

ini_set('memory_limit', '-1');
require_once 'ConnectionDB.php';

class Correspondencia
{

    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private static $encryption_key = '5166546A576E5A72';


    public static function setPostRequest($request)
    {

        if ($request[0] == 'article') {
            return Correspondencia::getInfoArtFromDoc();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    public static function setGetRequest($request)
    {
        if ($request[0] == 'all') {

        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }


    public static function getInfoArtFromDoc()
    {
        $body = file_get_contents('php://input');
        $artObject = json_decode($body);
        // Validar campos
        User::authorizationFromApp();
        if ($artObject !== null
            && ValidComponent::issetField($artObject->art, 600)) {

            $art = $artObject->art;
            $art_parts = explode("?", $art);
            if (count($art_parts) > 1) {
                $correspondencia = $art_parts[0];
                $str_articulos = $art_parts[1];
                $docInfo = self::getDocIDByCorrespondencia($correspondencia);
                if ($docInfo !== false) {
                    $artsComa = explode(",", $str_articulos);

                    if (count($artsComa) > 1) {//hay un signo de coma luego del explode con signo de interrogación

                        $finalArray = array();
                        foreach ($artsComa as $row) {
                            $arrayTemp = self::checkSearchArt($row, $docInfo['doc_id']);
                            foreach ($arrayTemp as $item) {
                                $finalArray[] = $item;
                            }
                        }

                        return [
                            "status" => self::SUCCESSFUL_CREATION,
                            "articulos" => $finalArray
                        ];

                    } else {// si el count es menor a 1 entonces no hay coma por lo que se procede a preguntar si hay guión (-)

                        return [
                            "status" => self::SUCCESSFUL_CREATION,
                            "articulos" => self::checkSearchArt($str_articulos, $docInfo['doc_id'])
                        ];

                    }

                } else {
                    //deroga comprobación
                    return [
                        "status" => self::FAILED_CREATION,
                        "message" => "No se encontro información en la concordancia: " . $correspondencia . " " . $str_articulos
                    ];
                }
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "600 - fue imposible recuperar los datos"
                ];
            }

        }
    }

    private static function checkSearchArt($str_articulos, $docId)
    {
        $artsGuion = explode("-", $str_articulos);
        if (count($artsGuion) > 1) {
            $start_sort_position_art = $artsGuion[0];
            $end_sort_position_art = $artsGuion[1];

            return Articulos::encryptDataArticulos(self::getRangeArt($docId, $start_sort_position_art, $end_sort_position_art));
        } else {
            $arts_value = $str_articulos;
            $art_num = self::extractArtNumClean($arts_value);

            return Articulos::encryptDataArticulos(self::getArticuloID($docId, $art_num));
        }
    }


    public static final function encryptDataCorrespondencia($result)
    {
        for ($i = 0; $i < count($result); $i++) {
            $result[$i]["id_corres"] = PHP_AES_Cipher::encrypt(self::$encryption_key, $result[$i]["id_corres"]);
            $result[$i]["idsigla"] = PHP_AES_Cipher::encrypt(self::$encryption_key, $result[$i]["idsigla"]);

        }
        return $result;
    }

    public static function getInfoCorrespondencia($docId)
    {
        $query = "SELECT corr.* FROM dex_documentos_legis INNER JOIN dex_correspondencias as corr ON dex_documentos_legis.id_corres = corr.id_corres AND dex_documentos_legis.doc_id = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $docId, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    private static function getDocIDByCorrespondencia($correspondencia)
    {
        $query = "SELECT doc_id FROM dex_documentos_legis INNER JOIN dex_correspondencias as corr ON dex_documentos_legis.id_corres = corr.id_corres AND corr.correspondencia = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $correspondencia, PDO::PARAM_STR);
        if ($prepare_stm->execute()) {
            return $prepare_stm->fetch(PDO::FETCH_ASSOC);
        } else {
            return null;
        }
    }

    private static function getRangeArt($docId, $start, $end)
    {
        //consultar los art_num
        $from_art_sort_position = self::getArtSortPositionByNum($start, $docId);
        $to_art_sort_position = self::getArtSortPositionByNum($end, $docId);


        $query = "SELECT art.* FROM dex_documentos_legis INNER JOIN dex_articulos as art ON dex_documentos_legis.doc_id = art.doc_id AND dex_documentos_legis.doc_id = ? AND art.art_sort_position BETWEEN ? AND ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $docId, PDO::PARAM_INT);
        $prepare_stm->bindValue(2, $from_art_sort_position, PDO::PARAM_STR);
        $prepare_stm->bindValue(3, $to_art_sort_position, PDO::PARAM_STR);
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    private static function getArtSortPositionByNum($art_num, $docId)
    {

        $query = "SELECT art_sort_position FROM dex_articulos WHERE art_num = ? AND doc_id = ?";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $art_num, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $docId, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            if ($prepare_stm->rowCount() > 0)
                return $prepare_stm->fetch(PDO::FETCH_ASSOC)['art_sort_position'];
        }

        return 0;

    }


    private static function getArticuloID($docId, $art_num)
    {
        $query = "SELECT art.* FROM dex_documentos_legis INNER JOIN dex_articulos as art ON dex_documentos_legis.doc_id = art.doc_id AND dex_documentos_legis.doc_id = ? AND art.art_num = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $docId, PDO::PARAM_INT);
        $prepare_stm->bindValue(2, $art_num, PDO::PARAM_STR);
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    private static function extractArtNumClean($arts_value)
    {
        $artnumclean = $arts_value;
        $pos1 = stripos($artnumclean, "Incs.");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "Inc.");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "Nums.");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "Num.");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "Lits.");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "Lit.");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "a)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "b)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "c)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "d)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "e)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "f)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "g)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "h)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "i)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "j)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "k)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "l)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "m)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }
        $pos1 = stripos($artnumclean, "n)");
        if ($pos1 !== false) {
            $artnumclean = substr($artnumclean, 0, $pos1);
        }

        return $artnumclean;
    }

}