<?php
ini_set('memory_limit', '-1');
require_once 'ConnectionDB.php';

class Document_legis
{
    const TABLE_NAME = "dex_documentos_legis";
    const TABLE_NAME_ART = "dex_articulos";
    const DOC_ID = "doc_id";
    const MAT_ID = "mat_id";
    const TEMA = "tema";
    const GRUP_ID = "grup_id";
    const GRUP_NOMBRE = "grup_nombre";
    const NUM_LEY = "num_ley";
    const TIPOLEY_ID = "tipoley_id";
    const ID_CORRES = "id_corres";
    const DOC_TITULO = "doc_titulo";
    const DOC_DESCRIPCION = "doc_descripcion";
    const DOC_PORTADA = "doc_portada";
    const DOC_XML = "doc_xml";
    const DOC_FECHA = "doc_fecha";
    const DOC_AUTORIDAD = "doc_autoridad";
    const DOC_RO = "doc_ro";
    const DOC_STATUS = "doc_status";
    const DOC_FECHA_RO = "doc_fecha_ro";
    const DOC_REFORMADO_POR = "doc_reformado_por";
    const DOC_DEROGADO_POR = "doc_derogado_por";
    const DOC_REFORMATORIO_DE = "doc_reformatorio_de";
    const DOC_DEROGATORIO_DE = "doc_derogatorio_de";
    const EVOLUCION_HTMLCODE = "evolucion_htmlCode";
    const EVOLUCION_XML = "evolucion_xml";
    const JURISPRUDENCIA_HTMLCODE = "jurisprudencia_htmlCode";
    const JURISPRUDENCIA_DOC_XML = "jurisprudencia_doc_xml";
    const HEAD_HTMLCODE = "head_htmlCode";
    const FOOT_HTMLCODE = "foot_HTMLcode";
    const HTMLCODE = "htmlCode";
    const FECHA_MODIFICACION = "fecha_modificacion";
    const IDINTERNO = "idinterno";
    const ID_GRUPO = "id_grupo";
    const N_RANKING = "nranking";


    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private static $encryption_key = '5166546A576E5A72';
    private static $DOCS_IDS = null;



    public static function setPostRequest($request)
    {

        if ($request[0] == 'listbasic') {
            return Document_legis::listBasicDocumentosLegis();
        } else if ($request[0] == 'searchindocuments') {
            return Document_legis::searchArtOrText();
        } else if ($request[0] == 'get_update_laws_in_app') {
            return Document_legis::getUpdateLawsInApp();
        } else if ($request[0] == 'send_law') {
            return Document_legis::SendEmailToRequest();
        } else if ($request[0] == 'get_info_book_by_code') {
            return Document_legis::getAllDataDocument_legis();
        } else if ($request[0] == 'get_buyer') {
            return Document_legis::getBuyer();
        } else if ($request[0] == 'get_todo_code') {
            return Document_legis::getTodoCode();
        } else if ($request[0] == 'get_user_data_buyer') {
            return Document_legis::getUserDataBuyer();
        } else if ($request[0] == 'get_buyer_details') {
            return Document_legis::getBuyerDetails();
        } else if ($request[0] == 'update_detail_user_doc') {
            return Document_legis::updateDetailUserBook();
        } else if ($request[0] == 'countart') {
            return Document_legis::getCountArt();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    public static function setGetRequest($request)
    {
        if ($request[0] == 'all') {

        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }


    public static function SendEmailToRequest()
    {

        $body = file_get_contents('php://input');
        $ObjData = json_decode($body);
        // Validar campos
        User::authorizationFromApp();

        if ($ObjData !== null) {
            if (ValidComponent::issetField($ObjData->id_usuario, 948)
                && ValidComponent::issetField($ObjData->docId, 949)
                && ValidComponent::isEmptyField("Código del documento", $ObjData->docId)) {
                $docId = $ObjData->docId;
                $docXml = self::getDocXml($docId);
                if ($docXml != null) {

                    $headers = apache_request_headers();
                    //$id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $data->id_usuario);
                    $id_usuario_php = $ObjData->id_usuario;
                    $pdo = ConnectionDB::getInstance()->getDataBase();
                    $emailUser = strtolower(User::getEmailFromID($id_usuario_php));
                    $fullNameUser = strtolower(User::getFullNameFromID($id_usuario_php));


                    $dondeDescargar = "http://www.cepweb.com.ec/AppWeb/RO/" . $docXml;
                    $sending = API::POST(Constants::LOCAL_SERVER() . "/speedycep/mail/lawdownload.php",
                        array(
                            "dondeDescargo" => $dondeDescargar,
                            "invitation_email" => serialize(array($fullNameUser => $emailUser))
                        ), $headers["Authorization"]);


                    if ($sending != "true") {
                        throw new ExceptionApi(self::UNKNOWN_FAULT, "No se pudo enviar el mensaje al email.");
                    } else {
                        return [
                            "status" => self::SUCCESSFUL_CREATION,
                            "message" => "Información enviada al email."
                        ];
                    }


                } else {
                    throw new ExceptionApi(self::ERROR_DATABASE, "Dirección del documento no encontrado.");
                }
            }
        } else {
            throw new ExceptionApi(self::ERROR_DATABASE, "Objeto nulo.");
        }

    }


    public static function getUpdateLawsInApp($verify_laws)
    {
        // Validar campos
        //User::authorizationFromApp();
        $rows = null;
        foreach ($verify_laws as $row) {
            $rst = self::getDataDocumentByIdAndDate($row->id, $row->fecha);
            if ($rst != null) {
                $rows[] = $rst;
            }
        }
        return $rows;
    }

    private static function getCountArt() {
        $body = file_get_contents('php://input');
        $docData = json_decode($body);
        User::authorizationFromApp();


        if ($docData != null) {
            if (ValidComponent::issetField($docData->docId, 100)) {
                $docId = $docData->docId;

                $dd = Articulos::getTotalRows($docId);

                if ($dd == null) {
                    return [
                        "status" => self::SUCCESSFUL_CREATION,
                        "message" => "No hay articulos para realizar el cálculo del precio de la ley."
                    ];
                } else {
                    return [
                        "status" => self::SUCCESSFUL_CREATION,
                        "rowCountDoc" => Articulos::getTotalRows($docId)
                    ];
                }


            }
        } else {
            throw new ExceptionApi(self::UNKNOWN_FAULT, "Información incompleta.");
        }


    }


    private static function listBasicDocumentosLegis()
    {
        // Validar campos
        User::authorizationFromApp();
        $dataDocument_legis = array();

        $init_admin = parse_ini_file('/var/www/html/speedycep/doc/basic_norm.ini');
        $storageData = $init_admin['data'];
        $ids = json_decode($storageData, true);
        $arr = array();
        $k = 0;
        foreach ($ids["doc_ids"] as $item) {
            $arr[$k] = $item['id'];
            $k++;
        }
        self::$DOCS_IDS = $arr;

        for ($i = 0; $i < count(self::$DOCS_IDS); $i++) {//son las gratis.
            $dataDocument_legis[$i] = self::getDataDocument_legis(self::$DOCS_IDS[$i]);
            $dataDocument_legis[$i] = self::encryptDataDocument($dataDocument_legis[$i]);
        }
        return [
            "status" => self::SUCCESSFUL_CREATION,
            "data" => $dataDocument_legis
        ];
    }


    private static final function encryptDataDocument($dataDocument_legis)
    {

        $dataDocument_legis->doc_id = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_id);
        $dataDocument_legis->mat_id = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->mat_id);
        $dataDocument_legis->tema = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->tema);
        $dataDocument_legis->grup_id = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->grup_id);
        $dataDocument_legis->grup_nombre = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->grup_nombre);
        $dataDocument_legis->num_ley = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->num_ley);
        $dataDocument_legis->tipoley_id = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->tipoley_id);
        $dataDocument_legis->id_corres = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->id_corres);
        $dataDocument_legis->doc_titulo = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_titulo);
        $dataDocument_legis->doc_descripcion = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_descripcion);
        $dataDocument_legis->doc_portada = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_portada);
        $dataDocument_legis->doc_xml = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_xml);
        $dataDocument_legis->doc_fecha = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_fecha);
        $dataDocument_legis->doc_autoridad = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_autoridad);
        $dataDocument_legis->doc_ro = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_ro);
        $dataDocument_legis->doc_status = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_status);
        $dataDocument_legis->doc_fecha_ro = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_fecha_ro);


        $dataDocument_legis->doc_reformado_por = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_reformado_por);
        $dataDocument_legis->doc_derogado_por = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_derogado_por);
        $dataDocument_legis->doc_reformatorio_de = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_reformatorio_de);
        $dataDocument_legis->doc_derogatorio_de = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_derogatorio_de);
        $dataDocument_legis->evolucion_htmlCode = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->evolucion_htmlCode);
        $dataDocument_legis->evolucion_xml = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->evolucion_xml);
        $dataDocument_legis->jurisprudencia_htmlCode = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->jurisprudencia_htmlCode);
        $dataDocument_legis->jurisprudencia_doc_xml = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->jurisprudencia_doc_xml);
        $dataDocument_legis->head_htmlCode = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->head_htmlCode);
        $dataDocument_legis->foot_HTMLcode = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->foot_HTMLcode);
        $dataDocument_legis->htmlCode = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->htmlCode);
        $dataDocument_legis->fecha_modificacion = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->fecha_modificacion);
        $dataDocument_legis->idinterno = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->idinterno);
        $dataDocument_legis->id_grupo = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->id_grupo);
        $dataDocument_legis->nranking = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->nranking);
        $dataDocument_legis->doc_servicio = PHP_AES_Cipher::encrypt(self::$encryption_key, $dataDocument_legis->doc_servicio);

        return $dataDocument_legis;
    }


    private static function getDataDocument_legis($doc_id)
    {
        $query = "SELECT * FROM  " . self::TABLE_NAME . " WHERE " . self::DOC_ID . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $doc_id, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetchObject();
            $result->doc_servicio = "GRATUITO";
            return $result;
        } else {
            return null;
        }
    }

    private static function getDataDocument_legisPremium($doc_id)
    {
        $query = "SELECT * FROM  " . self::TABLE_NAME . " WHERE " . self::DOC_ID . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $doc_id, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetchObject();
            $result->doc_servicio = "PREMIUM";
            return $result;
        } else {
            return null;
        }
    }

    private static function getAllDataDocument_legis()
    {
        $query = "SELECT * FROM  " . self::TABLE_NAME . " WHERE " . self::DOC_ID . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $_POST['id'], PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetchObject();
            return $result;
        } else {
            return null;
        }
    }


    private static function getArticulosByDocumID($doc_id)
    {

        $query = "SELECT * FROM  " . self::TABLE_NAME_ART . " WHERE " . self::DOC_ID . " = ? ORDER BY art_sort_position ASC;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $doc_id, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    private static function removeGuion($val)
    {

        $pos = stripos($val, "-");
        if ($pos !== false) {
            return mb_substr($val, $pos + 1, strlen($val));
        }

        return $val;

    }


    private static function globalSearchInTitleDocAndArt($ObjSearch)
    {

        $hasSearch = explode("-", $ObjSearch->search_text);
        $adicional = "";
        if (count($hasSearch) > 1) {
            $adicional = "AND dex_art.art_desc_no_html NOT LIKE ?";
        }

        $start_limit = $ObjSearch->start_limit;
        $end_limit = $ObjSearch->end_limit;
        $docs_in_device = $ObjSearch->docs_in_device;
        $docs_in_device_string = self::CreateDocsString($docs_in_device);
        $conditional_order_by = "ORDER BY NOT FIELD(dex_doc.doc_id," . $docs_in_device_string . ") ASC,
FIELD(dex_doc.doc_id," . $docs_in_device_string . ") ASC";
        $order_by = $ObjSearch->order_by;

        if ($order_by == "MORE_RESULTS") {
            $conditional_order_by = "ORDER BY n_coincidencias_desc DESC";
        }

        $query = "SELECT dex_doc.doc_id, dex_doc.doc_titulo, '0' as n_coincidencias_titulo, COALESCE(SUM(
		ROUND (   
			(
				LENGTH(dex_art.art_desc_no_html)
				- LENGTH( REPLACE ( dex_art.art_desc_no_html, ?, \"\") ) 
			) / LENGTH(?)        
		)
    ),0) as n_coincidencias_desc FROM dex_documentos_legis as dex_doc INNER JOIN dex_articulos as dex_art 
    ON dex_doc.doc_id = dex_art.doc_id AND (dex_art.art_desc_no_html LIKE LOWER(?) " . $adicional . " ) AND dex_doc.doc_titulo LIKE ? GROUP BY dex_doc.doc_id 
    HAVING n_coincidencias_titulo > 0 OR n_coincidencias_desc > 0 " . $conditional_order_by . " LIMIT " . $start_limit . ", " . $end_limit . ";";

        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $hasSearch[0], PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $hasSearch[0], PDO::PARAM_STR);
        $prepare_stm->bindValue(3, "%" . $hasSearch[0] . "%", PDO::PARAM_STR);
        if (count($hasSearch) > 1) {
            $prepare_stm->bindValue(4, "%" . $hasSearch[1] . "%", PDO::PARAM_STR);
            $prepare_stm->bindValue(5, "%" . $ObjSearch->doc_titulo_text . "%", PDO::PARAM_STR);
        } else {
            $prepare_stm->bindValue(4, "%" . $ObjSearch->doc_titulo_text . "%", PDO::PARAM_STR);
        }


        if ($prepare_stm->execute()) {

            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }

            for ($i = 0; $i < count($rows); $i++) {
                $docId = $rows[$i]["doc_id"];
                $rows[$i]["doc_id"] = PHP_AES_Cipher::encrypt(self::$encryption_key, $docId);
                $rows[$i]["doc_titulo"] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]["doc_titulo"]);
                $rows[$i]['articulos'] = self::getSearchArt($docId, $hasSearch[0], $ObjSearch->doc_titulo_text);

                $enc = self::Search($docId, $docs_in_device);
                if ($enc == false) {
                    $rows[$i]['document_extra'] = self::encryptDataDocument(self::getDataDocument_legisPremium($docId));
                }
            }

            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => $rows
            ];
        } else {
            return null;
        }
    }

    private static function soloSearchInTitleDoc($ObjSearch)
    {

        $doc_titulo_text = $ObjSearch->doc_titulo_text;
        $start_limit = $ObjSearch->start_limit;
        $end_limit = $ObjSearch->end_limit;
        $docs_in_device = $ObjSearch->docs_in_device;
        $docs_in_device_string = self::CreateDocsString($docs_in_device);
        $conditional_order_by = "ORDER BY NOT FIELD(dex_doc.doc_id," . $docs_in_device_string . ") ASC,
FIELD(dex_doc.doc_id," . $docs_in_device_string . ") ASC";
        $order_by = $ObjSearch->order_by;

        if ($order_by == "MORE_RESULTS") {
            $conditional_order_by = "ORDER BY n_coincidencias_desc DESC";
        }

        $query = "SELECT dex_doc.doc_id, dex_doc.doc_titulo, '0' as n_coincidencias_titulo, '0' as n_coincidencias_desc FROM dex_documentos_legis as dex_doc WHERE dex_doc.doc_titulo LIKE ? " . $conditional_order_by . " LIMIT " . $start_limit . ", " . $end_limit . ";";

        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, "%" . $ObjSearch->doc_titulo_text . "%", PDO::PARAM_STR);


        if ($prepare_stm->execute()) {

            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }

            for ($i = 0; $i < count($rows); $i++) {
                $docId = $rows[$i]["doc_id"];
                $rows[$i]["doc_id"] = PHP_AES_Cipher::encrypt(self::$encryption_key, $docId);
                $rows[$i]["doc_titulo"] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]["doc_titulo"]);
                $rows[$i]['articulos'] = self::getSearchArt($docId, '', $ObjSearch->doc_titulo_text);

                $enc = self::Search($docId, $docs_in_device);
                if ($enc == false) {
                    $rows[$i]['document_extra'] = self::encryptDataDocument(self::getDataDocument_legisPremium($docId));
                }
            }

            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => $rows
            ];
        } else {
            return null;
        }
    }


    private static function searchArtOrText()
    {

        $body = file_get_contents('php://input');
        $ObjSearch = json_decode($body);
        // Validar campos
        User::authorizationFromApp();

        if ($ObjSearch !== null) {

            if (ValidComponent::issetField($ObjSearch->doc_titulo_text, 949)
                && ValidComponent::issetField($ObjSearch->search_text, 950)
                && ValidComponent::issetField($ObjSearch->start_limit, 952)
                && ValidComponent::issetField($ObjSearch->end_limit, 953)
                && ValidComponent::issetField($ObjSearch->docs_in_device, 954)
                && ValidComponent::issetField($ObjSearch->order_by, 955)) {

                if ($ObjSearch->doc_titulo_text != "" && $ObjSearch->search_text == "") {
                    return self::soloSearchInTitleDoc($ObjSearch);
                } else {
                    return self::globalSearchInTitleDocAndArt($ObjSearch);
                }


            }

        } else {
            throw new ExceptionApi(self::ERROR_DATABASE, "Objeto nulo.");
        }
    }


    private static function getSearchArt($docId, $search_text, $search_ley)
    {
        $hasGuion = self::removeGuion($search_text);
        $adicional = "";
        if ($hasGuion != $search_text) {
            $adicional = "AND dex_art.art_desc_no_html NOT LIKE ?";
        }

        $query = "SELECT dex_art.id_articulo, dex_doc.doc_id, '0' as count_titulo, COALESCE(SUM(
		ROUND (   
			(
				LENGTH(dex_art.art_desc_no_html)
				- LENGTH( REPLACE ( dex_art.art_desc_no_html, ?, \"\") ) 
			) / LENGTH(?)        
		)
    ),0) as count_content FROM dex_documentos_legis as dex_doc INNER JOIN dex_articulos as dex_art 
    ON dex_doc.doc_id = dex_art.doc_id AND (dex_art.art_desc_no_html LIKE LOWER(?) " . $adicional . ") 
    AND dex_doc.doc_id = ? AND dex_doc.doc_titulo LIKE ? GROUP BY dex_art.id_articulo  HAVING count_content > 0 OR count_titulo > 0 ORDER BY dex_art.art_sort_position ASC;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $search_text, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $search_text, PDO::PARAM_STR);
        $prepare_stm->bindValue(3, "%" . $search_text . "%", PDO::PARAM_STR);

        if ($hasGuion != $search_text) {
            $prepare_stm->bindValue(4, "%" . $hasGuion . "%", PDO::PARAM_INT);
            $prepare_stm->bindValue(5, $docId, PDO::PARAM_INT);
            $prepare_stm->bindValue(6, "%" . $search_ley . "%", PDO::PARAM_STR);
        } else {
            $prepare_stm->bindValue(4, $docId, PDO::PARAM_INT);
            $prepare_stm->bindValue(5, "%" . $search_ley . "%", PDO::PARAM_STR);
        }

        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }


            for ($i = 0; $i < count($rows); $i++) {
                $rows[$i]["id_articulo"] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]["id_articulo"]);
                $rows[$i]["doc_id"] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]["doc_id"]);
            }

            return $rows;
        } else {
            return null;
        }
    }


    public static function getDataDocumentByIdAndDate($doc_id, $fecha_modificacion)
    {
        $query = "SELECT doc_id, doc_titulo, doc_descripcion, fecha_modificacion, doc_reformado_por FROM dex_documentos_legis WHERE doc_id = ? AND fecha_modificacion <> ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $doc_id, PDO::PARAM_INT);
        $prepare_stm->bindValue(2, $fecha_modificacion, PDO::PARAM_STR);
        $rows = null;
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetch(PDO::FETCH_ASSOC);
            if ($result) {
                return $result;
            }
        }
        return null;
    }


    private static function getDocXml($doc_id)
    {
        $query = "SELECT doc_xml FROM dex_documentos_legis WHERE doc_id = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $doc_id, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetch(PDO::FETCH_ASSOC);
            if ($result) {
                return $result['doc_xml'];
            }
        }
        return null;
    }

    private static function Search($value, $array)
    {
        for ($i = 0; $i < count($array); $i++) {
            if ($array[$i] == $value) {
                return true;
            }
        }
        return false;
    }

    private static function CreateDocsString($array)
    {
        $str = "";
        for ($i = 0; $i < count($array); $i++) {
            if ($i == 0) {
                $str = $array[$i];
            } else {
                $str .= "," . $array[$i];
            }

        }
        return $str;
    }


    private static function getBuyer()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $result = self::getBuyerUsers($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Encontrado!",
                    "data" => $result
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "No hay datos"
                ];
            }
        }
    }

    private static function getBuyerUsers($pdo, $doc_id)
    {
        $query = "SELECT dex_usuario_doclegis_comprado.id_dex_usuario_doclegis_comprado, dex_usuario_doclegis_comprado.numero_referencia, 
                  dex_usuario_doclegis_comprado.nombres_envio, dex_usuario_doclegis_comprado.apellidos_envio, 
                  dex_usuario_doclegis_comprado.tipo_pago, dex_usuario_doclegis_comprado.direccion_envio, 
                  dex_usuario_doclegis_comprado.cedula_envio, dex_usuario_doclegis_comprado.telefono_envio, 
                  dex_usuario_doclegis_comprado.ciudad_envio, dex_usuario_doclegis_comprado.pais_envio, 
                  dex_usuario_doclegis_comprado.email_envio, dex_usuario_doclegis_comprado.precio_compra, dex_usuario_doclegis_comprado.fecha_compra  
                  FROM dex_usuario_doclegis_comprado INNER JOIN dex_usuario_new ON 
                  dex_usuario_new.id_usuario = dex_usuario_doclegis_comprado.id_usuario INNER JOIN dex_documentos_legis ON 
                  dex_documentos_legis.doc_id = dex_usuario_doclegis_comprado.doc_id AND 
                  dex_documentos_legis.doc_id = ?;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $doc_id, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    private static function getTodoCode()
    {
        User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $result = self::getAll($pdo);
        if ($result) {
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "message" => "¡Encontrado!",
                "data" => $result
            ];
        }
    }

    public static function getAll($pdo)
    {
        $query = "SELECT dex_documentos_legis.* FROM dex_usuario_doclegis_comprado INNER JOIN dex_usuario_new ON 
                  dex_usuario_new.id_usuario = dex_usuario_doclegis_comprado.id_usuario INNER JOIN dex_documentos_legis ON 
                  dex_documentos_legis.doc_id = dex_usuario_doclegis_comprado.doc_id ORDER BY dex_documentos_legis.doc_fecha_ro DESC;";
        $prepare_stm = $pdo->prepare($query);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }


    private static function getUserDataBuyer()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Document_legis();
            $result = $cd->getDataBuyer($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Encontrado!",
                    "data" => $result
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "No hay datos"
                ];
            }
        }
    }

    public static function getDataBuyer($pdo, $id_dex_usuario_doclegis_comprado)
    {
        $query = "SELECT * FROM dex_usuario_doclegis_comprado WHERE id_dex_usuario_doclegis_comprado = ?;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_dex_usuario_doclegis_comprado, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            return $prepare_stm->fetch(PDO::FETCH_ASSOC);
        } else {
            return null;
        }
    }


    private static function getBuyerDetails()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $result = self::getBuyerUsersDetails($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Encontrado!",
                    "data" => $result
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "No hay datos"
                ];
            }
        }
    }

    private static function getBuyerUsersDetails($pdo, $id_dex_usuario_doclegis_comprado)
    {
        $query = "SELECT * FROM dex_detalle_envio_speedy_ro WHERE id_dex_usuario_doclegis_comprado = ? ORDER BY fecha_actualizacion ASC;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_dex_usuario_doclegis_comprado, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    private static function updateDetailUserBook()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $result = self::updateEnvioUsuario($pdo, $_POST['id'], $_POST['estado_envio'], $_POST['observacion']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Actualizado!",
                    "data" => self::getLastDetailsSendBook($pdo, $_POST['id'])
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Error - no fue posible actualizar."
                ];
            }
        }
    }

    private static function updateEnvioUsuario($pdo, $id_dex_usuario_doclegis_comprado, $estado_envio, $observacion)
    {

        $query = "INSERT INTO dex_detalle_envio_speedy_ro(id_dex_usuario_doclegis_comprado,estado_envio,
                  observacion,fecha_actualizacion) VALUES (?,?,?, NOW());";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_dex_usuario_doclegis_comprado, PDO::PARAM_INT);
        $prepare_stm->bindValue(2, $estado_envio, PDO::PARAM_STR);
        $prepare_stm->bindValue(3, $observacion, PDO::PARAM_STR);

        return $prepare_stm->execute();
    }

    public static function getLastDetailsSendBook($pdo, $id_dex_usuario_doclegis_comprado)
    {
        $query = "SELECT * FROM  dex_detalle_envio_speedy_ro WHERE id_dex_usuario_doclegis_comprado = ? ORDER BY fecha_actualizacion DESC LIMIT 1;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_dex_usuario_doclegis_comprado, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            return $prepare_stm->fetch(PDO::FETCH_ASSOC);
        } else {
            return null;
        }
    }

    public static function getByNotificationWithUser($id_usuario)
    {
        //User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $result = self::getDocOrderByPublicar($pdo, $id_usuario);
        if ($result) {
            for ($i = 0; $i < count($result); $i++) {
                $result[$i]['doc_id'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $result[$i]['doc_id']);
                $result[$i]['details_buyer'] = self::getBuyerUsersDetails($pdo, $result[$i]['id_dex_usuario_doclegis_comprado']);
                $result[$i]['id_dex_usuario_doclegis_comprado'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $result[$i]['id_dex_usuario_doclegis_comprado']);
            }
            return $result;
        }
        return null;
    }

    public static function getDocOrderByPublicar($pdo, $id_usuario)
    {
        $query = "SELECT dex_usuario_doclegis_comprado.*, dex_documentos_legis.doc_titulo FROM dex_usuario_doclegis_comprado INNER JOIN dex_usuario_new ON dex_usuario_new.id_usuario = dex_usuario_doclegis_comprado.id_usuario INNER JOIN dex_documentos_legis ON dex_documentos_legis.doc_id = dex_usuario_doclegis_comprado.doc_id AND dex_usuario_new.id_usuario = ? ORDER BY dex_documentos_legis.doc_fecha_ro DESC;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario, PDO::PARAM_STR);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }
}