<?php

ini_set('memory_limit', '-1');
require_once 'ConnectionDB.php';

class Notifications
{
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private static $encryption_key = '5166546A576E5A72';
    private static $keyApp = "A80D313B049E3A50E2B4DA77C62B779E0631FC4F8A1B118E99063A7524AB154B";

    public static function setPostRequest($request)
    {

        if ($request[0] == 'get') {
            return Notifications::getNotificationForUser();
        } else if ($request[0] == 'get_news') {
            return Notifications::getNotificationNewsForUser();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    public static function setGetRequest($request)
    {
        if ($request[0] == 'all') {

        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    private static function getNotificationNewsForUser()
    {

        $body = file_get_contents('php://input');
        $ObjSearch = json_decode($body);
        // Validar campos
        User::authorizationFromApp();

        if ($ObjSearch !== null) {
            if (ValidComponent::issetField($ObjSearch->id_usuario, 948)
                && ValidComponent::issetField($ObjSearch->sp_text, 949)
                && ValidComponent::issetField($ObjSearch->search_text, 950)
                && ValidComponent::issetField($ObjSearch->start_limit, 952)
                && ValidComponent::issetField($ObjSearch->end_limit, 953)) {


                $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $ObjSearch->id_usuario);
                //$id_usuario_php = $UserData->id_usuario;
                $email_usuario = User::getEmailFromID($id_usuario_php);
                $addOptions = false;
                if ($email_usuario != null) {
                    $addOptions = true;
                }

                $sp = $ObjSearch->sp_text;
                $search_text = $ObjSearch->search_text;
                $start_limit = $ObjSearch->start_limit;
                $end_limit = $ObjSearch->end_limit;

                if ($sp == "Libros") {

                    return [
                        "status" => self::SUCCESSFUL_CREATION,
                        "data" => array(
                            "books" => Book::getByNotificationWithUserLimit($id_usuario_php, $search_text, $start_limit, $end_limit, $addOptions)
                        )
                    ];
                } else if ($sp == "Cursos") {
                    return [
                        "status" => self::SUCCESSFUL_CREATION,
                        "data" => array(
                            "seminary" => Seminary::getByNotificationWithUserLimit($id_usuario_php, $search_text, $start_limit, $end_limit, $addOptions)
                        )
                    ];
                } else {

                    return [
                        "status" => self::SUCCESSFUL_CREATION,
                        "data" => array(
                            "books" => Book::getByNotificationWithUserLimit($id_usuario_php, $search_text, $start_limit, $end_limit, $addOptions),
                            "seminary" => Seminary::getByNotificationWithUserLimit($id_usuario_php, $search_text, $start_limit, $end_limit, $addOptions)

                        )
                    ];
                }



            }
        }  else {
            throw new ExceptionApi(self::ERROR_DATABASE, "Objeto nulo.");
        }
    }


    private static function getNotificationForUser()
    {
        $body = file_get_contents('php://input');
        $UserData = json_decode($body);
        // Validar campos
        User::authorizationFromApp();

        if ($UserData !== null && ValidComponent::issetField($UserData->id_usuario, 900)
            && ValidComponent::issetField($UserData->verify_laws, 901)) {


            $resultUpdateLaws = null;
            $resultDex_promocional = null;
            $resultSeminary = Seminary::getByNotificationWithOutUser();
            $resultBook = Book::getByNotificationWithOutUser();
            $resultDocLegis = null;
            //order result subscription premium.
            $tmpResultSubscriptionPremium = null;

            $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $UserData->id_usuario);
            //$id_usuario_php = $UserData->id_usuario;
            $email_usuario = User::getEmailFromID($id_usuario_php);
            if ($email_usuario != null) {
                $servicio_speedy = User::getServicioByID($id_usuario_php);

                if ($servicio_speedy == "PREMIUM") {
                    $resultUpdateLaws = Document_legis::getUpdateLawsInApp($UserData->verify_laws);
                }

                $resultDex_promocional = self::getNotificationsCodPromocional($email_usuario);
                $resultSeminary = Seminary::getByNotificationWithUser($id_usuario_php);
                $resultBook = Book::getByNotificationWithUser($id_usuario_php);

                $resultDocLegis = Document_legis::getByNotificationWithUser($id_usuario_php);
                $resultSubscriptionPremium = Cod_promocional::getCodAssocUser($id_usuario_php);


                $i = 0;
                $tmpDate_exp = null;
                foreach ($resultSubscriptionPremium as $item) {
                    $fecha_expiracion = $item['fecha'];
                    $date_exp = new DateTime($fecha_expiracion);

                    if ($i == 0) {
                        $tmpDate_exp = $date_exp;
                        $tmpResultSubscriptionPremium = $item;
                    } else {
                        if ($date_exp > $tmpDate_exp) {
                            $tmpDate_exp = $date_exp;
                            $tmpResultSubscriptionPremium = $item;
                        }
                    }

                    $i++;
                }


            }

            //extraer primero las notificaciones de códigos promocionales - DISPONIBLES
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => array(
                    "update_laws" => $resultUpdateLaws,
                    "promotional" => $resultDex_promocional,
                    "seminary" => $resultSeminary,
                    "books" => $resultBook,
                    "doclegis" => $resultDocLegis,
                    "subscription_premium" => $tmpResultSubscriptionPremium,
                    "settings_app" => Setting_app::getAllPrices()
                )
            ];
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Parametros incorrectos", 400);
        }

    }


    private static function getNotificationsCodPromocional($email_usuario)
    {

        $query = "SELECT id_dex_cod_promocional, codigo, duracion, fecha_inicial, fecha_expiracion FROM dex_cod_promocional WHERE email_assoc = ? AND estado = ? AND tipo_promocional = ? ORDER BY fecha_expiracion ASC;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $email_usuario, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, "INVITACION", PDO::PARAM_STR);
        $prepare_stm->bindValue(3, "EMAIL", PDO::PARAM_STR);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }

            for ($i = 0; $i < count($rows); $i++) {
                $rows[$i]['id_dex_cod_promocional'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]['id_dex_cod_promocional']);
                $rows[$i]['codigo'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]['codigo']);
                $rows[$i]['duracion_meses'] = self::calcularMeses($rows[$i]['duracion']);
            }

            return $rows;
        } else {
            return null;
        }
    }

    private static function calcularMeses($duracion)
    {

        if (($duracion / 30) == 1) {
            return "1 MES";
        } else {
            return ($duracion / 30) . " MESES";
        }
    }

}