<?php
ini_set('memory_limit', '-1');
require_once 'ConnectionDB.php';

class OfficialRegister
{
    const TABLE_NAME = "dex_usuario_doclegis_comprado";
    const ID_DEX_USUARIO_DOCLEGIS_COMPRADO = "id_dex_usuario_doclegis_comprado";
    const ID_USUARIO = "id_usuario";
    const DOC_ID = "doc_id";
    const DIRECCION_ENVIO = "direccion_envio";
    const NOMBRES_ENVIO = "nombres_envio";
    const APELLIDOS_ENVIO = "apellidos_envio";
    const CEDULA_ENVIO = "cedula_envio";
    const TELEFONO_ENVIO = "telefono_envio";
    const CIUDAD_ENVIO = "ciudad_envio";
    const PAIS_ENVIO = "pais_envio";
    const EMAIL_ENVIO = "email_envio";
    const PRECIO_COMPRA = "precio_compra";
    const NUMERO_REFERENCIA = "numero_referencia";
    const FECHA_COMPRA = "fecha_compra";
    const ESTADO_COMPRA = "estado_compra";
    const TIPO_PAGO = "tipo_pago";


    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private static $encryption_key = '5166546A576E5A72';
    private static $keyApp = "A80D313B049E3A50E2B4DA77C62B779E0631FC4F8A1B118E99063A7524AB154B";

    public static function setPostRequest($request)
    {

        if ($request[0] == 'get') {
            return OfficialRegister::getLastLaws();
        } else if ($request[0] == 'register') {
            return OfficialRegister::register();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    public static function setGetRequest($request)
    {
        if ($request[0] == 'all') {

        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    private static function getLastLaws()
    {
        $body = file_get_contents('php://input');
        $ObjData = json_decode($body);
        // Validar campos
        User::authorizationFromApp();
        if ($ObjData !== null) {
            if (ValidComponent::issetField($ObjData->start_limit, 948)) {
                $start_limit = $ObjData->start_limit;
                $end_limit = 6;
                $result = self::getLastLawDescFechaRo($start_limit, $end_limit);
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "total_rows" => count($result),
                    "data" => $result
                ];
            }
        } else {
            throw new ExceptionApi(self::ERROR_DATABASE, "Objeto nulo.");
        }
    }


    private static function getLastLawDescFechaRo($start_limit, $end_limit)
    {

        $query = "SELECT * FROM  dex_documentos_legis ORDER BY doc_fecha_ro DESC, doc_id DESC LIMIT " . $start_limit . "," . $end_limit . ";";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $start_limit, PDO::PARAM_INT);
        $prepare_stm->bindValue(2, $end_limit, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    private static function register()
    {
        $body = file_get_contents('php://input');
        $Data = json_decode($body);
        // Validar campos
        User::authorizationFromApp();

        if ($Data !== null && ValidComponent::issetField($Data->id_usuario, 900)
            && ValidComponent::issetField($Data->doc_id, 901)
            && ValidComponent::issetField($Data->nombres, 905) && ValidComponent::issetField($Data->apellidos, 906)
            && ValidComponent::issetField($Data->telefono, 907) && ValidComponent::issetField($Data->cedula, 908)
            && ValidComponent::issetField($Data->direccion, 909) && ValidComponent::issetField($Data->ciudad, 910)
            && ValidComponent::issetField($Data->pais, 911) && ValidComponent::issetField($Data->email, 912)
            && ValidComponent::issetField($Data->numero_referencia, 914) && ValidComponent::issetField($Data->precio_compra, 915)
            && ValidComponent::issetField($Data->tipo_pago, 916)) {

            $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $Data->id_usuario);
            //$id_usuario_php = $Data->id_usuario;
            $doc_id_php = $Data->doc_id;
            $nombres = $Data->nombres;
            $apellidos = $Data->apellidos;
            $telefono = $Data->telefono;
            $cedula = $Data->cedula;
            $direccion = $Data->direccion;
            $ciudad = $Data->ciudad;
            $pais = $Data->pais;
            $email = $Data->email;
            $numero_referencia = $Data->numero_referencia;
            $precio_compra = $Data->precio_compra;
            $tipo_pago = $Data->tipo_pago;//paypal o credito

            //fecha_pago
            $date_pago = new DateTime('now');
            $fecha_compra = $date_pago->format("Y-m-d h:i:s");
            $estado_compra = "PAGADO";
            $fecha_compraT = $date_pago->format("m/d/Y h:i:s a");

            /**/
            $query = "INSERT INTO " . self::TABLE_NAME . " (" . self::ID_USUARIO . ", " . self::DOC_ID . ", " . self::DIRECCION_ENVIO . ", " . self::NOMBRES_ENVIO . ", " . self::APELLIDOS_ENVIO . ", " . self::CEDULA_ENVIO . ", " . self::TELEFONO_ENVIO . ",  " . self::CIUDAD_ENVIO . ", " . self::PAIS_ENVIO . ", " . self::EMAIL_ENVIO . ", " . self::PRECIO_COMPRA . ", " . self::NUMERO_REFERENCIA . ", " . self::FECHA_COMPRA . ", " . self::ESTADO_COMPRA . ", " . self::TIPO_PAGO . ") VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

            $pdo = ConnectionDB::getInstance()->getDataBase();
            $prepare_stm = $pdo->prepare($query);
            $prepare_stm->bindParam(1, $id_usuario_php);
            $prepare_stm->bindParam(2, $doc_id_php);
            $prepare_stm->bindParam(3, $direccion);
            $prepare_stm->bindParam(4, $nombres);
            $prepare_stm->bindParam(5, $apellidos);
            $prepare_stm->bindParam(6, $cedula);
            $prepare_stm->bindParam(7, $telefono);
            $prepare_stm->bindParam(8, $ciudad);
            $prepare_stm->bindParam(9, $pais);
            $prepare_stm->bindParam(10, $email);
            $prepare_stm->bindParam(11, $precio_compra);
            $prepare_stm->bindParam(12, $numero_referencia);
            $prepare_stm->bindParam(13, $fecha_compra);
            $prepare_stm->bindParam(14, $estado_compra);
            $prepare_stm->bindParam(15, $tipo_pago);

            $result = $prepare_stm->execute();
            if ($result) {
                $id_dex_usuario_doclegis_comprado = $pdo->lastInsertId();
                http_response_code(200);

                $emailUser = strtolower(User::getEmailFromID($id_usuario_php));
                $fullNameUser = strtolower(User::getFullNameFromID($id_usuario_php));

                //get emails to send copy.
                $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/setting_app/get/",
                    array(), self::$keyApp);
                $data = API::JSON_TO_ARRAY($multi_info_api);
                $emails_for_books = $data["data"][0]['emails_for_books'];
                $arr_data = json_decode($emails_for_books, true);

                $email_principal = $arr_data['email_principal'];
                $email_option_a = $arr_data['email_option_a'];
                $email_option_b = $arr_data['email_option_b'];
                //create array emails
                $invitation_emails = array(
                    $fullNameUser => $emailUser
                );

                if ($email_principal != "") {
                    $invitation_emails["Correo principal"] = $email_principal;
                }

                if ($email_option_a != "") {
                    $invitation_emails["Correo opcional 1"] = $email_option_a;
                }

                if ($email_option_b != "") {
                    $invitation_emails["Correo opcional 2"] = $email_option_b;
                }

                $arr_data = self::getDataCode($doc_id_php);

                API::POST(Constants::LOCAL_SERVER() . "/speedycep/mail/sending_message_pay_law.php",
                    array(
                        "nombre_usuario" => $fullNameUser,
                        "email_usuario" => $emailUser,
                        "titulo_ley" => strtoupper($arr_data->doc_titulo),
                        "direccion_usuario" => $direccion . ", Ciudad " . $ciudad . ", " . $pais,
                        "telefono_usuario" => $telefono,
                        "fecha_y_hora_compra" => strtoupper($fecha_compraT),
                        "num_transaccion" => $numero_referencia,
                        "monto_pagado" => $precio_compra,
                        "invitation_email" => serialize($invitation_emails)
                    ), self::$keyApp);

                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Enhorabuena la ley ha sido comprada!",
                    "id_dex_usuario_doclegis_comprado" => $id_dex_usuario_doclegis_comprado,
                    "fecha_compra" => $fecha_compra,
                    "id_detalle_envio_speedy" => self::registerDetails($id_dex_usuario_doclegis_comprado)
                ];
            } else {
                throw new ExceptionApi(self::ERROR_DATABASE, "Ocurrio un error al insertar la información", 400);
            }

        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Parametros incorrectos", 400);
        }
    }


    private static function registerDetails($id_dex_usuario_doclegis_comprado)
    {

        $query = "INSERT INTO dex_detalle_envio_speedy_ro (id_dex_usuario_doclegis_comprado, estado_envio, fecha_actualizacion, observacion) VALUES (?, ?, ?, ?)";
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $prepare_stm = $pdo->prepare($query);

        $date_pago = new DateTime('now');
        $fecha_actualizacion = $date_pago->format("Y-m-d h:i:s");
        $estado = "INFORMACION RECIBIDA";
        $obs = "INFORMACION RECIBIDA DESDE APP";
        $prepare_stm->bindParam(1, $id_dex_usuario_doclegis_comprado);
        $prepare_stm->bindParam(2, $estado);
        $prepare_stm->bindParam(3, $fecha_actualizacion);
        $prepare_stm->bindParam(4, $obs);
        $result = $prepare_stm->execute();
        if ($result) {
            $id_detalle_envio_speedy = $pdo->lastInsertId();
            return $id_detalle_envio_speedy;
        } else {
            return -1;
        }
    }


    private static function getDataCode($id)
    {
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $cd = new OfficialRegister();
        return $cd->getInfoByID($id, $pdo);
    }

    public static function getInfoByID($id, $pdo)
    {
        $query = "SELECT * FROM dex_documentos_legis WHERE doc_id = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetchObject();
            return $result;
        } else {
            return null;
        }
    }

}