<?php

class PHP_AES_Cipher {

    private static $OPENSSL_CIPHER_NAME = "aes-128-ecb"; //Name of OpenSSL Cipher
    private static $CIPHER_KEY_LEN = 16; //128 bits
    /**
     * Encrypt data using AES Cipher (CBC) with 128 bit key
     *
     * @param string $key - key to use should be 16 bytes long (128 bits)
     * @param string $data - data to encrypt
     * @return string data in base64 encoding with iv attached at end after a :
     */
    static function encrypt($key, $data) {
        $encryptedPayload = base64_encode(openssl_encrypt($data, self::$OPENSSL_CIPHER_NAME, $key, OPENSSL_RAW_DATA));;

        return $encryptedPayload;

    }
    /**
     * Decrypt data using AES Cipher (CBC) with 128 bit key
     *
     * @param string $key - key to use should be 16 bytes long (128 bits)
     * @param string $data - data to be decrypted in base64 encoding with iv attached at the end after a :
     * @return string
     */
    static function decrypt($key, $data) {
        $decryptedData = openssl_decrypt(base64_decode($data), PHP_AES_Cipher::$OPENSSL_CIPHER_NAME, $key, OPENSSL_RAW_DATA);
        return $decryptedData;
    }
}
?>