<?php
ini_set('memory_limit', '-1');
require_once 'ConnectionDB.php';

class Search_suggest
{
    const TABLE_NAME = "tbl_search_suggest";
    const ID_SUGGEST = "id_suggest";
    const SUGGESTION = "suggestion";
    const RECORD = "record";

    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private static $encryption_key = '5166546A576E5A72';


    public static function setPostRequest($request)
    {

        if ($request[0] == 'all') {
            return Search_suggest::getAll();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    private static function getAll()
    {
        $body = file_get_contents('php://input');
        $suggObject = json_decode($body);

        if ($suggObject !== null
            && ValidComponent::issetField($suggObject->start_limit, 900)) {
            User::authorizationFromApp();
            $query = "SELECT " . self::ID_SUGGEST . "," . self::SUGGESTION . " FROM  " . self::TABLE_NAME . " ORDER BY " . self::ID_SUGGEST . " ASC LIMIT " . $suggObject->start_limit . ",1000;";
            $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);

            $rows = null;
            if ($prepare_stm->execute()) {
                while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                    $rows[] = $row;
                }

                for ($i = 0; $i < count($rows); $i++) {
                    $rows[$i]["id_suggest"] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]["id_suggest"]);
                }

                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "rows" => $prepare_stm->rowCount(),
                    "total_rows" => self::getTotalRows(),
                    "data" => $rows
                ];
            } else {
                return null;
            }
        } else {
            return null;
        }

    }

    private static function getTotalRows()
    {
        $query = "SELECT COUNT(" . self::ID_SUGGEST . ") as total FROM  " . self::TABLE_NAME . " ORDER BY " . self::ID_SUGGEST . " ASC;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);

        if ($prepare_stm->execute()) {
            $row = $prepare_stm->fetch(PDO::FETCH_ASSOC);
            return $row['total'];
        } else {
            return null;
        }
    }
}