<?php

require_once 'ConnectionDB.php';
require_once 'API.php';

class Seminary
{

    const TABLE_NAME = "dex_taller_sem";
    const ID_TALLER_SEM = "id_taller_sem";
    const TIPO_TALLER_SEM = "tipo_taller_sem";
    const TITULO_TALLER_SEM = "titulo_taller_sem";
    const FECHA_DESDE = "fecha_desde";
    const FECHA_HASTA = "fecha_hasta";
    const HORARIO = "horario";
    const INVERSION = "inversion";
    const TELEFONO = "telefono";
    const EXTRA = "extra";
    const PORTADA_PATH = "portada_path";
    const PUBLICAR = "publicar";
    const LUGAR = "lugar";

    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private static $encryption_key = '5166546A576E5A72';
    private static $keyApp = "A80D313B049E3A50E2B4DA77C62B779E0631FC4F8A1B118E99063A7524AB154B";

    public static function setPostRequest($request)
    {
        if ($request[0] == 'register_todo_code') {
            return Seminary::registerTodoCode();
        } else if ($request[0] == 'edit_todo_code') {
            return Seminary::editTodoCode();
        } else if ($request[0] == 'delete_todo_code') {
            return Seminary::deleteTodoCode();
        } else if ($request[0] == 'get_todo_code') {
            return Seminary::getTodoCode();
        } else if ($request[0] == 'update_portada') {
            return Seminary::updatePortada();
        } else if ($request[0] == 'publish_todo_code') {
            return Seminary::publishTodoCode();
        } else if ($request[0] == 'unpublish_todo_code') {
            return Seminary::unPublishTodoCode();
        } else if ($request[0] == 'get_by_notification_without_user') {
            return Seminary::getByNotificationWithOutUser();
        } else if ($request[0] == 'get_by_notification_with_user') {
            return Seminary::getByNotificationWithUser();
        } else if ($request[0] == 'get_by_users') {
            return Seminary::getByUsersForSeminary();
        } else if ($request[0] == 'pay') {
            return Seminary::paySeminary();
        } else if ($request[0] == 'get_seminary_post_by_code') {
            return Seminary::getSeminaryPostByCode();
        } else if ($request[0] == "get_test") {
            $arg = self::getDataCode(1);
            $date_desde = new DateTime($arg->fecha_desde);
            $fecha_desde = $date_desde->format("Y-m-d h:i:s a");
            if ($arg->fecha_desde == "")
                $fecha_desde = "";

            return $fecha_desde;
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    private static function paySeminary()
    {

        $body = file_get_contents('php://input');
        $Data = json_decode($body);
// Validar campos
        User::authorizationFromApp();

        if ($Data !== NULL) {
            if (ValidComponent::issetField($Data->id_usuario, 991)
                && ValidComponent::issetField($Data->id_taller_sem, 992)
                && ValidComponent::issetField($Data->monto, 993)
                && ValidComponent::issetField($Data->estado_pago, 994)
                && ValidComponent::issetField($Data->tipo_pago, 995)
                && ValidComponent::issetField($Data->numero_referencia, 996)) {

                $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $Data->id_usuario);
                $id_taller_sem_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $Data->id_taller_sem);

                $query = "INSERT INTO dex_usuario_taller_sem(id_usuario, id_taller_sem, estado_pago, monto_cancelado, tipo_pago, numero_referencia) VALUES (?,?,?,?,?,?)";
                $pdo = ConnectionDB::getInstance()->getDataBase();
                $prepare_stm = $pdo->prepare($query);

                $prepare_stm->bindValue(1, $id_usuario_php, PDO::PARAM_INT);
                $prepare_stm->bindValue(2, $id_taller_sem_php, PDO::PARAM_INT);
                $prepare_stm->bindValue(3, $Data->estado_pago, PDO::PARAM_STR);
                $prepare_stm->bindValue(4, $Data->monto, PDO::PARAM_STR);
                $prepare_stm->bindValue(5, $Data->tipo_pago, PDO::PARAM_STR);
                $prepare_stm->bindValue(6, $Data->numero_referencia, PDO::PARAM_STR);

                $result = $prepare_stm->execute();

                if ($result) {


                    $emailUser = strtolower(User::getEmailFromID($id_usuario_php));
                    $fullNameUser = strtolower(User::getFullNameFromID($id_usuario_php));

                    //get emails to send copy.
                    $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/setting_app/get/",
                        array(), self::$keyApp);
                    $data = API::JSON_TO_ARRAY($multi_info_api);
                    $emails_for_seminaries = $data["data"][0]['emails_for_seminaries'];
                    $arr_data = json_decode($emails_for_seminaries, true);

                    $email_principal = $arr_data['email_principal'];
                    $email_option_a = $arr_data['email_option_a'];
                    $email_option_b = $arr_data['email_option_b'];
                    //create array emails
                    $invitation_emails = array(
                        $fullNameUser => $emailUser
                    );

                    if ($email_principal != "") {
                        $invitation_emails["Correo principal"] = $email_principal;
                    }

                    if ($email_option_a != "") {
                        $invitation_emails["Correo opcional 1"] = $email_option_a;
                    }

                    if ($email_option_b != "") {
                        $invitation_emails["Correo opcional 2"] = $email_option_b;
                    }


                    $arg = self::getDataCode($id_taller_sem_php);

                    $date_desde = new DateTime($arg->fecha_desde);
                    $fecha_desde = $date_desde->format("m/d/Y h:i:s a");

                    $date_hasta = new DateTime($arg->fecha_hasta);
                    $fecha_hasta= $date_hasta->format("m/d/Y h:i:s a");

                    if ($arg->fecha_desde == "")
                        $fecha_desde = "";

                    if ($arg->fecha_hasta == "")
                        $fecha_hasta = "";

                    API::POST(Constants::LOCAL_SERVER() . "/speedycep/mail/sending_message_pay_seminary.php",
                        array(
                            "nombre_usuario" => $fullNameUser,
                            "tipo_taller_sem" => $Data->tipo_pago,
                            "email_usuario" => $emailUser,
                            "titulo_taller_sem" => $arg->titulo_taller_sem,
                            "fecha_desde" => strtoupper($fecha_desde),
                            "fecha_hasta" => strtoupper($fecha_hasta),
                            "horario" => strtoupper($arg->horario),
                            "numero_transaccion" => $Data->numero_referencia,
                            "monto_pagado" => $Data->monto,
                            "telefono_usuario" => $arg->telefono,
                            "lugar_taller_sem" => $arg->lugar,
                            "extra_taller_sem" => $arg->extra,
                            "invitation_email" => serialize($invitation_emails)
                        ), self::$keyApp);


                    return [
                        "status" => self::SUCCESSFUL_CREATION,
                        "message" => "Su compra ha sido registrada correctamente."
                    ];
                } else {
                    throw new ExceptionApi(self::ERROR_DATABASE, "Ocurrio un error en la base de datos");
                }

            }
        }


    }

    private static function getByUsersForSeminary()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Seminary();
            $result = $cd->getUserBySeminary($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Encontrado!",
                    "data" => $result
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "No hay datos"
                ];
            }
        }
        return null;
    }

    public static function getByNotificationWithOutUser()
    {
        //User::authorizationFromApp();

        $pdo = ConnectionDB::getInstance()->getDataBase();
        $cd = new Seminary();
        $result = $cd->getSeminaryOrderByPublicar($pdo);
        if ($result) {
            for ($i = 0; $i < count($result); $i++) {
                $result[$i]['id_taller_sem'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $result[$i]['id_taller_sem']);
            }
            return $result;
        }
        return null;
    }

    public static function getByNotificationWithUser($id_usuario)
    {
        //User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $result = self::getSeminaryOrderByPublicar($pdo);
        if ($result) {
            for ($i = 0; $i < count($result); $i++) {
                $result[$i]['inscripcion'] = self::getInscriptionSeminaryUser($pdo, $result[$i]['id_taller_sem'], $id_usuario);
                $result[$i]['id_taller_sem'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $result[$i]['id_taller_sem']);
            }
            return $result;
        }
        return null;
    }


    public static function getByNotificationWithUserLimit($id_usuario, $search_text, $start_limit, $end_limit, $addOptions = false)
    {
        //User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $result = self::getSeminaryOrderByPublicarLimit($pdo, $search_text, $start_limit, $end_limit);;
        if ($result) {
            for ($i = 0; $i < count($result); $i++) {
                if ($addOptions) {
                    $result[$i]['inscripcion'] = self::getInscriptionSeminaryUser($pdo, $result[$i]['id_taller_sem'], $id_usuario);
                }
                $result[$i]['id_taller_sem'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $result[$i]['id_taller_sem']);
            }
            return $result;
        }
        return null;
    }

    private static function unPublishTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Seminary();
            $result = $cd->unPublishTodo($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡No Publicada!"
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Error - no fue posible cambiar la opción."
                ];
            }
        }
    }

    private static function publishTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Seminary();
            $result = $cd->publishTodo($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Publicada!"
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Error - no fue posible publicar."
                ];
            }
        }
    }

    private static function updatePortada()
    {
        User::authorizationFromApp();
        if (isset($_POST['id']) && isset($_POST['portada_path'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Seminary();
            $result = $cd->updatePortadaTodo($pdo, $_POST['id'], $_POST['portada_path']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Portada cambiada!",
                    "data" => $_POST['portada_path']
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Ocurrio un error al intentar cambiar la portada."
                ];
            }
        }
    }

    public function updatePortadaTodo($pdo, $id, $portada_path)
    {
        $query = "UPDATE " . self::TABLE_NAME . "
                        SET 
                        " . self::PORTADA_PATH . " = ?
                        WHERE " . self::ID_TALLER_SEM . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $portada_path, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

    private static function getTodoCode()
    {
        User::authorizationFromApp();
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $cd = new Seminary();
        $result = self::getAll($pdo);
        if ($result) {
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "message" => "¡Encontrado!",
                "data" => $result
            ];
        }
    }

    private static function deleteTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['id'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Seminary();
            $result = $cd->deleteTodo($pdo, $_POST['id']);
            if ($result) {
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Eliminado!"
                ];
            } else {
                return [
                    "status" => self::FAILED_CREATION,
                    "message" => "Error - no fue posible eliminar el seminario/taller."
                ];
            }
        }
    }

    private static function editTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['id']) && isset($_POST['tipo_taller_sem']) && isset($_POST['lugar']) && isset($_POST['titulo_taller_sem']) && isset($_POST['fecha_desde'])
            && isset($_POST['fecha_hasta']) && isset($_POST['horario']) && isset($_POST['inversion']) && isset($_POST['telefono'])
            && isset($_POST['extra'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Seminary();
            $result = $cd->modifyTodo($pdo, $_POST['id'], $_POST['tipo_taller_sem'], $_POST['titulo_taller_sem'], $_POST['lugar'], $_POST['fecha_desde'],
                $_POST['fecha_hasta'], $_POST['horario'], $_POST['inversion'], $_POST['telefono'], $_POST['extra']);
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "message" => "¡Editado!",
                "data" => self::getDataCode($_POST['id'])
            ];
        }
    }

    private static function registerTodoCode()
    {
        User::authorizationFromApp();
        if (isset($_POST['tipo_taller_sem']) && isset($_POST['titulo_taller_sem']) && isset($_POST['lugar']) && isset($_POST['fecha_desde'])
            && isset($_POST['fecha_hasta']) && isset($_POST['horario']) && isset($_POST['inversion']) && isset($_POST['telefono'])
            && isset($_POST['extra']) && isset($_POST['portada_path'])) {
            $pdo = ConnectionDB::getInstance()->getDataBase();
            $cd = new Seminary();
            $result = $cd->insertTodo($pdo, $_POST['tipo_taller_sem'], $_POST['titulo_taller_sem'], $_POST['lugar'], $_POST['fecha_desde'],
                $_POST['fecha_hasta'], $_POST['horario'], $_POST['inversion'], $_POST['telefono'], $_POST['extra'], $_POST['portada_path']);
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "message" => "¡Registrado!",
                "data" => self::getDataCode($pdo->lastInsertId())
            ];
        }
    }

    private static function getDataCode($id)
    {
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $cd = new Seminary();
        return $cd->getInfoByID($id, $pdo);
    }

    public static function getInfoByID($id, $pdo)
    {
        $query = "SELECT * FROM  " . self::TABLE_NAME . " WHERE " . self::ID_TALLER_SEM . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetchObject();
            return $result;
        } else {
            return null;
        }
    }


    public function insertTodo($pdo, $tipo_taller_sem, $titulo_taller_sem, $lugar, $fecha_desde, $fecha_hasta, $horario,
                               $inversion, $telefono, $extra, $portada_path)
    {

        $query = "INSERT INTO " . self::TABLE_NAME . "(" . self::TIPO_TALLER_SEM . ", 
                " . self::TITULO_TALLER_SEM . ", 
                " . self::LUGAR . ", 
                " . self::FECHA_DESDE . ", 
                " . self::FECHA_HASTA . ", 
                " . self::HORARIO . ",
                " . self::INVERSION . ", 
                " . self::TELEFONO . ", 
                " . self::EXTRA . ", 
                " . self::PORTADA_PATH . ") VALUES (?,?,?,?,?,?,?,?,?,?)";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $tipo_taller_sem, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $titulo_taller_sem, PDO::PARAM_STR);
        $prepare_stm->bindValue(3, $lugar, PDO::PARAM_STR);
        $prepare_stm->bindValue(4, $fecha_desde, PDO::PARAM_STR);
        $prepare_stm->bindValue(5, $fecha_hasta, PDO::PARAM_STR);
        $prepare_stm->bindValue(6, $horario, PDO::PARAM_STR);
        $prepare_stm->bindValue(7, $inversion, PDO::PARAM_STR);
        $prepare_stm->bindValue(8, $telefono, PDO::PARAM_STR);
        $prepare_stm->bindValue(9, $extra, PDO::PARAM_STR);
        $prepare_stm->bindValue(10, $portada_path, PDO::PARAM_STR);

        return $prepare_stm->execute();
    }


    public function deleteTodo($pdo, $id)
    {

        $query = "DELETE FROM " . self::TABLE_NAME . " WHERE " . self::ID_TALLER_SEM . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

    public function publishTodo($pdo, $id)
    {
        $query = "UPDATE " . self::TABLE_NAME . "
                        SET 
                        " . self::PUBLICAR . " = ?
                        WHERE " . self::ID_TALLER_SEM . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, "PUBLICADA", PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

    public function unPublishTodo($pdo, $id)
    {
        $query = "UPDATE " . self::TABLE_NAME . "
                        SET 
                        " . self::PUBLICAR . " = ?
                        WHERE " . self::ID_TALLER_SEM . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, "NO PUBLICADA", PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

    public function modifyTodo($pdo, $id, $tipo_taller_sem, $titulo_taller_sem, $lugar, $fecha_desde, $fecha_hasta, $horario,
                               $inversion, $telefono, $extra)
    {


        $query = "UPDATE " . self::TABLE_NAME . "
                        SET 
                        " . self::TIPO_TALLER_SEM . " = ?,
                        " . self::TITULO_TALLER_SEM . " = ?,
                        " . self::LUGAR . " = ?,
                        " . self::FECHA_DESDE . " = ?,
                        " . self::FECHA_HASTA . " = ?,
                        " . self::HORARIO . " = ?,
                        " . self::INVERSION . " = ?,
                        " . self::TELEFONO . " = ?,
                        " . self::EXTRA . " = ?
                        WHERE " . self::ID_TALLER_SEM . " = ?;";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $tipo_taller_sem, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $titulo_taller_sem, PDO::PARAM_STR);
        $prepare_stm->bindValue(3, $lugar, PDO::PARAM_STR);
        $prepare_stm->bindValue(4, $fecha_desde, PDO::PARAM_STR);
        $prepare_stm->bindValue(5, $fecha_hasta, PDO::PARAM_STR);
        $prepare_stm->bindValue(6, $horario, PDO::PARAM_STR);
        $prepare_stm->bindValue(7, $inversion, PDO::PARAM_STR);
        $prepare_stm->bindValue(8, $telefono, PDO::PARAM_STR);
        $prepare_stm->bindValue(9, $extra, PDO::PARAM_STR);
        $prepare_stm->bindValue(10, $id, PDO::PARAM_INT);

        return $prepare_stm->execute();
    }

    public static function getInscriptionSeminaryUser($pdo, $id_taller_sem, $id_usuario)
    {
        $query = "SELECT dex_usuario_taller_sem.* FROM dex_usuario_taller_sem INNER JOIN dex_taller_sem ON dex_usuario_taller_sem.id_taller_sem = dex_taller_sem.id_taller_sem INNER JOIN dex_usuario_new ON dex_usuario_new.id_usuario = dex_usuario_taller_sem.id_usuario AND dex_taller_sem.id_taller_sem  = ? AND dex_usuario_new.id_usuario = ?";
        //$pdo = ConnectionDB::getInstance()->getDataBase();
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_taller_sem, PDO::PARAM_INT);
        $prepare_stm->bindValue(2, $id_usuario, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetch(PDO::FETCH_ASSOC);
            return $result['estado_pago'];
        } else {
            return null;
        }
    }

    public static function getSeminaryOrderByPublicar($pdo)
    {
        $query = "SELECT * FROM " . self::TABLE_NAME . " WHERE " . self::PUBLICAR . " = ? ORDER BY " . self::ID_TALLER_SEM . " DESC;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, "PUBLICADA", PDO::PARAM_STR);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    public static function getSeminaryOrderByPublicarLimit($pdo, $search_text, $start_limit, $end_limit)
    {
        $query = "SELECT * FROM " . self::TABLE_NAME . " WHERE " . self::PUBLICAR . " = ? AND " . self::TITULO_TALLER_SEM . " LIKE ? ORDER BY " . self::ID_TALLER_SEM . " DESC LIMIT ?, ?;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, "PUBLICADA", PDO::PARAM_STR);
        $prepare_stm->bindValue(2, "%" . $search_text . "%", PDO::PARAM_STR);
        $prepare_stm->bindValue(3, $start_limit, PDO::PARAM_INT);
        $prepare_stm->bindValue(4, $end_limit, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }


    public static function getAll($pdo)
    {
        $query = "SELECT * FROM  " . self::TABLE_NAME . " ORDER BY " . self::FECHA_DESDE . " ASC;";
        $prepare_stm = $pdo->prepare($query);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    public static function getUserBySeminary($pdo, $id_taller_sem)
    {
        $query = "SELECT `dex_usuario_new`.`id_usuario`,
    `dex_usuario_new`.`email_usuario`,
    `dex_usuario_new`.`cedula_usuario`,    
    `dex_usuario_new`.`nombre_usuario`,
    `dex_usuario_new`.`apellido_usuario`,
    `dex_usuario_new`.`sexo`,
    `dex_usuario_new`.`pais_usuario`,
    `dex_usuario_new`.`ciudad_usuario`,
    `dex_usuario_new`.`direccion_usuario`,
    `dex_usuario_new`.`celular_usuario`,
    `dex_usuario_taller_sem`.`monto_cancelado`,
    `dex_usuario_taller_sem`.`estado_pago` FROM dex_usuario_taller_sem INNER JOIN dex_taller_sem ON 
    dex_taller_sem.id_taller_sem = dex_usuario_taller_sem.id_taller_sem INNER JOIN dex_usuario_new ON 
    dex_usuario_new.id_usuario = dex_usuario_taller_sem.id_usuario AND dex_taller_sem.id_taller_sem = ?;";
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_taller_sem, PDO::PARAM_INT);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }
            return $rows;
        } else {
            return null;
        }
    }

    private static function getSeminaryPostByCode()
    {

        if (isset($_POST['id_taller_sem'])) {
            //extraer primero las notificaciones de códigos promocionales - DISPONIBLES
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => self::getDataCode($_POST['id_taller_sem'])
            ];
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Parametros incorrectos", 400);
        }

    }
}

?>