<?php


use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

class Send_Email
{

    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private $HOST = "smtp.gmail.com";
    private $USERNAME = "cepweb.activacion@gmail.com";
    private $PASS = "Ao5OlhAJ";
    private $SMTP = "tls";
    private $PORT = "587";
    private $mail = null;

    public function __construct()
    {
        // Instantiation and passing `true` enables exceptions
        $this->mail = new PHPMailer(true);
        //Server settings

        $this->mail->CharSet = 'UTF-8';
        $this->mail->SMTPDebug = 0;                                     // Enable verbose debug output
        $this->mail->isSMTP();                                          // Set mailer to use SMTP
        $this->mail->Host = $this->HOST;                                // sets GMAIL as the SMTP server
        $this->mail->SMTPAuth = true;                                   // Enable SMTP authentication
        $this->mail->Username = $this->USERNAME;                        // GMAIL username
        $this->mail->Password = $this->PASS;                            // GMAIL password
        $this->mail->SMTPSecure = $this->SMTP;                          // Enable TLS encryption, `ssl` also accepted
        $this->mail->Port = $this->PORT;                                // TCP port to connect to

    }

    private function makeEmail($text_email, $subject, $invitation_email)
    {
        try {
            //Recipients
            $this->mail->setFrom('cepweb@cep.org.ec', 'Servicio al Cliente CEPWeb');
            //$this->mail->addReplyTo("cepweb@cep.org.ec", "Servicio al Cliente CEPWeb");
            foreach ($invitation_email as $key => $val) {
                $this->mail->AddAddress($val, $key);
            }

            // Content
            $this->mail->isHTML(true);                                  // Set email format to HTML
            $this->mail->Subject = $subject;
            $this->mail->Body = $text_email;
            $this->mail->AltBody = 'Para ver este mensaje, por favor use un cliente email compatible con HTML';

            $sending = $this->mail->send();
            if ($sending) {
                return true;
            } else {
                return "Mailer Error: {$this->mail->ErrorInfo}";
            }
        } catch (Exception $e) {
            return "Message could not be sent. Mailer Error: {$this->mail->ErrorInfo}";
        }
    }

    public function createContactMessage($names, $email, $tema, $message, $subject, $servicio_speedy, $direccion, $telefono)
    {
        $text_email = $this->setMessage($message, $email, $names, $tema, $servicio_speedy, $direccion, $telefono);
        $text_email = $this->email_add_format($text_email);
        return $this->makeEmail($text_email, $subject, array($names => "cepweb.activacion@gmail.com"));
    }


    public function createInvitation($name_creador, $codigo, $invitation_email)
    {
        $subject = "Regalo de " . $name_creador;

        $text_email = $this->setContentEmail($name_creador, $codigo);
        $text_email = $this->email_add_format($text_email);
        return $this->makeEmail($text_email, $subject, $invitation_email);
    }


    public function resentInvitation($codigo, $invitation_email)
    {
        $subject = "Reenvío de código promocional";
        $text_email = $this->setReenvioContent($codigo);
        $text_email = $this->email_add_format($text_email);
        return $this->makeEmail($text_email, $subject, $invitation_email);
    }

    public function sendLinkLaw($dondeDescargo, $invitation_email)
    {
        $subject = "Descarga ya el documento solicitado";
        $text_email = $this->setEnviarLinkDescargaLaw($dondeDescargo);
        $text_email = $this->email_add_format($text_email);
        return $this->makeEmail($text_email, $subject, $invitation_email);
    }


    public function sentEbookLink($path_ebook, $invitation_email)
    {
        $subject = "Compra de ebook en SpeedyCEP";

        $text_email = $this->setContentEbookLink($path_ebook);
        $text_email = $this->email_add_format($text_email);
        return $this->makeEmail($text_email, $subject, $invitation_email);
    }

    public function sentCongratsDownload($invitation_email)
    {
        $subject = "Compra de ley en físico SpeedyCEP";

        $text_email = $this->setContentCongratsDownload();
        $text_email = $this->email_add_format($text_email);
        return $this->makeEmail($text_email, $subject, $invitation_email);
    }

    private function setMessage($message, $email, $names, $tema, $servicio_speedy, $direccion, $telefono)
    {
        return "<p><strong>Email:</strong> " . $email . "</p>
                <p><strong>Nombres y Apellidos:</strong> " . $names . "</p>
                <p><strong>Servicio contratado:</strong> " . $servicio_speedy . "</p>
                <p><strong>Dirección de contacto:</strong> " . $direccion . "</p>
                <p><strong>Teléfono de contacto:</strong> " . $telefono . "</p>
                <p><strong>Tema:</strong> " . $tema . "</p>
                <p><strong>Mensaje:</strong> " . $message . "</p>";
    }

    private function setContentEmail($name_creador, $codigo)
    {

        return "<p style='font-size: 18px;'>Hola, " . $name_creador . " ha hecho que tú ganes una suscripción gratuita, por un mes, a SpeedyCEP, la herramienta más veloz para buscar y hallar leyes en donde quiera que estés.
        <br/>
        SpeedyCEP es una sencilla App de búsqueda de leyes que se actualiza a diario. La versión gratuita permite acceder rápidamente a varias de las leyes más importantes del Ecuador. Pero con el cupón que acabas de ganar te has hecho acreedor puedes acceder al 100% de las leyes vigentes del país que están en nuestra base de datos.
        <br/>
        Descarga la App en <a href='https://play.google.com/store/apps/details?id=com.ec.cepapp&hl=es'>Google Play</a> o en <a href=''>App Store</a>, regístrate con este email y luego ingresa este código promocional: " . $codigo . "
        <br/>
        <strong>¡Disfruta SpeedyCEP!</strong></p>
        ";

    }

    private function setReenvioContent($codigo)
    {

        return "<p style='font-size: 18px;'>Hola, has ganado una suscripción gratuita, por un mes, a SpeedyCEP, la herramienta más veloz para buscar y hallar leyes en donde quiera que estés.
        <br/>
        SpeedyCEP es una sencilla App de búsqueda de leyes que se actualiza a diario. La versión gratuita permite acceder rápidamente a varias de las leyes más importantes del Ecuador. Pero con el cupón que acabas de ganar te has hecho acreedor puedes acceder al 100% de las leyes vigentes del país que están en nuestra base de datos por un mes.
        <br/>
        Descarga la App en <a href='https://play.google.com/store/apps/details?id=com.ec.cepapp&hl=es'>Google Play</a> o en <a href=''>App Store</a>, regístrate con este email y luego ingresa este código promocional: " . $codigo . "
        <br/>
        <strong>¡Disfruta SpeedyCEP!</strong></p>
        ";

    }

    private function setEnviarLinkDescargaLaw($dondeDescargo)
    {

        return "<p style='font-size: 18px;'>Hola, puedes descargar la versión digital accediendo al siguiente enlace: " . $dondeDescargo . " <br/>
        Descarga la App en <a href='https://play.google.com/store/apps/details?id=com.ec.cepapp&hl=es'>Google Play</a> y en <a href=''>App Store</a>
        <br/>
        <strong>¡Disfruta SpeedyCEP!</strong></p>
        ";

    }

    private function setContentCongratsDownload()
    {

        return "<p style='font-size: 18px;'>Tu transacción se ha realizado correctamente. En los siguientes días te llegará esta ley a tu casa</p>";

    }

    private function setContentEbookLink($path_ebook)
    {

        return "<p style='font-size: 18px;'>Hola, gracias por comprar nuestro ebook, puedes descargar el mismo desde el siguiente enlance: " . $path_ebook . " <br/>
        Descarga la App en <a href='https://play.google.com/store/apps/details?id=com.ec.cepapp&hl=es'>Google Play</a> y en <a href=''>App Store</a>
        <br/>
        <strong>¡Disfruta SpeedyCEP!</strong></p>
        ";

    }

    private function email_add_format($html_body)
    {
        $final_body = '<html>
<head>
<style>
	body{
		font-family:Arial, Helvetica, sans-serif;
		font-size:12px;
		color:#333;
	}
	
	.headerMail{
		text-align:right;
		margin:20px;
	}
	.footerMail{
		text-align:left;
		margin:20px;
	}
	.bodyMail{
		margin:20px;
	}
	hr{
		margin:0px 20px;
	}
</style>
</head><body leftmargin="0" topmargin="0">
	<div class="headerMail"><a href="http://www.cepweb.com.ec/"><img src="http://www.cepweb.com.ec/AppWeb/img/imagen_ingreso_cw.png" alt="" border="0" /></a></div>
	<hr />
	<div class="bodyMail">' . $html_body . '</div>
	<hr />    
    <div class="footerMail">&copy; ' . date("Y") . ' Corporacion de Estudios y Publicaciones</div>
</body></html>';
        return $final_body;
    }

    public function createMessagePaySubscription($nombre_usuario, $direccion_usuario, $telefono_usuario,
                                                 $type_subscription, $email_usuario,
                                                 $fecha_y_hora_compra, $num_transaccion, $monto_pagado,
                                                 $fecha_expiracion, $invitation_email)
    {

        $subject = "Hola $nombre_usuario, su suscripción $num_transaccion ha sido completada.";

        $text_email = "<style>
        p {
        
        font-family: Arial, Helvetica, sans-serif;
        
        }
        
        table {
          border-collapse: collapse;
        }
        
        th, td {
          padding: 15px;
          text-align: left;
          border-bottom: 1px solid #ddd;
        }
        
        div#content {
          width: 500px;
          border: 2px solid #ddd;
          padding: 15px;
        }
        
        div#main {
            display: flex;
            flex-direction: row;
            justify-content: center;
            align-items: center;
        }
        
        p#copyright {
            padding:15px;
            text-align: center;
            font-size: 10px;
            color: #555;
        }
        
        div#header {
            background: #D31E3E;
            padding:15px;
            color: white;
        }
        
        </style>
        
        <div id=\"main\">
            <div id=\"content\">
                <div id=\"header\">
                    <p>Hola $nombre_usuario,</p>
                    <h2><strong>USTED ACABA DE COMPRAR UNA SUSCRIPCI&Oacute;N POR $type_subscription</strong></h2>
                </div>
                    <p>&nbsp;</p>
                    <p><strong>Los detalles de la transacci&oacute;n son:</strong></p>
                <table>
                <tbody>
                <tr>
                <td width=\"294\">
                <p><strong>Enviado a:</strong></p>
                </td>
                <td width=\"294\">
                <p>$email_usuario</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Dirección:</strong></p>
                </td>
                <td width=\"294\">
                <p>$direccion_usuario</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Teléfono:</strong></p>
                </td>
                <td width=\"294\">
                <p>$telefono_usuario</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Fecha y hora:</strong></p>
                </td>
                <td width=\"294\">
                <p>$fecha_y_hora_compra</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>ID de la transacci&oacute;n:</strong></p>
                </td>
                <td width=\"294\">
                <p>$num_transaccion</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Total pagado:</strong></p>
                </td>
                <td width=\"294\">
                <p>$" . $monto_pagado . "</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>V&aacute;lido hasta el:</strong></p>
                </td>
                <td width=\"294\">
                <p>$fecha_expiracion</p>
                </td>
                </tr>
                </tbody>
                </table>
                <p>&nbsp;</p>
                <p>Si usted no realiz&oacute; esta operaci&oacute;n, o si no reconoce ninguno de los detalles que aparecen en la parte superior, por favor, contacte con nuestro <a href=\"mailto:cepweb.activacion@gmail.com\">soporte técnico</a>.</p>
                <p>&nbsp;</p>
                <p><strong>Gracias por usar SpeedyCEP</strong></p>
                <div align=\"center\">
                    <img src=\"https://cepweb.com.ec/speedycep/speedyceplogo.png\" alt=\"\" border=\"0\" width= \"128\" height=\"128\" />
                </div>
                <p id=\"copyright\">Copyright © " . date("Y") . " Corporacion de Estudios y Publicaciones. SpeedyCEP es una marca registrada de Corporacion de Estudios y Publicaciones. Todos los derechos reservados.</p>
            </div>
        </div>";

        return $this->makeEmail($text_email, $subject, $invitation_email);
    }


    public function createMessagePaySeminary($nombre_usuario, $tipo_taller_sem, $email_usuario,
                                             $titulo_taller_sem, $fecha_desde, $fecha_hasta,
                                             $horario, $numero_transaccion, $monto_pagado, $telefono_usuario,
                                             $lugar_taller_sem, $extra_taller_sem, $invitation_email)
    {

        $subject = "Hola $nombre_usuario, su compra $numero_transaccion  de " . strtolower($titulo_taller_sem) . " ha sido completada.";

        $text_email = "<style>
            
            p {
            
            font-family: Arial, Helvetica, sans-serif;
            
            }
            
            table {
              border-collapse: collapse;
            }
            
            th, td {
              padding: 15px;
              text-align: left;
              border-bottom: 1px solid #ddd;
            }
            
            div#content {
              width: 500px;
              border: 2px solid #ddd;
              padding: 15px;
            }
            
            div#main {
                display: flex;
                flex-direction: row;
                justify-content: center;
                align-items: center;
            }
            
            p#copyright {
                padding:15px;
                text-align: center;
                font-size: 10px;
                color: #555;
            }
            
            div#header {
                background: #D31E3E;
                padding:15px;
                color: white;
            }
            
            </style>
            
            <div id=\"main\">
                <div id=\"content\">
                    <div id=\"header\">
                        <p>Hola $nombre_usuario,</p>
                        <h2><strong>USTED ACABA DE COMPRAR UN CURSO O SEMINARIO DE ".strtoupper($titulo_taller_sem)."</strong></h2>
                    </div>
                        <p>&nbsp;</p>
                        <p><strong>Los detalles de la transacci&oacute;n son:</strong></p>
                    <table>
                    <tbody>
                    <tr>
                    <td width=\"294\">
                    <p><strong>Enviado a:</strong></p>
                    </td>
                    <td width=\"294\">
                    <p>$email_usuario</p>
                    </td>
                    </tr>
                    <tr>
                    <td width=\"294\">
                    <p><strong>Título:</strong></p>
                    </td>
                    <td width=\"294\">
                    <p>$titulo_taller_sem</p>
                    </td>
                    </tr>
                    <tr>
                    <td width=\"294\">
                    <p><strong>Comienza:</strong></p>
                    </td>
                    <td width=\"294\">
                    <p>$fecha_desde</p>
                    </td>
                    </tr>
                    <tr>
                    <td width=\"294\">
                    <p><strong>Termina:</strong></p>
                    </td>
                    <td width=\"294\">
                    <p>$fecha_hasta</p>
                    </td>
                    </tr>
                    <tr>
                    <td width=\"294\">
                    <p><strong>Horario</strong></p>
                    </td>
                    <td width=\"294\">
                    <p>$horario</p>
                    </td>
                    </tr>
                    <tr>
                    <td width=\"294\">
                    <p><strong>ID de la transacción:</strong></p>
                    </td>
                    <td width=\"294\">
                    <p>$numero_transaccion</p>
                    </td>
                    </tr>
                    <tr>
                    <td width=\"294\">
                    <p><strong>Total pagado:</strong></p>
                    </td>
                    <td width=\"294\">
                    <p>$" . $monto_pagado . "</p>
                    </td>
                    </tr>
                    <tr>
                    <td width=\"294\">
                    <p><strong>Télefono de contacto:</strong></p>
                    </td>
                    <td width=\"294\">
                    <p>$telefono_usuario</p>
                    </td>
                    </tr>
                    <tr>
                    <td width=\"294\">
                    <p><strong>Lugar:</strong></p>
                    </td>
                    <td width=\"294\">
                    <p>$lugar_taller_sem</p>
                    </td>
                    </tr>
                    <tr>
                    <td width=\"294\">
                    <p><strong>Información adicional:</strong></p>
                    </td>
                    <td width=\"294\">
                    <p>$extra_taller_sem</p>
                    </td>
                    </tr>
                    </tbody>
                    </table>
                    <p>&nbsp;</p>
                    <p>Si usted no realiz&oacute; esta operaci&oacute;n, o si no reconoce ninguno de los detalles que aparecen en la parte superior, por favor, contacte con nuestro <a href=\"mailto:cepweb.activacion@gmail.com\">soporte técnico</a>.</p>
                    <p>&nbsp;</p>
                    <p><strong>Gracias por usar SpeedyCEP</strong></p>
                    <div align=\"center\">
                        <img src=\"https://cepweb.com.ec/speedycep/speedyceplogo.png\" alt=\"\" border=\"0\" width= \"128\" height=\"128\" />
                    </div>
                    <p id=\"copyright\">Copyright © " . date("Y") . " Corporacion de Estudios y Publicaciones. SpeedyCEP es una marca registrada de Corporacion de Estudios y Publicaciones. Todos los derechos reservados.</p>
                </div>
            </div>";

        return $this->makeEmail($text_email, $subject, $invitation_email);
    }


    public function createMessagePayLaw($nombre_usuario, $direccion_usuario, $telefono_usuario,
                                        $titulo_ley, $email_usuario,
                                        $fecha_y_hora_compra, $num_transaccion, $monto_pagado,
                                        $invitation_email)
    {

        $subject = "Hola $nombre_usuario, su compra N# $num_transaccion ha sido completada.";

        $text_email = "<style>
        p {
        
        font-family: Arial, Helvetica, sans-serif;
        
        }
        
        table {
          border-collapse: collapse;
        }
        
        th, td {
          padding: 15px;
          text-align: left;
          border-bottom: 1px solid #ddd;
        }
        
        div#content {
          width: 500px;
          border: 2px solid #ddd;
          padding: 15px;
        }
        
        div#main {
            display: flex;
            flex-direction: row;
            justify-content: center;
            align-items: center;
        }
        
        p#copyright {
            padding:15px;
            text-align: center;
            font-size: 10px;
            color: #555;
        }
        
        div#header {
            background: #D31E3E;
            padding:15px;
            color: white;
        }
        
        </style>
        
        <div id=\"main\">
            <div id=\"content\">
                <div id=\"header\">
                    <p>Hola $nombre_usuario,</p>
                    <h2><strong>USTED ACABA DE COMPRAR UNA LEY</strong></h2>
                </div>
                    <p>&nbsp;</p>
                    <p><strong>Los detalles de la transacci&oacute;n son:</strong></p>
                <table>
                <tbody>
                <tr>
                <td width=\"294\">
                <p><strong>Enviado a:</strong></p>
                </td>
                <td width=\"294\">
                <p>$email_usuario</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Ley:</strong></p>
                </td>
                <td width=\"294\">
                <p>$titulo_ley</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Dirección:</strong></p>
                </td>
                <td width=\"294\">
                <p>$direccion_usuario</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Teléfono:</strong></p>
                </td>
                <td width=\"294\">
                <p>$telefono_usuario</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Fecha y hora:</strong></p>
                </td>
                <td width=\"294\">
                <p>$fecha_y_hora_compra</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>ID de la transacci&oacute;n:</strong></p>
                </td>
                <td width=\"294\">
                <p>$num_transaccion</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Total pagado:</strong></p>
                </td>
                <td width=\"294\">
                <p>$" . $monto_pagado . "</p>
                </td>
                </tr>
                </tbody>
                </table>
                <p>&nbsp;</p>
                <p>Si usted no realiz&oacute; esta operaci&oacute;n, o si no reconoce ninguno de los detalles que aparecen en la parte superior, por favor, contacte con nuestro <a href=\"mailto:cepweb.activacion@gmail.com\">soporte técnico</a>.</p>
                <p>&nbsp;</p>
                <p><strong>Gracias por usar SpeedyCEP</strong></p>
                <div align=\"center\">
                    <img src=\"https://cepweb.com.ec/speedycep/speedyceplogo.png\" alt=\"\" border=\"0\" width= \"128\" height=\"128\" />
                </div>
                <p id=\"copyright\">Copyright © " . date("Y") . " Corporacion de Estudios y Publicaciones. SpeedyCEP es una marca registrada de Corporacion de Estudios y Publicaciones. Todos los derechos reservados.</p>
            </div>
        </div>";

        return $this->makeEmail($text_email, $subject, $invitation_email);
    }


    public function createMessagePayBook($nombre_usuario, $direccion_usuario, $telefono_usuario,
                                         $tipo_book, $titulo_book, $autor_book, $edicion_book, $email_usuario,
                                         $fecha_y_hora_compra, $num_transaccion, $monto_pagado,
                                         $invitation_email)
    {

        $subject = "Hola $nombre_usuario, su compra N# $num_transaccion ha sido completada.";

        $text_email = "<style>
        p {
        
        font-family: Arial, Helvetica, sans-serif;
        
        }
        
        table {
          border-collapse: collapse;
        }
        
        th, td {
          padding: 15px;
          text-align: left;
          border-bottom: 1px solid #ddd;
        }
        
        div#content {
          width: 500px;
          border: 2px solid #ddd;
          padding: 15px;
        }
        
        div#main {
            display: flex;
            flex-direction: row;
            justify-content: center;
            align-items: center;
        }
        
        p#copyright {
            padding:15px;
            text-align: center;
            font-size: 10px;
            color: #555;
        }
        
        div#header {
            background: #D31E3E;
            padding:15px;
            color: white;
        }
        
        </style>
        
        <div id=\"main\">
            <div id=\"content\">
                <div id=\"header\">
                    <p>Hola $nombre_usuario,</p>
                    <h2><strong>USTED ACABA DE COMPRAR UN LIBRO $tipo_book</strong></h2>
                </div>
                    <p>&nbsp;</p>
                    <p><strong>Los detalles de la transacci&oacute;n son:</strong></p>
                <table>
                <tbody>
                <tr>
                <td width=\"294\">
                <p><strong>Enviado a:</strong></p>
                </td>
                <td width=\"294\">
                <p>$email_usuario</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Título:</strong></p>
                </td>
                <td width=\"294\">
                <p>$titulo_book</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Autor:</strong></p>
                </td>
                <td width=\"294\">
                <p>$autor_book</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Edición:</strong></p>
                </td>
                <td width=\"294\">
                <p>$edicion_book</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Dirección:</strong></p>
                </td>
                <td width=\"294\">
                <p>$direccion_usuario</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Teléfono:</strong></p>
                </td>
                <td width=\"294\">
                <p>$telefono_usuario</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Fecha y hora:</strong></p>
                </td>
                <td width=\"294\">
                <p>$fecha_y_hora_compra</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>ID de la transacci&oacute;n:</strong></p>
                </td>
                <td width=\"294\">
                <p>$num_transaccion</p>
                </td>
                </tr>
                <tr>
                <td width=\"294\">
                <p><strong>Total pagado:</strong></p>
                </td>
                <td width=\"294\">
                <p>$" . $monto_pagado . "</p>
                </td>
                </tr>
                </tbody>
                </table>
                <p>&nbsp;</p>
                <p>Si usted no realiz&oacute; esta operaci&oacute;n, o si no reconoce ninguno de los detalles que aparecen en la parte superior, por favor, contacte con nuestro <a href=\"mailto:cepweb.activacion@gmail.com\">soporte técnico</a>.</p>
                <p>&nbsp;</p>
                <p><strong>Gracias por usar SpeedyCEP</strong></p>
                <div align=\"center\">
                    <img src=\"https://cepweb.com.ec/speedycep/speedyceplogo.png\" alt=\"\" border=\"0\" width= \"128\" height=\"128\" />
                </div>
                <p id=\"copyright\">Copyright © " . date("Y") . " Corporacion de Estudios y Publicaciones. SpeedyCEP es una marca registrada de Corporacion de Estudios y Publicaciones. Todos los derechos reservados.</p>
            </div>
        </div>";

        return $this->makeEmail($text_email, $subject, $invitation_email);
    }

}