<?php
ini_set('memory_limit', '-1');
require_once 'ConnectionDB.php';

class Setting_app
{
    const TABLE_NAME = "dex_settings_app";

    const ID_DEX_SETTINGS_APP = "id_dex_settings_app";
    const LAW_PRICE = "law_price";
    const LAW_ROW_QUANTITY = "law_row_quantity";
    const DOMESTIC_SHIPPING_PRICE = "domestic_shipping_price";
    const AMERICA_SHIPPING_PRICE = "america_shipping_price";
    const INTERNATIONAL_SHIPPING_PRICE = "international_shipping_price";
    const MONTHLY_SUBSCRIPTION_PRICE = "monthly_subscription_price";
    const ANUAL_SUBSCRIPTION_PRICE = "anual_subscription_price";

    const EMAILS_FOR_BOOKS = "emails_for_books";
    const EMAILS_FOR_SEMINARIES = "emails_for_seminaries";
    const EMAILS_FOR_SUSCRIPTIONS = "emails_for_suscriptions";

    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private static $encryption_key = '5166546A576E5A72';


    public static function setPostRequest($request)
    {

        if ($request[0] == 'get') {
            return Setting_app::get();
        } else if ($request[0] == 'change') {
            return Setting_app::change();
        } else if ($request[0] == 'change_emails_for_books') {
            return Setting_app::update_emails_for_books();
        } else if ($request[0] == 'change_emails_for_seminaries') {
            return Setting_app::update_emails_for_seminaries();
        } else if ($request[0] == 'change_emails_for_subscriptions') {
            return Setting_app::update_emails_for_subscriptions();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    private static function change()
    {

        User::authorizationFromApp();
        $DEFAULT_ID_DEX_SETTINGS_APP = '1';

        $query = "UPDATE " . self::TABLE_NAME . " SET " . self::LAW_PRICE . " = ?, " . self::LAW_ROW_QUANTITY . " = ?, " . self::DOMESTIC_SHIPPING_PRICE . " = ?, " . self::AMERICA_SHIPPING_PRICE . " = ?, " . self::INTERNATIONAL_SHIPPING_PRICE . " = ?, " . self::MONTHLY_SUBSCRIPTION_PRICE . " = ?, " . self::ANUAL_SUBSCRIPTION_PRICE . " = ? WHERE " . self::ID_DEX_SETTINGS_APP . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $_POST['law_price'], PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $_POST['law_row_quantity'], PDO::PARAM_INT);
        $prepare_stm->bindValue(3, $_POST['domestic_shipping_price'], PDO::PARAM_STR);
        $prepare_stm->bindValue(4, $_POST['america_shipping_price'], PDO::PARAM_STR);
        $prepare_stm->bindValue(5, $_POST['international_shipping_price'], PDO::PARAM_STR);
        $prepare_stm->bindValue(6, $_POST['monthly_subscription_price'], PDO::PARAM_STR);
        $prepare_stm->bindValue(7, $_POST['anual_subscription_price'], PDO::PARAM_STR);
        $prepare_stm->bindValue(8, $DEFAULT_ID_DEX_SETTINGS_APP, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => "Los ajustes de precios fueron almacenados correctamente."
            ];
        } else {
            return [
                "status" => self::FAILED_CREATION,
                "message" => "Ocurrio un error al intentar almacenar los ajustes precios"
            ];
        }

    }


    private static function update_emails_for_books()
    {

        User::authorizationFromApp();
        $DEFAULT_ID_DEX_SETTINGS_APP = '1';

        $query = "UPDATE " . self::TABLE_NAME . " SET " . self::EMAILS_FOR_BOOKS . " = ? WHERE " . self::ID_DEX_SETTINGS_APP . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $_POST['emails_for_books'], PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $DEFAULT_ID_DEX_SETTINGS_APP, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => "Correos almacenados correctamente."
            ];
        } else {
            return [
                "status" => self::FAILED_CREATION,
                "message" => "Ocurrio un error al intentar almacenar los correos"
            ];
        }

    }


    private static function update_emails_for_seminaries()
    {

        User::authorizationFromApp();
        $DEFAULT_ID_DEX_SETTINGS_APP = '1';

        $query = "UPDATE " . self::TABLE_NAME . " SET " . self::EMAILS_FOR_SEMINARIES . " = ? WHERE " . self::ID_DEX_SETTINGS_APP . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $_POST['emails_for_seminaries'], PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $DEFAULT_ID_DEX_SETTINGS_APP, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => "Correos almacenados correctamente."
            ];
        } else {
            return [
                "status" => self::FAILED_CREATION,
                "message" => "Ocurrio un error al intentar almacenar los correos"
            ];
        }

    }


    private static function update_emails_for_subscriptions()
    {

        User::authorizationFromApp();
        $DEFAULT_ID_DEX_SETTINGS_APP = '1';

        $query = "UPDATE " . self::TABLE_NAME . " SET " . self::EMAILS_FOR_SUSCRIPTIONS . " = ? WHERE " . self::ID_DEX_SETTINGS_APP . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $_POST['emails_for_suscriptions'], PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $DEFAULT_ID_DEX_SETTINGS_APP, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => "Correos almacenados correctamente."
            ];
        } else {
            return [
                "status" => self::FAILED_CREATION,
                "message" => "Ocurrio un error al intentar almacenar los correos"
            ];
        }

    }


    private static function get()
    {
        $body = file_get_contents('php://input');
        User::authorizationFromApp();
        $query = "SELECT * FROM  " . self::TABLE_NAME . " ORDER BY " . self::ID_DEX_SETTINGS_APP . " ASC;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);

        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }

            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => $rows
            ];
        } else {
            return null;
        }
    }

    public static function getAllPrices() {
        $query = "SELECT law_price, law_row_quantity, domestic_shipping_price, america_shipping_price, international_shipping_price, monthly_subscription_price, anual_subscription_price FROM  " . self::TABLE_NAME . " ORDER BY " . self::ID_DEX_SETTINGS_APP . " ASC LIMIT 1;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);

        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }

            for ($i = 0; $i < count($rows); $i++) {
                $rows[$i]['law_price'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]['law_price']);
                $rows[$i]['law_row_quantity'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]['law_row_quantity']);
                $rows[$i]['domestic_shipping_price'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]['domestic_shipping_price']);
                $rows[$i]['america_shipping_price'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]['america_shipping_price']);
                $rows[$i]['international_shipping_price'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]['international_shipping_price']);
                $rows[$i]['monthly_subscription_price'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]['monthly_subscription_price']);
                $rows[$i]['anual_subscription_price'] = PHP_AES_Cipher::encrypt(self::$encryption_key, $rows[$i]['anual_subscription_price']);
            }

            return $rows;
        } else {
            return null;
        }
    }
}