<?php
date_default_timezone_set('America/Guayaquil');

class SubscriptionPremium
{
    const TABLE_NAME = "dex_usu_ser_contratado";
    const ID_USU_SER_CONTRATADO = "id_usu_ser_contratado";
    const METODO_PAGO = "metodo_pago";
    const FECHA_PAGO = "fecha_pago";
    const FECHA_EXPIRACION = "fecha_expiracion";
    const DURACION = "duracion";
    const TIPO_SERVICIO = "tipo_servicio";
    const ESTADO = "estado";
    const NOMBRES = "nombres";
    const APELLIDOS = "apellidos";
    const TELEFONO = "telefono";
    const CEDULA = "cedula";
    const DIRECCION = "direccion";
    const CIUDAD = "ciudad";
    const PAIS = "pais";
    const EMAIL = "email";
    const NUM_TRANSACCION = "num_transaccion";
    const ID_USUARIO = "id_usuario";

    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    private static $encryption_key = '5166546A576E5A72';
    private static $keyApp = "A80D313B049E3A50E2B4DA77C62B779E0631FC4F8A1B118E99063A7524AB154B";

    public static function setPostRequest($request)
    {

        if ($request[0] == 'register') {
            return SubscriptionPremium::registerSubscription();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    private static function registerSubscription()
    {

        $body = file_get_contents('php://input');
        $Data = json_decode($body);
        User::authorizationFromApp();

        if ($Data !== null && ValidComponent::issetField($Data->id_usuario, 900)
            && ValidComponent::issetField($Data->metodo_pago, 901) && ValidComponent::issetField($Data->duracion, 902)
            && ValidComponent::issetField($Data->tipo_servicio, 903) && ValidComponent::issetField($Data->estado, 904)
            && ValidComponent::issetField($Data->nombres, 905) && ValidComponent::issetField($Data->apellidos, 906)
            && ValidComponent::issetField($Data->telefono, 907) && ValidComponent::issetField($Data->cedula, 908)
            && ValidComponent::issetField($Data->direccion, 909) && ValidComponent::issetField($Data->ciudad, 910)
            && ValidComponent::issetField($Data->pais, 911) && ValidComponent::issetField($Data->email, 912)
            && ValidComponent::issetField($Data->num_transaccion, 914)
            && ValidComponent::issetField($Data->monto_pagado, 915)) {

            $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $Data->id_usuario);
            //$id_usuario_php = $Data->id_usuario;
            $metodo_pago = $Data->metodo_pago;
            $duracion = $Data->duracion;
            $tipo_servicio = $Data->tipo_servicio;
            $estado = $Data->estado;
            $nombres = $Data->nombres;
            $apellidos = $Data->apellidos;
            $telefono = $Data->telefono;
            $cedula = $Data->cedula;
            $direccion = $Data->direccion;
            $ciudad = $Data->ciudad;
            $pais = $Data->pais;
            $email = $Data->email;
            $num_transaccion = $Data->num_transaccion;
            $monto_pagado = $Data->monto_pagado;

            //fecha_pago
            //fecha_expiracion
            $date_pago = new DateTime('now');
            $fecha_pago = $date_pago->format("Y-m-d h:i:s");

            $fecha_pago_alt = $date_pago->format("m/d/Y h:i:s a");
            $dia_q_caduca = User::newFechaCaducidadPremium($id_usuario_php, $duracion);
            $dia_q_caduca_alt = User::newFechaCaducidadPremiumT($id_usuario_php, $duracion);
            $query = "INSERT INTO " . self::TABLE_NAME . " (" . self::METODO_PAGO . ", " . self::FECHA_PAGO . ", " . self::FECHA_EXPIRACION . ", " . self::DURACION . ", " . self::TIPO_SERVICIO . ", " . self::ESTADO . ", " . self::NOMBRES . ", " . self::APELLIDOS . ", " . self::TELEFONO . ", " . self::CEDULA . ", " . self::DIRECCION . ", " . self::CIUDAD . ", " . self::PAIS . ", " . self::EMAIL . ", " . self::NUM_TRANSACCION . ", " . self::ID_USUARIO . ") VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";

            $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
            $prepare_stm->bindParam(1, $metodo_pago);
            $prepare_stm->bindParam(2, $fecha_pago);
            $prepare_stm->bindParam(3, $dia_q_caduca);
            $prepare_stm->bindParam(4, $duracion);
            $prepare_stm->bindParam(5, $tipo_servicio);
            $prepare_stm->bindParam(6, $estado);
            $prepare_stm->bindParam(7, $nombres);
            $prepare_stm->bindParam(8, $apellidos);
            $prepare_stm->bindParam(9, $telefono);
            $prepare_stm->bindParam(10, $cedula);
            $prepare_stm->bindParam(11, $direccion);
            $prepare_stm->bindParam(12, $ciudad);
            $prepare_stm->bindParam(13, $pais);
            $prepare_stm->bindParam(14, $email);
            $prepare_stm->bindParam(15, $num_transaccion);
            $prepare_stm->bindParam(16, $id_usuario_php);

            $result = $prepare_stm->execute();
            if ($result) {
                User::updateFechaCaducidadPremium($id_usuario_php, $duracion);
                http_response_code(200);


                $emailUser = strtolower(User::getEmailFromID($id_usuario_php));
                $fullNameUser = strtolower(User::getFullNameFromID($id_usuario_php));

                //get emails to send copy.
                $multi_info_api = API::POST_SERVER(Constants::PATH_API() . "/setting_app/get/",
                    array(), self::$keyApp);
                $data = API::JSON_TO_ARRAY($multi_info_api);
                $emails_for_books = $data["data"][0]['emails_for_suscriptions'];
                $arr_data = json_decode($emails_for_books, true);

                $email_principal = $arr_data['email_principal'];
                $email_option_a = $arr_data['email_option_a'];
                $email_option_b = $arr_data['email_option_b'];
                //create array emails
                $invitation_emails = array(
                    $fullNameUser => $emailUser
                );

                if ($email_principal != "") {
                    $invitation_emails["Correo principal"] = $email_principal;
                }

                if ($email_option_a != "") {
                    $invitation_emails["Correo opcional 1"] = $email_option_a;
                }

                if ($email_option_b != "") {
                    $invitation_emails["Correo opcional 2"] = $email_option_b;
                }


                API::POST(Constants::LOCAL_SERVER() . "/speedycep/mail/sending_message_pay_subscription.php",
                    array(
                        "nombre_usuario" => $fullNameUser,
                        "direccion_usuario" => $direccion . ", Ciudad " . $ciudad . ", " . $pais,
                        "telefono_usuario" => $telefono,
                        "type_subscription" => strtoupper($tipo_servicio),
                        "email_usuario" => $emailUser,
                        "fecha_y_hora_compra" => strtoupper($fecha_pago_alt),
                        "num_transaccion" => $num_transaccion,
                        "monto_pagado" => $monto_pagado,
                        "fecha_expiracion" => strtoupper($dia_q_caduca_alt),
                        "invitation_email" => serialize($invitation_emails)
                    ), self::$keyApp);


                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Enhorabuena suscripcón premium ha sido agregada correctamente!",
                    "new_date_expire" => $dia_q_caduca
                ];


            } else {
                throw new ExceptionApi(self::ERROR_DATABASE, "Ocurrio un error al insertar la información", 400);
            }

        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Parametros incorrectos", 400);
        }

    }

}