<?php
date_default_timezone_set('America/Guayaquil');
require_once 'ConnectionDB.php';

class User
{
    const TABLE_NAME = "dex_usuario_new";
    const ID_USUARIO = "id_usuario";
    const EMAIL_USUARIO = "email_usuario";
    const CLAVE_USUARIO = "clave_usuario";
    const IPS_VALIDAS = "ips_validas";
    const NOMBRE_USUARIO = "nombre_usuario";
    const APELLIDO_USUARIO = "apellido_usuario";
    const PAIS_USUARIO = "pais_usuario";
    const CIUDAD_USUARIO = "ciudad_usuario";
    const DIRECCION_USUARIO = "direccion_usuario";
    const CELULAR_USUARIO = "celular_usuario";
    const CONVENCIONAL_USUARIO = "convencional_usuario";
    const ESTADO_USUARIO = "estado_usuario";//char
    const FECHA_REGISTRO = "fecha_registro";
    const FECHA_CADUCIDAD_CEPWEB = "fecha_caducidad_cepweb";
    const CANT_LICENCIAS = "cant_licencias";
    const ID_COMO_SE_ENTERO = "id_como_se_entero";
    const ID_VENDEDOR_CEP = "id_vendedor_cep";
    const OBSERVACIONES = "observaciones";
    const SERVICIO_SPEEDY = "servicio_speedy";
    const FECHA_CADUCA_PREMIUM = "fecha_caduca_premium";
    const METODO_DE_PAGO = "metodo_de_pago";

    //campos extras para uso de la app.
    const APP_API_KEY = "app_api_key";
    const SEXO = "sexo";
    const CEDULA_USUARIO = "cedula_usuario";

    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;
    const DEFAULT_ESTADO_USUARIO = "A";
    const INACTIVO_ESTADO_USUARIO = "I";
    private static $encryption_key = '5166546A576E5A72';
    const DEFAULT_SERVICIO_SPEEDY = "GRATUITO";
    const DEFAULT_METODO_DE_PAGO = "NINGUNO";
    private static $PREMIUM_SERVICIO_SPEEDY = "PREMIUM";

    public static function setPostRequest($request)
    {

        if ($request[0] == 'register') {
            return User::registerUser();
        } else if ($request[0] == 'modify') {
            return User::modifyUser();
        } else if ($request[0] == 'change_password') {
            return User::changePassword();
        } else if ($request[0] == 'change_pay_method') {
            return User::changePayMethod();
        } else if ($request[0] == "loginApp") {
            return User::loginApp();
        } else if ($request[0] == "get_data") {
            return User::getDataApp();
        } else if ($request[0] == "all_from_admin") {
            return User::getAllFromAdmin();
        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    public static function setGetRequest($request)
    {
        if ($request[0] == 'all') {

        } else {
            throw new ExceptionApi(self::INCORRECT_URL, "Url mal formada", 400);
        }

    }

    private static function getAllFromAdmin()
    {
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $query = "SELECT * FROM  dex_usuario_new ORDER BY servicio_speedy DESC, fecha_caduca_premium ASC;";
        $prepare_stm = $pdo->prepare($query);
        $rows = null;
        if ($prepare_stm->execute()) {
            while ($row = $prepare_stm->fetch(PDO::FETCH_ASSOC)) {
                $rows[] = $row;
            }

            return [
                "status" => self::SUCCESSFUL_CREATION,
                "data" => $rows
            ];

        } else {
            return null;
        }
    }

    private function loginApp()
    {

        $body = file_get_contents('php://input');
        $UserData = json_decode($body);
        // Validar campos
        self::authorizationFromApp();

        if ($UserData !== NULL) {


            if (ValidComponent::issetField($UserData->email_usuario, 991)
                && ValidComponent::isEmptyField("Email*", $UserData->email_usuario)
                && ValidComponent::issetField($UserData->clave_usuario, 992)
                && ValidComponent::isEmptyField("Clave*", $UserData->clave_usuario)) {

                $query = "SELECT " . self::ID_USUARIO . "," . self::CLAVE_USUARIO . "," . self::ESTADO_USUARIO . " FROM " . self::TABLE_NAME . " WHERE " . self::EMAIL_USUARIO . " = ?";

                try {

                    $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);

                    $prepare_stm->bindParam(1, $UserData->email_usuario);

                    $prepare_stm->execute();

                    if ($prepare_stm) {

                        $resultado = $prepare_stm->fetch();
                        if (isset($resultado[self::ID_USUARIO])) {

                            if (self::validPassword($UserData->clave_usuario, $resultado[self::CLAVE_USUARIO])) {

                                $userBD = self::getDataUserByEmail($UserData->email_usuario);
                                if ($userBD != NULL) {
                                    http_response_code(200);
                                    //verificar si tiene api_key
                                    if ($userBD->app_api_key == null || $userBD->app_api_key == "") {
                                        //update
                                        $userBD->app_api_key = self::generateApiPassword();
                                        self::updateApiKey($userBD->id_usuario, $userBD->app_api_key);
                                    }


                                    //verificar caducidad premium.
                                    $userBD->servicio_speedy = User::verifyPremiumAccount($userBD->fecha_caduca_premium, $userBD->servicio_speedy, $userBD->id_usuario);
                                    $userBD->auth_provider = "NORMAL";
                                    //antes de enviar verificar si la persona ha usado un cupo de suscripción adicional.
                                    return [
                                        "status" => 1,
                                        "message" => "Información encontrada.",
                                        "data" => $userBD
                                    ];
                                } else {
                                    throw new ExceptionApi(self::UNKNOWN_FAULT,
                                        "Ha ocurrido un error");
                                }


                            } else {
                                throw new ExceptionApi(self::FAILED_CREATION, "Usuario y/o clave incorrectos");
                            }

                        } else {
                            throw new ExceptionApi(self::FAILED_CREATION, "No fue posible iniciar sesión no existen los datos.");
                        }


                    } else {
                        throw new ExceptionApi(self::ERROR_DATABASE, "Error en el servidor");
                    }

                } catch (PDOException $e) {
                    throw new ExceptionApi(self::ERROR_DATABASE, $e->getMessage());
                }


            } else {
                throw new ExceptionApi(self::FAILED_CREATION, "Objeto nulo1", 422);
            }


        } else {
            throw new ExceptionApi(self::FAILED_CREATION, "Objeto nulo2", 422);
        }


    }


    /*registro de usuario*/
    private static function registerUser()
    {

        $body = file_get_contents('php://input');
        $user = json_decode($body);
        // Validar campos
        self::authorizationFromApp();
        // Crear usuario
        $result = self::createUser($user);
        // Imprimir respuesta
        switch ($result) {
            case self::SUCCESSFUL_CREATION:
                http_response_code(200);
                $userBD = User::getDataUserByEmail($user->email_usuario);
                $userBD->auth_provider = "NORMAL";
                return [
                    "status" => self::SUCCESSFUL_CREATION,
                    "message" => "¡Registrado con éxito!",
                    "data" => $userBD
                ];
                break;
            case self::FAILED_CREATION:
                throw new ExceptionApi(self::FAILED_CREATION, "Ha ocurrido un error");
                break;
            default:
                throw new ExceptionApi(self::UNKNOWN_FAULT, "Información incompleta.");
                break;
        }
    }


    private static function getDataApp()
    {

        $body = file_get_contents('php://input');
        $UserData = json_decode($body);
        // Validar campos
        $id_user = self::authorizationApi();

        if ($UserData !== null) {

            if (ValidComponent::issetField($UserData->id_usuario, 988)) {

                $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $UserData->id_usuario);
                //$id_usuario_php = $UserData->id_usuario;
                if ($id_user == $id_usuario_php) {
                    $resultado = User::getDataUserByID($id_usuario_php);//aqui modificAR para poder obtener y validar si caduca.
                    $resultado->servicio_speedy = User::verifyPremiumAccount($resultado->fecha_caduca_premium, $resultado->servicio_speedy, $id_usuario_php);
                    http_response_code(200);
                    return [
                        "status" => self::SUCCESSFUL_CREATION,
                        "message" => "¡Consulta con éxito!",
                        "data" => $resultado
                    ];
                } else {
                    throw new ExceptionApi(self::FAILED_CREATION, "No eres el usuario de esta cuenta, no puedes consultar.");
                }
            }


        }
    }

    public static function verifyPremiumAccount($fecha_caduca_premium, $result_servicio, $id_usuario)
    {//$resultado->fecha_caduca_premium, $resultado->servicio_speedy, $id_usuario_php
        $dateExpiracionPremium = new DateTime($fecha_caduca_premium);
        $currentDate = new DateTime('now');

        if ($result_servicio == "") {
            User::updateServicioSpeedy($id_usuario, "GRATUITO");
            return "GRATUITO";
        } else {
            if ($currentDate > $dateExpiracionPremium && $result_servicio == "PREMIUM") {
                //update servicio
                User::updateServicioSpeedy($id_usuario, "GRATUITO");
                return "GRATUITO";
            } else {
                return $result_servicio;
            }
        }
    }


    private static function changePayMethod()
    {

        $body = file_get_contents('php://input');
        $UserData = json_decode($body);
        // Validar campos
        $id_user = self::authorizationApi();

        if ($UserData !== null) {
            if (ValidComponent::issetField($UserData->id_usuario, 988)
                && ValidComponent::issetField($UserData->new_metodo_de_pago, 993)) {
                $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $UserData->id_usuario);
                if ($id_user == $id_usuario_php) {
                    $metodo_de_pago = $UserData->new_metodo_de_pago;
                    $result = self::updateMetodoDePagoSpeedy($id_user, $metodo_de_pago);
                    if ($result) {
                        http_response_code(200);
                        return [
                            "status" => self::SUCCESSFUL_CREATION,
                            "message" => "¡Metodo de pago actualizado!"
                        ];
                    } else {
                        throw new ExceptionApi(self::ERROR_DATABASE, "No se pudo modificar la información.");
                    }
                } else {
                    throw new ExceptionApi(self::FAILED_CREATION, "No eres el usuario de esta cuenta, no puedes modificar.");
                }
            }
        }
    }

    private static function changePassword()
    {

        $body = file_get_contents('php://input');
        $UserData = json_decode($body);
        // Validar campos
        $id_user = self::authorizationApi();

        if ($UserData !== null) {

            if (ValidComponent::issetField($UserData->id_usuario, 988)
                && ValidComponent::issetField($UserData->old_password, 993)
                && ValidComponent::issetField($UserData->new_password, 994)) {

                $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $UserData->id_usuario);
                if ($id_user == $id_usuario_php) {

                    $estadoUsuario = self::getEstadoByID($id_user);

                    /*if ($estadoUsuario == self::DEFAULT_ESTADO_USUARIO) {

                    } else {
                        throw new ExceptionApi(self::FAILED_CREATION, "Usuario inactivo, no se puede modificar.");
                    }*/
                    $old_password = self::getPasswordFromID($id_user);

                    if ($UserData->new_password != $UserData->old_password) {
                        $new_password = self::encryptPassword($UserData->new_password);
                        if (self::validPassword($UserData->old_password, $old_password)) {
                            $query = "UPDATE " . self::TABLE_NAME . " SET " . self::CLAVE_USUARIO . " = ? WHERE " . self::ID_USUARIO . " = ?;";
                            $pdo = ConnectionDB::getInstance()->getDataBase();
                            $prepare_stm = $pdo->prepare($query);
                            $prepare_stm->bindValue(1, $new_password, PDO::PARAM_STR);
                            $prepare_stm->bindValue(2, $id_user, PDO::PARAM_INT);
                            $result = $prepare_stm->execute();

                            if ($result) {
                                http_response_code(200);
                                return [
                                    "status" => self::SUCCESSFUL_CREATION,
                                    "message" => "¡Clave modificada con éxito!"
                                ];
                            } else {
                                throw new ExceptionApi(self::ERROR_DATABASE, "No se pudo modificar la información.");
                            }
                        } else {
                            throw new ExceptionApi(self::ERROR_DATABASE, "La contraseña anterior no es válida.");
                        }
                    } else {
                        throw new ExceptionApi(self::FAILED_CREATION, "La clave nueva no puede ser igual a la anterior.");
                    }



                } else {
                    throw new ExceptionApi(self::FAILED_CREATION, "No eres el usuario de esta cuenta, no puedes modificar.");
                }
            }


        }
    }

    private static function modifyUser()
    {

        $body = file_get_contents('php://input');
        $UserData = json_decode($body);
        // Validar campos
        $id_user = self::authorizationApi();

        if ($UserData !== null) {
            if (ValidComponent::issetField($UserData->id_usuario, 988)
                && ValidComponent::issetField($UserData->nombre_usuario, 989)
                && ValidComponent::isEmptyField("Nombres*", $UserData->nombre_usuario)
                && ValidComponent::issetField($UserData->apellido_usuario, 990)
                && ValidComponent::isEmptyField("Apellidos*", $UserData->apellido_usuario)
                && ValidComponent::issetField($UserData->email_usuario, 991)
                && ValidComponent::isEmptyField("Email*", $UserData->email_usuario)
                && Valid::validEmail($UserData->email_usuario)

                && ValidComponent::issetField($UserData->direccion_usuario, 993)
                && ValidComponent::issetField($UserData->ciudad_usuario, 994)
                && ValidComponent::issetField($UserData->pais_usuario, 995)
                && ValidComponent::issetField($UserData->cedula_usuario, 996)
                && ValidComponent::issetField($UserData->sexo, 997)
                && ValidComponent::issetField($UserData->celular_usuario, 998)) {

                //getByIdUser($keyApi)
                $id_usuario_php = PHP_AES_Cipher::decrypt(self::$encryption_key, $UserData->id_usuario);
                if ($id_user == $id_usuario_php) {
                    $flag = true;
                    $tmpUserCompare = self::getDataUserByEmail($UserData->email_usuario);
                    if (is_object($tmpUserCompare) && $tmpUserCompare->id_usuario != $id_user) {
                        $flag = false;
                    }


                    if ($flag) {

                        $estadoUsuario = self::getEstadoByID($id_user);

                        /*if ($estadoUsuario == self::DEFAULT_ESTADO_USUARIO) {
                        } else {
                            throw new ExceptionApi(self::FAILED_CREATION, "Usuario inactivo, no se puede modificar.");
                        }*/

                        $query = "UPDATE " . self::TABLE_NAME . " SET " . self::EMAIL_USUARIO . " = ?, " . self::NOMBRE_USUARIO . " = ?, 
                        " . self::APELLIDO_USUARIO . " = ?, " . self::DIRECCION_USUARIO . " = ?, " . self::CIUDAD_USUARIO . " = ?, 
                        " . self::PAIS_USUARIO . " = ?, " . self::CEDULA_USUARIO . " = ?, " . self::SEXO . " = ?, 
                        " . self::CELULAR_USUARIO . " = ? WHERE " . self::ID_USUARIO . " = ?;";

                        $pdo = ConnectionDB::getInstance()->getDataBase();
                        $prepare_stm = $pdo->prepare($query);
                        $prepare_stm->bindValue(1, strtolower($UserData->email_usuario), PDO::PARAM_STR);
                        $prepare_stm->bindValue(2, $UserData->nombre_usuario, PDO::PARAM_STR);
                        $prepare_stm->bindValue(3, $UserData->apellido_usuario, PDO::PARAM_STR);
                        $prepare_stm->bindValue(4, $UserData->direccion_usuario, PDO::PARAM_STR);
                        $prepare_stm->bindValue(5, $UserData->ciudad_usuario, PDO::PARAM_STR);
                        $prepare_stm->bindValue(6, $UserData->pais_usuario, PDO::PARAM_STR);
                        $prepare_stm->bindValue(7, $UserData->cedula_usuario, PDO::PARAM_STR);
                        $prepare_stm->bindValue(8, $UserData->sexo, PDO::PARAM_STR);
                        $prepare_stm->bindValue(9, $UserData->celular_usuario, PDO::PARAM_INT);
                        $prepare_stm->bindValue(10, $id_user, PDO::PARAM_INT);
                        $result = $prepare_stm->execute();

                        if ($result) {
                            http_response_code(200);
                            return [
                                "status" => self::SUCCESSFUL_CREATION,
                                "message" => "¡Modificado con éxito!"
                            ];
                        } else {
                            throw new ExceptionApi(self::ERROR_DATABASE, "No se pudo modificar la información.");
                        }

                    } else {
                        throw new ExceptionApi(self::FAILED_CREATION, "Este correo ya existe con otro usuario.");
                    }
                } else {
                    throw new ExceptionApi(self::FAILED_CREATION, "No eres el usuario de esta cuenta, no puedes modificar.");
                }
            }
        }

    }

    private function createUser($UserData)
    {
        if ($UserData !== null) {
            //create var
            if (ValidComponent::issetField($UserData->nombre_usuario, 989)
                && ValidComponent::isEmptyField("Nombres*", $UserData->nombre_usuario)
                && ValidComponent::issetField($UserData->apellido_usuario, 990)
                && ValidComponent::isEmptyField("Apellidos*", $UserData->apellido_usuario)
                && ValidComponent::issetField($UserData->email_usuario, 991)
                && ValidComponent::isEmptyField("Email*", $UserData->email_usuario)
                && Valid::validEmail($UserData->email_usuario)
                && self::notExistEmail($UserData->email_usuario)
                && ValidComponent::issetField($UserData->clave_usuario, 992)
                && ValidComponent::isEmptyField("Clave*", $UserData->clave_usuario)
                && Valid::validLengthPassword($UserData->clave_usuario)
                && ValidComponent::issetField($UserData->direccion_usuario, 993)
                && ValidComponent::issetField($UserData->ciudad_usuario, 994)
                && ValidComponent::issetField($UserData->pais_usuario, 995)
                && ValidComponent::issetField($UserData->cedula_usuario, 996)
                && ValidComponent::issetField($UserData->sexo, 997)
                && ValidComponent::issetField($UserData->celular_usuario, 998)
                && ValidComponent::issetField($UserData->cod_promocional, 999)) {

                //antes de register verificar si el campo cod_promocional esta lleno.
                $pdo = ConnectionDB::getInstance()->getDataBase();
                $email_usuario = $UserData->email_usuario;
                $clave_usuario = self::encryptPassword($UserData->clave_usuario);
                $nombre_usuario = $UserData->nombre_usuario;
                $apellido_usuario = $UserData->apellido_usuario;
                $direccion_usuario = $UserData->direccion_usuario;
                $ciudad_usuario = $UserData->ciudad_usuario;
                $pais_usuario = $UserData->pais_usuario;
                $cedula_usuario = $UserData->cedula_usuario;
                $sexo = $UserData->sexo;
                $celular_usuario = $UserData->celular_usuario;
                $app_api_key = self::generateApiPassword();

                $estado_usuario = self::DEFAULT_ESTADO_USUARIO;
                $cant_licencias = 1;
                $id_como_se_entero = 1;
                $id_vendedor_cep = 1;
                $cod_promocional = $UserData->cod_promocional;
                $flag_promocional = false;
                $temp_duracion_cod_promocional = 0;
                $temp_id_cod_promocional = 0;
                $temp_email_creador = "";
                $objCod_promocional = new Cod_promocional();
                if ($cod_promocional !== "") {
                    //verificar existencia del código.
                    $result = $objCod_promocional->getInfoByCode($cod_promocional, $pdo);
                    if ($result) {
                        if ($result->estado == "INVITACION") {
                            $dateExpiracion = new DateTime($result->fecha_expiracion);
                            $temp_duracion_cod_promocional = $result->duracion;
                            $temp_id_cod_promocional = $result->id_dex_cod_promocional;
                            $temp_email_creador = $result->email_creador;
                            $currentDate = new DateTime('now');
                            if ($currentDate < $dateExpiracion) {
                                if ($result->tipo_promocional == "EMAIL") {
                                    //verificar si el email tiene assoc el codigo.
                                    if (strtolower($result->email_assoc) == strtolower($email_usuario)) {
                                        $flag_promocional = true;
                                    } else {
                                        throw new ExceptionApi(self::FAILED_CREATION, "Código promocional " . $cod_promocional . " pertenece a otro usuario.");
                                    }
                                } else {
                                    $flag_promocional = true;
                                }

                            } else {
                                throw new ExceptionApi(self::FAILED_CREATION, "Código promocional " . $cod_promocional . " expirado, por favor ingrese otro.");
                            }

                        } else {
                            throw new ExceptionApi(self::FAILED_CREATION, "Código promocional " . $cod_promocional . " usado, por favor ingrese otro.");
                        }
                    }
                }

                $query = "INSERT INTO " . self::TABLE_NAME . "(" . self::EMAIL_USUARIO . ", 
                " . self::CLAVE_USUARIO . ", 
                " . self::NOMBRE_USUARIO . ", 
                " . self::APELLIDO_USUARIO . ", 
                " . self::DIRECCION_USUARIO . ", 
                " . self::CIUDAD_USUARIO . ", 
                " . self::PAIS_USUARIO . ", 
                " . self::CEDULA_USUARIO . ", 
                " . self::SEXO . ", 
                " . self::CELULAR_USUARIO . ", 
                " . self::APP_API_KEY . ", 
                " . self::ESTADO_USUARIO . ", 
                " . self::CANT_LICENCIAS . ", 
                " . self::ID_COMO_SE_ENTERO . ", 
                " . self::ID_VENDEDOR_CEP . ", 
                " . self::SERVICIO_SPEEDY . ", 
                " . self::FECHA_REGISTRO . ", 
                " . self::FECHA_CADUCIDAD_CEPWEB . ", 
                " . self::FECHA_CADUCA_PREMIUM . ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,NOW(), NOW() + INTERVAL 15 DAY, NOW())";

                try {
                    $pdo = ConnectionDB::getInstance()->getDataBase();
                    $prepare_stm = $pdo->prepare($query);

                    $prepare_stm->bindValue(1, strtolower($email_usuario), PDO::PARAM_STR);
                    $prepare_stm->bindValue(2, $clave_usuario, PDO::PARAM_STR);
                    $prepare_stm->bindValue(3, $nombre_usuario, PDO::PARAM_STR);
                    $prepare_stm->bindValue(4, $apellido_usuario, PDO::PARAM_STR);
                    $prepare_stm->bindValue(5, $direccion_usuario, PDO::PARAM_STR);
                    $prepare_stm->bindValue(6, $ciudad_usuario, PDO::PARAM_STR);
                    $prepare_stm->bindValue(7, $pais_usuario, PDO::PARAM_STR);
                    $prepare_stm->bindValue(8, $cedula_usuario, PDO::PARAM_STR);
                    $prepare_stm->bindValue(9, $sexo, PDO::PARAM_STR);
                    $prepare_stm->bindValue(10, $celular_usuario, PDO::PARAM_STR);
                    $prepare_stm->bindValue(11, $app_api_key, PDO::PARAM_STR);

                    $prepare_stm->bindValue(12, $estado_usuario, PDO::PARAM_STR);
                    $prepare_stm->bindValue(13, $cant_licencias, PDO::PARAM_INT);
                    $prepare_stm->bindValue(14, $id_como_se_entero, PDO::PARAM_INT);
                    $prepare_stm->bindValue(15, $id_vendedor_cep, PDO::PARAM_INT);
                    $prepare_stm->bindValue(16, self::DEFAULT_SERVICIO_SPEEDY, PDO::PARAM_STR);

                    $result = $prepare_stm->execute();

                    if ($result) {
                        if ($flag_promocional) {
                            $id_usuario_temp = $pdo->lastInsertId();
                            //registro en tabla usuario_cod_pro
                            $objUsuario_cod_pro = new Usuario_cod_pro();
                            $res = $objUsuario_cod_pro->registerUsuarioCodPromocional($pdo, $temp_duracion_cod_promocional, $id_usuario_temp, $temp_id_cod_promocional);
                            if ($res) {
                                //se puede modificar el estado del codigo a usado.
                                $objCod_promocional->modifyEstado($pdo, $temp_id_cod_promocional, "USADO");
                                //modifica la fecha de caducidad agregando la duración del código promocional.
                                self::updateFechaCaducidadPremium($id_usuario_temp, $temp_duracion_cod_promocional);
                                if ($temp_email_creador !== "") {
                                    //crear un cupo al usuario creador o que invita.
                                    $resInsertPromocional = $objCod_promocional->insertCodPromocional($pdo, $temp_email_creador, "EMAIL", "");
                                    if (!$resInsertPromocional) {
                                        return self::FAILED_CREATION;
                                    }
                                }
                            }
                        }
                        return self::SUCCESSFUL_CREATION;
                    } else {
                        return self::FAILED_CREATION;
                    }
                } catch (PDOException $e) {
                    throw new ExceptionApi(self::ERROR_DATABASE, $e->getMessage());
                }


            }

        }


    }

    private static function validKeyApi($keyApi)
    {
        $query = "SELECT COUNT(" . self::ID_USUARIO . ") FROM  " . self::TABLE_NAME . " WHERE " . self::APP_API_KEY . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $keyApi);
        $prepare_stm->execute();
        return $prepare_stm->fetchColumn(0) > 0; // true o false

    }

    private static function getDataUserByEmail($email)
    {
        $query = "SELECT " . self::ID_USUARIO . "," . self::EMAIL_USUARIO . "," . self::NOMBRE_USUARIO . "," . self::APELLIDO_USUARIO . "," . self::DIRECCION_USUARIO . "," . self::CIUDAD_USUARIO . "," . self::PAIS_USUARIO . "," . self::CELULAR_USUARIO . "," . self::CEDULA_USUARIO . "," . self::SEXO . "," . self::APP_API_KEY . "," . self::FECHA_CADUCIDAD_CEPWEB . "," . self::FECHA_CADUCA_PREMIUM . "," . self::ESTADO_USUARIO . "," . self::SERVICIO_SPEEDY . "," . self::METODO_DE_PAGO . " FROM  " . self::TABLE_NAME . " WHERE " . self::EMAIL_USUARIO . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $email);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetchObject();
            return $result;
        } else {
            return null;
        }
    }

    private static function getDataUserByID($id_usuario)
    {
        $query = "SELECT " . self::ID_USUARIO . "," . self::EMAIL_USUARIO . "," . self::NOMBRE_USUARIO . "," . self::APELLIDO_USUARIO . "," . self::DIRECCION_USUARIO . "," . self::CIUDAD_USUARIO . "," . self::PAIS_USUARIO . "," . self::CELULAR_USUARIO . "," . self::CEDULA_USUARIO . "," . self::SEXO . "," . self::APP_API_KEY . "," . self::FECHA_CADUCIDAD_CEPWEB . "," . self::FECHA_CADUCA_PREMIUM . "," . self::ESTADO_USUARIO . "," . self::SERVICIO_SPEEDY . "," . self::METODO_DE_PAGO . " FROM  " . self::TABLE_NAME . " WHERE " . self::ID_USUARIO . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetchObject();
            return $result;
        } else {
            return null;
        }
    }

    private static function getPasswordFromID($id_usuario)
    {
        $query = "SELECT " . self::CLAVE_USUARIO . " FROM  " . self::TABLE_NAME . " WHERE " . self::ID_USUARIO . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetch();
            return $result[self::CLAVE_USUARIO];
        } else {
            return null;
        }
    }

    public static function getEmailFromID($id_usuario)
    {
        $query = "SELECT " . self::EMAIL_USUARIO . " FROM  " . self::TABLE_NAME . " WHERE " . self::ID_USUARIO . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetch();
            return $result[self::EMAIL_USUARIO];
        } else {
            return null;
        }
    }

    public static function getFullNameFromID($id_usuario)
    {
        $query = "SELECT " . self::NOMBRE_USUARIO . ", " . self::APELLIDO_USUARIO . " FROM  " . self::TABLE_NAME . " WHERE " . self::ID_USUARIO . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetch();
            return $result[self::NOMBRE_USUARIO] . " " . $result[self::APELLIDO_USUARIO];
        } else {
            return null;
        }
    }

    private static function getByIdUser($keyApi)
    {
        $query = "SELECT " . self::ID_USUARIO . " FROM  " . self::TABLE_NAME . " WHERE " . self::APP_API_KEY . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $keyApi);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetch();
            return $result[self::ID_USUARIO];
        } else {
            return null;
        }
    }

    public static function getEstadoByID($id_usuario)
    {
        $query = "SELECT " . self::ESTADO_USUARIO . " FROM  " . self::TABLE_NAME . " WHERE " . self::ID_USUARIO . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetch();
            return $result[self::ESTADO_USUARIO];
        } else {
            return null;
        }
    }

    public static function getServicioByID($id_usuario)
    {
        $query = "SELECT " . self::SERVICIO_SPEEDY . " FROM  " . self::TABLE_NAME . " WHERE " . self::ID_USUARIO . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetch();
            return $result[self::SERVICIO_SPEEDY];
        } else {
            return null;
        }
    }

    public static function getFechaCaducidadPremium($id_usuario)
    {
        $query = "SELECT " . self::FECHA_CADUCA_PREMIUM . " FROM  " . self::TABLE_NAME . " WHERE " . self::ID_USUARIO . " = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario, PDO::PARAM_INT);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetch();
            return $result[self::FECHA_CADUCA_PREMIUM];
        } else {
            return null;
        }
    }

    public static function notExistEmail($email)
    {
        $query = "SELECT COUNT(" . self::ID_USUARIO . ") FROM  " . self::TABLE_NAME . " WHERE LOWER(" . self::EMAIL_USUARIO . ") = ?;";
        $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
        $prepare_stm->bindValue(1, strtolower($email));
        $prepare_stm->execute();
        if ($prepare_stm->fetchColumn(0) <= 0) {
            return true;
        } else {
            throw new ExceptionApi(self::ERROR_DATABASE, "Ya existe una cuenta con este email.", 422);
        }
    }


    /* public static function getFechaExpiracionPremium($id_usuario) {
         $query = "SELECT ser_contratado.fecha_expiracion as fecha_premium FROM dex_usuario_new INNER JOIN dex_usu_ser_contratado as ser_contratado ON ser_contratado.id_usuario = dex_usuario_new.id_usuario AND dex_usuario_new.id_usuario = ? ORDER BY ser_contratado.fecha_expiracion DESC LIMIT 1;";
         $prepare_stm = ConnectionDB::getInstance()->getDataBase()->prepare($query);
         $prepare_stm->bindValue(1, $id_usuario, PDO::PARAM_INT);
         $prepare_stm->execute();
         if ($prepare_stm->execute()) {
             $result = $prepare_stm->fetch();
             if ($result) {
                 return $result['fecha_premium'];
             }
         }
         return "0000-00-00 00:00:00";
     }*/

    public static function updateFechaCaducidadPremium($id_usuario, $duracion)
    {

        $servicio_speedy = self::getServicioByID($id_usuario);
        $dateTimeCaducidadActual = new DateTime('now');
        if ($servicio_speedy == self::$PREMIUM_SERVICIO_SPEEDY) {
            //consultar fecha almacenada en el sistema como caducidad.
            $dateTimeCaducidadActual = new DateTime(self::getFechaCaducidadPremium($id_usuario));
        }

        $intervalo = new DateInterval('P' . $duracion . 'D');
        $dateTimeCaducidadActual->add($intervalo);//nueva fecha.

        $query = "UPDATE " . self::TABLE_NAME . " SET " . self::FECHA_CADUCA_PREMIUM . " = ?, " . self::ESTADO_USUARIO . " = ?, " . self::SERVICIO_SPEEDY . " = ? WHERE " . self::ID_USUARIO . " = ?;";
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $dateTimeCaducidadActual->format("Y-m-d H:i:s"), PDO::PARAM_STR);
        $prepare_stm->bindValue(2, self::DEFAULT_ESTADO_USUARIO, PDO::PARAM_STR);
        $prepare_stm->bindValue(3, self::$PREMIUM_SERVICIO_SPEEDY, PDO::PARAM_STR);
        $prepare_stm->bindValue(4, $id_usuario, PDO::PARAM_INT);
        $result = $prepare_stm->execute();
        if ($result) {
            http_response_code(200);
            return self::SUCCESSFUL_CREATION;
        } else {
            return self::FAILED_CREATION;
        }

    }

    public static function newFechaCaducidadPremium($id_usuario, $duracion)
    {

        $servicio_speedy = self::getServicioByID($id_usuario);
        $dateTimeCaducidadActual = new DateTime('now');
        if ($servicio_speedy == self::$PREMIUM_SERVICIO_SPEEDY) {
            //consultar fecha almacenada en el sistema como caducidad.
            $dateTimeCaducidadActual = new DateTime(self::getFechaCaducidadPremium($id_usuario));
        }

        $intervalo = new DateInterval('P' . $duracion . 'D');
        $dateTimeCaducidadActual->add($intervalo);//nueva fecha.

        return $dateTimeCaducidadActual->format("Y-m-d H:i:s");
    }

    public static function newFechaCaducidadPremiumT($id_usuario, $duracion)
    {

        $servicio_speedy = self::getServicioByID($id_usuario);
        $dateTimeCaducidadActual = new DateTime('now');
        if ($servicio_speedy == self::$PREMIUM_SERVICIO_SPEEDY) {
            //consultar fecha almacenada en el sistema como caducidad.
            $dateTimeCaducidadActual = new DateTime(self::getFechaCaducidadPremium($id_usuario));
        }

        $intervalo = new DateInterval('P' . $duracion . 'D');
        $dateTimeCaducidadActual->add($intervalo);//nueva fecha.

        return $dateTimeCaducidadActual->format("m/d/Y H:i:s a");
    }

    public static function updateEstado($id_usuario)
    {


        $query = "UPDATE " . self::TABLE_NAME . " SET " . self::ESTADO_USUARIO . " = ? WHERE " . self::ID_USUARIO . " = ?;";
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, self::INACTIVO_ESTADO_USUARIO, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id_usuario, PDO::PARAM_INT);
        $result = $prepare_stm->execute();
        if ($result) {
            http_response_code(200);
            return self::SUCCESSFUL_CREATION;
        } else {
            return self::FAILED_CREATION;
        }

    }

    public static function updateApiKey($id_usuario, $app_api_key)
    {


        $query = "UPDATE " . self::TABLE_NAME . " SET " . self::APP_API_KEY . " = ? WHERE " . self::ID_USUARIO . " = ?;";
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $app_api_key, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id_usuario, PDO::PARAM_INT);
        $result = $prepare_stm->execute();
        if ($result) {
            http_response_code(200);
            return self::SUCCESSFUL_CREATION;
        } else {
            return self::FAILED_CREATION;
        }

    }

    public static function updateServicioSpeedy($id_usuario, $servicio_speedy)
    {


        $query = "UPDATE " . self::TABLE_NAME . " SET " . self::SERVICIO_SPEEDY . " = ? WHERE " . self::ID_USUARIO . " = ?;";
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $servicio_speedy, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id_usuario, PDO::PARAM_INT);
        $result = $prepare_stm->execute();
        if ($result) {
            http_response_code(200);
            return self::SUCCESSFUL_CREATION;
        } else {
            return self::FAILED_CREATION;
        }

    }

    public static function updateMetodoDePagoSpeedy($id_usuario, $metodo_de_pago)
    {
        $query = "UPDATE " . self::TABLE_NAME . " SET " . self::METODO_DE_PAGO . " = ? WHERE " . self::ID_USUARIO . " = ?;";
        $pdo = ConnectionDB::getInstance()->getDataBase();
        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $metodo_de_pago, PDO::PARAM_STR);
        $prepare_stm->bindValue(2, $id_usuario, PDO::PARAM_INT);
        return $prepare_stm->execute();
    }


    public static function authorizationApi()
    {
        $headers = apache_request_headers();
        if (isset($headers['Authorization'])) {
            $keyApi = $headers["Authorization"];
            if (User::validKeyApi($keyApi)) {
                return User::getByIdUser($keyApi);
            } else {
                throw new ExceptionApi(self::NOT_AUTH_API_KEY, "Clave API no autorizada", 401);
            }
        } else {
            throw new ExceptionApi(
                self::AUS_AUTH_API_KEY,
                "Se Requiere Clave del API para la Autenticación");
        }

    }

    public static function authorizationFromApp()
    {
        $headers = apache_request_headers();
        if (isset($headers['Authorization'])) {
            $keyApi = $headers["Authorization"];
            if ($keyApi == "A80D313B049E3A50E2B4DA77C62B779E0631FC4F8A1B118E99063A7524AB154B") {//private_authorization_key_app
                return User::getByIdUser($keyApi);
            } else {
                throw new ExceptionApi(self::NOT_AUTH_API_KEY, "Clave API no autorizada", 401);
            }
        } else {
            throw new ExceptionApi(
                self::AUS_AUTH_API_KEY,
                "Se Requiere Clave del API para la Autenticación");
        }
    }


    private static function validPassword($contrasenaPlana, $contrasenaHash)
    {
        return crypt($contrasenaPlana, $contrasenaHash) == $contrasenaHash;
    }

    private static function encryptPassword($password)
    {
        $cost = 10;
        $salt = strtr(base64_encode(mcrypt_create_iv(16, MCRYPT_DEV_URANDOM)), '+', '.');
        $salt = sprintf("$2a$%02d$", $cost) . $salt;
        $hash = crypt($password, $salt);

        return $hash;

    }

    private function generateApiPassword()
    {
        return md5(microtime() . rand());
    }


}