<?php

require_once 'ConnectionDB.php';

class Usuario_cod_pro
{

    const TABLE_NAME = "dex_usuario_cod_pro";
    const TABLE_USUARIO = "dex_usuario_new";
    const TABLE_COD_PROMOCIONAL = "dex_cod_promocional";
    const ID_USUARIO_COD_PRO = "id_usuario_cod_pro";
    const ID_USUARIO = "id_usuario";
    const ID_COD_PROMOCIONAL = "id_cod_promocional";
    const CODIGO = "codigo";
    const DURACION_DISMIN = "duracion_dismin";
    const FECHA_EXPIRACION = "fecha_expiracion";
    /*STATUS USER*/
    const SUCCESSFUL_CREATION = 1;
    const FAILED_CREATION = 2;
    const ERROR_DATABASE = 3;
    const AUS_AUTH_API_KEY = 4;//ausencia api
    const NOT_AUTH_API_KEY = 5;//no autorizada
    const INCORRECT_URL = 6;
    const UNKNOWN_FAULT = 7;


    public function verifyUserAndCode($pdo, $codigo)
    {
        $query = "SELECT dex_usuario_new.email_usuario FROM " . self::TABLE_NAME . "
        ," . self::TABLE_USUARIO . "," . self::TABLE_COD_PROMOCIONAL . " WHERE 
        " . self::TABLE_NAME . "." . self::ID_USUARIO . " = " . self::TABLE_USUARIO . "." . self::ID_USUARIO . " AND 
        " . self::TABLE_NAME . "." . self::ID_USUARIO_COD_PRO . " = " . self::TABLE_COD_PROMOCIONAL . "." . self::ID_USUARIO_COD_PRO . " AND 
         " . self::TABLE_COD_PROMOCIONAL . "." . self::CODIGO . " = ?";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $codigo, PDO::PARAM_STR);
        if ($prepare_stm->execute()) {
            $result = $prepare_stm->fetchObject();
            return $result;
        } else {
            return null;
        }

    }

    public function registerUsuarioCodPromocional($pdo, $duracion, $id_usuario, $id_cod_promocional, $fecha_expiracion)
    {

        $query = "INSERT INTO " . self::TABLE_NAME . "(" . self::ID_USUARIO . ", 
                " . self::ID_COD_PROMOCIONAL . ", 
                " . self::DURACION_DISMIN . ", " . self::FECHA_EXPIRACION . ") VALUES (?,?,?,?)";

        $prepare_stm = $pdo->prepare($query);
        $prepare_stm->bindValue(1, $id_usuario, PDO::PARAM_INT);
        $prepare_stm->bindValue(2, $id_cod_promocional, PDO::PARAM_INT);
        $prepare_stm->bindValue(3, $duracion, PDO::PARAM_INT);
        $prepare_stm->bindValue(4, $fecha_expiracion, PDO::PARAM_STR);

        return $prepare_stm->execute();

    }

}